commit 01cbd47b19a57a70924c4cc4ecad52319a446b29
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Mon Jan 31 14:47:37 2011 +0000

    Release Clutter 1.6.0

 configure.ac | 4 ++--
 1 file changed, 2 insertions(+), 2 deletions(-)

commit c060f086c5af655a52d7b2651abd76eb10394534
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Mon Jan 31 13:59:14 2011 +0000

    docs: Update the NEWS file

 NEWS | 4 +++-
 1 file changed, 3 insertions(+), 1 deletion(-)

commit bb44d51fc934e2360eb8d529be7cdcec438d32b5
Merge: 5859efa34 6680cebfe
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Mon Jan 31 13:58:12 2011 +0000

    Merge remote branch 'elliot/cookbook-actors-composite'
    
    * elliot/cookbook-actors-composite:
      docs: Add reference to useful GObject tutorial
      docs: Explain why destroy() is implemented
      docs: Implement destroy() rather than dispose()
      docs: Don't use clutter_stage_get_default()
      docs: Change text on button
      docs: Add a note about other state variables
      docs: Complete composite actor recipe
      docs: Change order of functions in example to match docs
      docs: Add more comments on how allocate() works
      docs: Include code examples in the recipe
      docs: Explain enums for properties and signals
      docs: Don't set explicit size on button
      docs: Add example of preferred_height() and preferred_width()
      docs: Add recipe for creating a custom ClutterActor with composition
      docs: Add more comments on code example for composite actor
      docs: Improve example code formatting
      docs: Add some gtk-doc annotations to example
      docs: Add custom ClutterActor example which uses composition

commit 5859efa34ff530a9452877a46cc120ca1d36a8e1
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Mon Jan 31 13:50:37 2011 +0000

    docs: Update NEWS file

 NEWS | 11 ++++++++++-
 1 file changed, 10 insertions(+), 1 deletion(-)

commit 2c1f8c9ad367035f7fd0d5177c60816440d916b2
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Fri Jan 28 14:53:08 2011 +0000

    osx: Add devices to event translation code
    
    Use a DeviceManager sub-class similar to the Win32 backend one, which
    creates two InputDevices: a core pointer and a core keyboard.
    
    The event translation code then uses these two devices to fill out the
    .device field of the events.
    
    Throw in enter/leave tracking, given that we need to update the device's
    state.
    
    http://bugzilla.clutter-project.org/show_bug.cgi?id=2490

 clutter/osx/clutter-backend-osx.c        |  45 +++++++++++++++++++++++++++++++++++++--------
 clutter/osx/clutter-device-manager-osx.c | 180 ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
 clutter/osx/clutter-device-manager-osx.h |  58 ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
 clutter/osx/clutter-event-osx.c          |  83 ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++-------------------
 clutter/osx/clutter-stage-osx.c          |   7 +++++--
 clutter/osx/clutter-stage-osx.h          |  12 ++++++------
 6 files changed, 350 insertions(+), 35 deletions(-)

commit 634e4ffd1a93d62c3875e02f5ba69085fa0b4bcf
Author: Viatcheslav Gachkaylo <vgachkaylo@crystalnix.com>
Date:   Fri Jan 28 12:56:57 2011 +0000

    osx: Improve the event loop
    
    Implementation of event loop which works with GLib events, native OS X
    events and Clutter events.
    
    The event loop source code comes from the equivalent code in the Quartz
    GDK backend from GTK+ 2.22.1, which is LGPL v2.1+ and thus compatible
    with Clutter's licensing terms.
    
    The code has been tested with libsoup, which did not work before together
    with Clutter.
    
    Signed-off-by: Emmanuele Bassi <ebassi@linux.intel.com>
    
    http://bugzilla.clutter-project.org/show_bug.cgi?id=2490

 clutter/Makefile.am                  |    6 +-
 clutter/clutter-debug.h              |    3 +-
 clutter/osx/clutter-event-loop-osx.c | 1051 +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
 clutter/osx/clutter-event-loop-osx.h |   32 ++++++
 clutter/osx/clutter-event-osx.c      |  223 ++++++++++++++++-------------------------
 clutter/osx/clutter-stage-osx.h      |    3 +
 6 files changed, 1176 insertions(+), 142 deletions(-)

commit 6680cebfe1f0ef697e16f6db26d1e7fb70d5e459
Author: Elliot Smith <elliot.smith@intel.com>
Date:   Mon Jan 31 13:40:10 2011 +0000

    docs: Add reference to useful GObject tutorial
    
    Add a reference to a GObject tutorial which
    is a good introduction to the various macros etc.
    and what they're for.

 doc/cookbook/actors.xml | 4 +++-
 1 file changed, 3 insertions(+), 1 deletion(-)

commit 885664f725aa3704c46db62e7b1fa951819fc22c
Author: Elliot Smith <elliot.smith@intel.com>
Date:   Mon Jan 31 13:39:11 2011 +0000

    docs: Explain why destroy() is implemented
    
    As destroy() is Clutter-specific and not generic
    GObject code, explain why we implement it
    (rather than dispose()).

 doc/cookbook/actors.xml | 25 +++++++++++++++++++++++++
 1 file changed, 25 insertions(+)

commit 1558975bc38c87690f26bc54849459c4db581371
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Mon Jan 31 13:37:32 2011 +0000

    docs: Fix documentation for clutter_actor_pop_internal()
    
    http://bugzilla.clutter-project.org/show_bug.cgi?id=2534

 clutter/clutter-actor.c | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit e69d60e8b64bbe0811479dac96aee6009560be4e
Author: Elliot Smith <elliot.smith@intel.com>
Date:   Mon Jan 31 13:36:37 2011 +0000

    docs: Implement destroy() rather than dispose()
    
    Remove the dispose() implementation and replace
    with destroy().
    
    This should be promoted as the standard approach
    for implementing a composite actor, as it emits a
    signal when instances of the actor subclass are destroyed.

 doc/cookbook/examples/cb-button.c | 61 +++++++++++++++++++++++++++++++------------------------------
 1 file changed, 31 insertions(+), 30 deletions(-)

commit 9753cd4a59f3849090bf8cee247fafd806729826
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Mon Jan 31 13:04:49 2011 +0000

    docs: Update Cogl release notes for 1.6

 README | 23 +++++++++++++++++++++++
 1 file changed, 23 insertions(+)

commit f954b8e1bb309d4f9487edb558f4280c772cffb5
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Mon Jan 31 13:04:35 2011 +0000

    Update the NEWS file

 NEWS | 35 +++++++++++++++++++++++++++++++++++
 1 file changed, 35 insertions(+)

commit ef36d7cbccbd9225f2a16328522c1cbf3d0befd0
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Mon Jan 31 12:51:14 2011 +0000

    docs: Update the documentation for clutter_actor_unparent()
    
    Make sure that we document the semantics of unparent() and who should
    call it.

 clutter/clutter-actor.c | 8 +++++---
 1 file changed, 5 insertions(+), 3 deletions(-)

commit e32253508de412c3d91c55e73e099ddcc38e1082
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Mon Jan 31 12:50:25 2011 +0000

    docs: Update documentation for ::destroy
    
    The ::destroy signal is meant to be used to break reference cycles on
    third party code. The documentation should really make it clear.

 clutter/clutter-actor.c | 19 +++++++++++++++----
 1 file changed, 15 insertions(+), 4 deletions(-)

commit e0580127f8f3510c2a8b4d2906c66835ac7bc5a5
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Mon Jan 31 12:28:03 2011 +0000

    docs: Update release notes for 1.6

 README | 90 +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++-----------------------
 1 file changed, 67 insertions(+), 23 deletions(-)

commit f63158c2a2c27e7d4a264caf994f799a38fb6398
Author: Elliot Smith <elliot.smith@intel.com>
Date:   Mon Jan 31 12:18:58 2011 +0000

    docs: Don't use clutter_stage_get_default()
    
    clutter_stage_get_new() is the recommended way to
    get a stage instance, so use that instead.

 doc/cookbook/examples/actors-composite-main.c | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 3f64137a7937498ea4982edf9c1fb133fe9321e4
Author: Elliot Smith <elliot.smith@intel.com>
Date:   Mon Jan 31 11:06:01 2011 +0000

    docs: Change text on button
    
    Modify the text shown on the button to "hello / world"
    rather than "winkle / pickers". Slightly more
    sensible.

 doc/cookbook/examples/actors-composite-main.c | 8 ++++----
 1 file changed, 4 insertions(+), 4 deletions(-)

commit 5530c5e2ec9605722e7f65b60b73e8fe396e6c39
Author: Elliot Smith <elliot.smith@intel.com>
Date:   Mon Jan 31 11:05:27 2011 +0000

    docs: Add a note about other state variables
    
    Explain that the private structure would be the
    place to store other state variables for the instance.

 doc/cookbook/examples/cb-button.c | 4 ++++
 1 file changed, 4 insertions(+)

commit 08f5dc08d0e11e2f03b3a9c8889222a584cbe0e7
Author: Elliot Smith <elliot.smith@intel.com>
Date:   Mon Jan 31 10:53:52 2011 +0000

    docs: Complete composite actor recipe
    
    Add some extra detail to the Discussion section of the
    composite actor recipe, concentrating on the pros and
    cons of this approach.
    
    Also explain more about the Clutter parts of the implementation.
    
    Also general tidy up of language and style.

 doc/cookbook/actors.xml | 220 ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++-----------------------------------------------
 1 file changed, 170 insertions(+), 50 deletions(-)

commit 238fd52c4b0660ac61b3ae125f3eef8f71b0f6b0
Author: Elliot Smith <elliot.smith@intel.com>
Date:   Fri Jan 28 17:09:24 2011 +0000

    docs: Change order of functions in example to match docs
    
    Moved the functions around in the C code file, to match
    the order Clutter uses them, and the order they are explained
    in the recipe.

 doc/cookbook/examples/cb-button.c | 99 ++++++++++++++++++++++++++++++++++++++++++++-------------------------------------------------------
 1 file changed, 44 insertions(+), 55 deletions(-)

commit 6934b3645164b5e2a4d4c3da5ed99fe93bb9a95d
Author: Elliot Smith <elliot.smith@intel.com>
Date:   Fri Jan 28 16:43:22 2011 +0000

    docs: Add more comments on how allocate() works
    
    Add some extra description to the allocate() function,
    explaining how the allocation has to be adjusted to
    coordinates relative to the actor as a whole, before
    applying to the single child actor it is composed from.

 doc/cookbook/examples/cb-button.c | 9 ++++++++-
 1 file changed, 8 insertions(+), 1 deletion(-)

commit 00deb59a9daa45558753810fcc18c738f61b0a6e
Author: Elliot Smith <elliot.smith@intel.com>
Date:   Fri Jan 28 11:49:08 2011 +0000

    docs: Include code examples in the recipe
    
    Include all the code examples inline as part of the recipe.
    
    Remove sections around each code example, as these are
    unnecessary; leave full discussion for the Discussion section
    instead of trying to cram it in around the code example.

 doc/cookbook/actors.xml | 103 ++++++++++++++++++++++++++++++++++---------------------------------------------------------------------
 1 file changed, 34 insertions(+), 69 deletions(-)

commit 5f676ce3253f4e6f5ac07a1c1099d17e8384d5ee
Author: Elliot Smith <elliot.smith@intel.com>
Date:   Fri Jan 28 11:39:26 2011 +0000

    docs: Explain enums for properties and signals
    
    Add some more explanatory comments about the PROP_ and
    signals enums.

 doc/cookbook/examples/cb-button.c | 18 ++++++++++++------
 1 file changed, 12 insertions(+), 6 deletions(-)

commit 18b90f100c259db2e5ef19874277b3d5d50791f0
Author: Elliot Smith <elliot.smith@intel.com>
Date:   Fri Jan 28 11:36:20 2011 +0000

    docs: Don't set explicit size on button
    
    Rather than set a size on the CbButton instance, let it
    size itself automatically, based on the size requisition
    functions.

 doc/cookbook/examples/actors-composite-main.c | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 951f13bb8dc2ead8fe3fd3a6f2fede2618c57a19
Author: Elliot Smith <elliot.smith@intel.com>
Date:   Fri Jan 28 11:35:14 2011 +0000

    docs: Add example of preferred_height() and preferred_width()
    
    As most actor subclasses will probably want to implement
    size requisition, give a simple example of how to do this
    on the basis of the composed actor's size, plus some padding.

 doc/cookbook/examples/cb-button.c | 67 ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++---
 1 file changed, 64 insertions(+), 3 deletions(-)

commit 2adc224f0e701648ff0f08ed80317f4b3d4109df
Author: Elliot Smith <elliot.smith@intel.com>
Date:   Wed Jan 26 11:22:07 2011 +0000

    docs: Add recipe for creating a custom ClutterActor with composition

 doc/cookbook/actors.xml | 190 +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++-
 1 file changed, 189 insertions(+), 1 deletion(-)

commit 7059be499ab8c31bcc9825f823587d05410f186a
Author: Elliot Smith <elliot.smith@intel.com>
Date:   Fri Jan 28 11:13:47 2011 +0000

    docs: Add more comments on code example for composite actor
    
    Add more comments about the specific purpose of functions
    and variables in the composite actor example, particularly
    around GObject implementation.

 doc/cookbook/examples/cb-button.c | 69 +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++--------
 doc/cookbook/examples/cb-button.h | 11 +++++++++++
 2 files changed, 72 insertions(+), 8 deletions(-)

commit b3954878c2827e78c0d800a038d6ae5cb515a136
Author: Elliot Smith <elliot.smith@intel.com>
Date:   Wed Jan 26 11:18:23 2011 +0000

    docs: Improve example code formatting
    
    Improve code formatting to adhere to Clutter uncrustify rules.

 doc/cookbook/examples/cb-button.c | 16 +++++++---------
 doc/cookbook/examples/cb-button.h | 29 +++++++++++++++--------------
 2 files changed, 22 insertions(+), 23 deletions(-)

commit 7b9eaeeadbf6ff10b4e467d13a873685a613ba37
Author: Elliot Smith <elliot.smith@intel.com>
Date:   Tue Jan 25 11:36:13 2011 +0000

    docs: Add some gtk-doc annotations to example
    
    As this is a full GObject class implementation, add some
    gtk-doc annotations to demonstrate how how custom actor subclasses
    should be documented.

 doc/cookbook/examples/cb-button.c | 65 +++++++++++++++++++++++++++++++++++++++++++++++++++++++----------
 1 file changed, 55 insertions(+), 10 deletions(-)

commit 8a5967f0cc4ca2ce2b4e8869f4a0ec3bdee07912
Author: Elliot Smith <elliot.smith@intel.com>
Date:   Fri Jan 21 16:43:03 2011 +0000

    docs: Add custom ClutterActor example which uses composition

 doc/cookbook/examples/Makefile.am             |   2 ++
 doc/cookbook/examples/actors-composite-main.c |  79 +++++++++++++++++++++++++++++++++++++++++++++++++++
 doc/cookbook/examples/cb-button.c             | 287 +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
 doc/cookbook/examples/cb-button.h             |  72 +++++++++++++++++++++++++++++++++++++++++++++++
 4 files changed, 440 insertions(+)

commit b820e3940681e4a08ec4985bb13c7f53faf657d4
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Sun Jan 30 23:00:00 2011 +0000

    text: Bind BackSpace + Shift as BackSpace
    
    Follow this old GTK+ bug:
    
      https://bugzilla.gnome.org/show_bug.cgi?id=80302
    
    and ignore the Shift mask.

 clutter/clutter-text.c | 4 ++++
 1 file changed, 4 insertions(+)

commit 9be4cfe8a9eef6a7a15c7100731a199f9348e73b
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Fri Jan 28 18:05:06 2011 +0000

    x11/stage: Use a global Window ↔ Stage relationship
    
    Since we need to find the stage from the X11 Window, it's better to use
    a static hashmap that gets updated every time the ClutterStageX11:xwin
    member is changed, instead of iterating over every stage handled by the
    global ClutterStageManager singleton.

 clutter/glx/clutter-backend-glx.c |  7 +++++--
 clutter/x11/clutter-stage-x11.c   | 49 ++++++++++++++++++++++++++++++++-----------------
 2 files changed, 37 insertions(+), 19 deletions(-)

commit f4508be4ab18f741bea12ea993c635fa9d632de2
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Fri Jan 28 17:25:43 2011 +0000

    win32: Small clean ups in the event code
    
    Use clutter_event_set_device() instead of setting the device field.
    
    Also, use G_N_ELEMENTS() to determine the size of the key symbols
    mapping array.

 clutter/win32/clutter-event-win32.c | 31 ++++++++++++++++++++-----------
 1 file changed, 20 insertions(+), 11 deletions(-)

commit 82d1e5a6ee081cf462999ea04fbd51cdb91f70c9
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Thu Jan 27 17:26:16 2011 +0000

    Clean up crossing event synthesis code
    
    Clutter should just require that the windowing system used by a backend
    adds a device to the stage when the device enters, and removes it from
    the stage when the device leaves; with this information, we can
    synthesize every crossing event and update the device state without
    other intervention from the backend-specific code.
    
    The generation of additional crossing events for actors that are
    covering the stage at the coordinates of the crossing event should be
    delegated to the event processing code.
    
    The x11 and win32 backends need to be modified to relay the enter and
    leave events from the windowing system.

 clutter/clutter-device-manager-private.h      |   6 ++++--
 clutter/clutter-device-manager.c              |   2 +-
 clutter/clutter-event.c                       |   1 +
 clutter/clutter-input-device.c                | 152 ++++++++++++++++++++++++++++++++++++++++++++++++++++++--------------------------------------------------------------------------------------------------
 clutter/clutter-main.c                        |  90 ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++----------------------
 clutter/clutter-stage-private.h               |   8 ++++++++
 clutter/clutter-stage.c                       |  48 +++++++++++++++++++++++++++++++++++++++++++++++-
 clutter/win32/clutter-event-win32.c           |  19 ++++++++++++++++---
 clutter/x11/clutter-device-manager-core-x11.c |  45 +++++++++++++++++++++++++--------------------
 clutter/x11/clutter-device-manager-xi2.c      |  32 ++++++++++++++++++--------------
 10 files changed, 242 insertions(+), 161 deletions(-)

commit b3784bd2b4c9aeac809cca70681bc248123133f8
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Thu Jan 27 17:21:08 2011 +0000

    event: Add a setter for the device field
    
    When synthesizing events coming from input devices it should be
    possible to just call a setter function, to avoid a huge switch
    on the type of the event.
    
    Clutter should also store the device pointer inside the private
    data, for faster access of the pointer in allocated events.
    
    Finally, the get_device_id() and get_device_type() accessors should
    just be wrappers around clutter_event_get_device(), to reduce the
    amount of code duplication.

 clutter/clutter-event.c                    | 98 ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++--------------------------------------
 clutter/clutter-event.h                    |  3 +++
 doc/reference/clutter/clutter-sections.txt |  1 +
 3 files changed, 64 insertions(+), 38 deletions(-)

commit 3502f326b21856ed7720c8541aa4eb3990517a6f
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Wed Jan 26 12:44:03 2011 +0000

    x11/stage: Remove redundant line location
    
    The CLUTTER_NOTE() macro already adds the line location; adding another
    will just clutter up the log.

 clutter/x11/clutter-stage-x11.c | 3 +--
 1 file changed, 1 insertion(+), 2 deletions(-)

commit acf51259d2057b412d1d32fa8246fd14c9ddb66f
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Wed Jan 26 11:58:08 2011 +0000

    x11: Store a back pointer to the backend in the stage
    
    Since we access it in order to get the X11 Display pointer, it makes
    sense to have the ClutterBackendX11 already available inside the
    ClutterStageX11 structure, and avoid the pattern:
    
      ClutterBackend *backend = clutter_get_default_backend ();
      ClutterBackendX11 *backend_x11 = CLUTTER_BACKEND_X11 (backend);
    
    which costs us a function call, a type cast and an unused variable.

 clutter/egl/clutter-backend-egl.c |   1 +
 clutter/glx/clutter-backend-glx.c |   1 +
 clutter/x11/clutter-stage-x11.c   | 129 +++++++++++++++++++++++++++++++++++++--------------------------------------------------------------------------------------------
 clutter/x11/clutter-stage-x11.h   |   5 ++---
 4 files changed, 41 insertions(+), 95 deletions(-)

commit 1d7e2233130b3041cc204fed326087c3a2bc9867
Author: Neil Roberts <neil@linux.intel.com>
Date:   Fri Jan 28 18:11:38 2011 +0000

    test-path: Fix the test when running against latest Cairo versions
    
    Cairo has recently changed so that it no longer adds a final move-to
    command when the path ends with a close. This patch makes the test
    check the run-time version number of Cairo to avoid duplicating this
    behaviour when testing the conversion to and from a Cairo path.

 tests/conform/test-path.c | 18 ++++++++++++------
 1 file changed, 12 insertions(+), 6 deletions(-)

commit e7519a149beb78b92ab8e5b2d315fbab3102dbc2
Author: Neil Roberts <neil@linux.intel.com>
Date:   Tue Jan 25 15:53:35 2011 +0000

    clutter-stage-x11: Don't ensure the viewport when the window moves
    
    When we receive a ConfigureNotify event that doesn't affect the size
    of the window (only the position) then we were still calling
    clutter_stage_ensure_viewport which ends up queueing a full stage
    redraw. This patch makes it so that it only ensures the viewport when
    the size changes as it already did for avoiding queueing a relayout.
    
    It now also avoids setting the clipped redraws cool off period when
    the window only moves under the assumption that it's only necessary
    for size changes.

 clutter/x11/clutter-stage-x11.c | 134 +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++-----------------------------------------------------------------
 1 file changed, 69 insertions(+), 65 deletions(-)

commit dc6f6d6445a1fb9090ce63947218578b969c8718
Author: Rob Bradford <rob@linux.intel.com>
Date:   Mon Jan 24 18:41:49 2011 +0000

    animator: Only free the animator key when we've finished with it
    
    Fixes: http://bugzilla.clutter-project.org/show_bug.cgi?id=2530

 clutter/clutter-animator.c | 3 ++-
 1 file changed, 2 insertions(+), 1 deletion(-)

commit 5593792a40850b6a8f96afa91745115191a45c67
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Wed Jan 26 10:32:42 2011 +0000

    Include stdint.h when using uint32_t
    
    Since the XI2 device manager code is going to be compiled only on
    POSIX compliant systems, we can safely assume the presence of stdint.h
    and include it unconditionally.

 clutter/x11/clutter-device-manager-xi2.c | 8 +++++---
 1 file changed, 5 insertions(+), 3 deletions(-)

commit 5329c986947d08fd724585d8eac61f8e0b0553b5
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Tue Jan 25 11:10:29 2011 +0000

    bind-constraint: Add BIND_POSITION and BIND_SIZE
    
    CLUTTER_BIND_POSITION and CLUTTER_BIND_SIZE are two convenience
    enumeration values for binding x and y, and width and height
    respectively, using a single ClutterBindConstraint.

 clutter/clutter-bind-constraint.c    | 12 ++++++++++++
 clutter/clutter-bind-constraint.h    |  8 +++++++-
 tests/interactive/test-constraints.c |  4 +++-
 tests/interactive/test-flow-layout.c |  5 +----
 4 files changed, 23 insertions(+), 6 deletions(-)

commit 4f53653bf9f2d4ea30ee77e686b4799d8e356c99
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Tue Jan 25 11:00:20 2011 +0000

    x11: Remove more private symbols
    
    Some private functions escaped my wrath in commit
    a277b4091a3fa09a39cf001809c3048eb27f3952.
    
    Thanks to: Emilio Pozuelo Monfort on #clutter

 clutter/x11/clutter-backend-x11.c             | 4 ++--
 clutter/x11/clutter-device-manager-core-x11.c | 2 ++
 clutter/x11/clutter-device-manager-core-x11.h | 4 ++--
 3 files changed, 6 insertions(+), 4 deletions(-)

commit 32486fe995911256a76673bf62609312893281be
Author: Robert Bragg <robert@linux.intel.com>
Date:   Mon Jan 24 18:42:28 2011 +0000

    pipeline: fix for _init_multi_property_sparse_state
    
    When copying COMBINE state in
    _cogl_pipeline_layer_init_multi_property_sparse_state we would read some
    state from the destination layer (invalid data potentially), then
    redundantly set the value back on the destination. This was picked up by
    valgrind, and the code is now more careful about how it references the
    src layer vs the destination layer.

 clutter/cogl/cogl/cogl-pipeline.c | 27 ++++++++++++++-------------
 1 file changed, 14 insertions(+), 13 deletions(-)

commit bca39776d3080c180cdcf6698a54ee2c25bb5383
Author: Robert Bragg <robert@linux.intel.com>
Date:   Fri Jan 21 19:05:23 2011 +0000

    framebuffer: flush journal when switching framebuffers
    
    There is currently a problem with per-framebuffer journals in that it's
    possible to create a framebuffer from a texture which then gets rendered
    too but the framebuffer (and corresponding journal) can be freed before
    the texture gets used to draw with.
    
    Conceptually we want to make sure when freeing a framebuffer that - if
    it is associated with a texture - we flush the journal as the last thing
    before really freeing the framebuffer's meta data. Technically though
    this is awkward to implement since the obvious mechanism for us to be
    notified about the framebuffer's destruction (by setting some user data
    internally with a callback) notifies when the framebuffer has a
    ref-count of 0. This means we'd have to be careful what we do with the
    framebuffer to consider e.g. recursive destruction; anything that would
    set more user data on the framebuffer while it is being destroyed and
    ensuring nothing else gets notified of the framebuffer's destruction
    before the journal has been flushed.
    
    For simplicity, for now, this patch provides another solution which is
    to flush framebuffer journals whenever we switch away from a given
    framebuffer via cogl_set_framebuffer or cogl_push/pop_framebuffer. The
    disadvantage of this approach is that we can't batch all the geometry of
    a scene that involves intermediate renders to offscreen framebufers.
    Clutter is doing this more and more with applications that use the
    ClutterEffect APIs so this is a shame. Hopefully this will only be a
    stop-gap solution while we consider how to reliably support journal
    logging across framebuffer changes.

 clutter/cogl/cogl/cogl-framebuffer.c | 26 ++++++++++++++++++++++----
 1 file changed, 22 insertions(+), 4 deletions(-)

commit 4609770bb9faa4dc74ddd0f25e099ff46b91e258
Author: Neil Roberts <neil@linux.intel.com>
Date:   Mon Jan 24 17:32:06 2011 +0000

    cogl-clip-stack: Fix flushing multiple stencil rectangles
    
    When flushing a clip stack that contains more than one rectangle which
    needs to use the stencil buffer the code takes a different path so
    that it can combine the new rectangle with the existing contents of
    the stencil buffer. However it was not correctly flushing the
    modelview and projection matrices so that rectangle would be in the
    wrong place.

 clutter/cogl/cogl/cogl-clip-stack.c | 16 ++++++++--------
 1 file changed, 8 insertions(+), 8 deletions(-)

commit 6102f802449d22d543621532b543d6879fdb1925
Author: Neil Roberts <neil@linux.intel.com>
Date:   Mon Jan 24 17:17:16 2011 +0000

    test-clip: Replace the ellipse with a rotated rectangle
    
    With test-clip it's possible to draw three different shapes depending
    on what mouse button is used: a rectangle, an ellipse or a path
    containing multiple shapes. However the ellipse is also a path so it
    doesn't really test anything extra from the third option. This
    replaces the ellipse with a rectangle that is first rotated by the
    modelview matrix. The rotated matrix won't be able to use the scissor
    so it can be used to test stencil and clip plane clipping.

 tests/interactive/test-clip.c | 41 ++++++++++++++++++++++++++++++++++-------
 1 file changed, 34 insertions(+), 7 deletions(-)

commit 5137d0a23f19ce461f178596b687479bd62d8522
Author: Neil Roberts <neil@linux.intel.com>
Date:   Mon Jan 24 16:36:56 2011 +0000

    cogl-debug: Add a debug option for tracing clipping
    
    This adds a COGL_DEBUG=clipping option that reports how the clip is
    being flushed. This is needed to determine whether the scissor,
    stencil clip planes or software clipping is being used.

 clutter/cogl/cogl/cogl-clip-stack.c    | 12 ++++++++++++
 clutter/cogl/cogl/cogl-debug-options.h |  5 +++++
 clutter/cogl/cogl/cogl-debug.c         |  3 ++-
 clutter/cogl/cogl/cogl-debug.h         |  1 +
 clutter/cogl/cogl/cogl-journal.c       |  2 ++
 5 files changed, 22 insertions(+), 1 deletion(-)

commit 35a2d79e462c2d27e462f0e614c475cce17b883b
Author: Neil Roberts <neil@linux.intel.com>
Date:   Mon Jan 24 14:28:00 2011 +0000

    cogl-debug: Split the flags to support more than 32
    
    The CoglDebugFlags are now stored in an array of unsigned ints rather
    than a single variable. The flags are accessed using macros instead of
    directly peeking at the cogl_debug_flags variable. The index values
    are stored in the enum rather than the actual mask values so that the
    enum doesn't need to be more than 32 bits wide. The hope is that the
    code to determine the index into the array can be optimized out by the
    compiler so it should have exactly the same performance as the old
    code.

 clutter/cogl/cogl/cogl-atlas-texture.c          |   2 +-
 clutter/cogl/cogl/cogl-attribute.c              |   8 ++++----
 clutter/cogl/cogl/cogl-blend-string.c           |  14 +++++++-------
 clutter/cogl/cogl/cogl-context.c                |  10 +++++-----
 clutter/cogl/cogl/cogl-debug.c                  |  85 ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++-------------------
 clutter/cogl/cogl/cogl-debug.h                  | 105 ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++-----------------------------------
 clutter/cogl/cogl/cogl-framebuffer.c            |   4 ++--
 clutter/cogl/cogl/cogl-journal.c                |  38 +++++++++++++++++++-------------------
 clutter/cogl/cogl/cogl-matrix-private.h         |   2 +-
 clutter/cogl/cogl/cogl-pipeline-fragend-arbfp.c |   6 +++---
 clutter/cogl/cogl/cogl-pipeline-fragend-fixed.c |   6 +++---
 clutter/cogl/cogl/cogl-pipeline-vertend-fixed.c |   2 +-
 clutter/cogl/cogl/cogl-pipeline.c               |   2 +-
 clutter/cogl/cogl/cogl-profile.c                |  10 ++++------
 clutter/cogl/cogl/cogl-rectangle-map.c          |   4 ++--
 clutter/cogl/cogl/cogl-shader.c                 |   4 ++--
 16 files changed, 191 insertions(+), 111 deletions(-)

commit 67fdb5c9f8494117e3d763693041be3ace8168f4
Author: Neil Roberts <neil@linux.intel.com>
Date:   Fri Jan 14 11:11:44 2011 +0000

    cogl-pipeline: Flush the lighting params in common code not vertend
    
    The lighting parameters such as the diffuse and ambient colors were
    previously only flushed in the fixed vertend. This meant that if a
    vertex shader was used then they would not be set. The lighting
    parameters are uniforms which are just as useful in a fragment shader
    so it doesn't really make sense to set them in the vertend. They are
    now flushed in the common cogl-pipeline-opengl code but the code is
    #ifdef'd for GLES2 because they need to be part of the progend in that
    case.

 clutter/cogl/cogl/cogl-pipeline-opengl.c        | 25 ++++++++++++++++++++++++-
 clutter/cogl/cogl/cogl-pipeline-vertend-fixed.c | 19 -------------------
 2 files changed, 24 insertions(+), 20 deletions(-)

commit e778018d0d3247a64a7de64f0937a1335a22b56e
Author: Neil Roberts <neil@linux.intel.com>
Date:   Thu Jan 13 18:24:22 2011 +0000

    cogl-pipeline-progend-glsl: Generalize updating GLES2 uniforms
    
    The uniforms for the alpha test reference value and point size on
    GLES2 are updating using similar code. This generalizes the code so
    that there is a static array of predefined builtin uniforms which
    contains the uniform name, a pointer to a function to get the value
    from the pipeline, a pointer to a function to update the uniform and a
    flag representing which CoglPipelineState change affects the
    uniform. The uniforms are then updated in a loop. This should simplify
    adding more builtin uniforms.

 clutter/cogl/cogl/cogl-pipeline-progend-glsl.c | 134 +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++---------------------------------------------------------
 1 file changed, 77 insertions(+), 57 deletions(-)

commit 9ff04e8a998af90891996fe8c2a4439e5736e4f4
Author: Neil Roberts <neil@linux.intel.com>
Date:   Wed Jan 12 13:47:55 2011 +0000

    cogl-shader-boilerplate: Move the uniforms to the common code
    
    The builtin uniforms are accessible from either the vertex shader or
    the fragment shader so we should define them in the common
    section. This doesn't really matter for the current list of uniforms
    because it's pretty unlikely that you'd want to access the matrices
    from the fragment shader, but for other builtins such as the lighting
    material properties it makes sense.

 clutter/cogl/cogl/cogl-shader-boilerplate.h | 31 +++++++++++++++++--------------
 1 file changed, 17 insertions(+), 14 deletions(-)

commit e8d5be0ba79eef766fff723012c5d1994da84b4c
Author: Neil Roberts <neil@linux.intel.com>
Date:   Mon Jan 24 11:49:04 2011 +0000

    ClutterTimeline: Fix the 'msecs' parameter for the new-frame signal
    
    Between Clutter 0.8 and 1.0, the new-frame signal of ClutterTimeline
    changed the second parameter to be an elapsed time in milliseconds
    rather than the frame number. However a few places in clutter were
    still calling the parameter 'frame_num' which is a bit
    misleading. Notably the signature for the signal class closure in the
    header was using the wrong name. This changes them to use 'msecs'.

 clutter/clutter-alpha.c              | 2 +-
 clutter/clutter-timeline.h           | 2 +-
 tests/conform/test-timeline-rewind.c | 4 +---
 3 files changed, 3 insertions(+), 5 deletions(-)

commit 5c0aaf50a7b3d1914d4580d5f853faa9a4b10f73
Author: Neil Roberts <neil@linux.intel.com>
Date:   Mon Jan 24 11:29:59 2011 +0000

    clutter-timeline: Emit the new-frame signal even on the first frame
    
    ClutterTimeline has special handling for the first time do_tick is
    called which was not emitting a new-frame signal. This meant that an
    application which directly uses the timeline would have to manually
    setup the initial state of an animation after starting a timeline to
    avoid painting a single frame with the wrong state. It seems to make
    more sense to instead emit the new-frame signal so that the
    application always sees a new-frame when the progress changes before a
    paint.

 clutter/clutter-timeline.c | 2 ++
 1 file changed, 2 insertions(+)

commit b917285e24a355d38678b4a1cdce9e572ac34c14
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Mon Jan 24 10:51:06 2011 +0000

    Post-release version bump to 1.5.15

 configure.ac       |   2 +-
 po/clutter-1.0.pot | 445 ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++-----------------------------------------------------------------------------------------------
 po/de.po           | 445 ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++-----------------------------------------------------------------------------------------------
 po/fr.po           | 449 ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++-----------------------------------------------------------------------------------------------
 po/id.po           | 450 +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++-----------------------------------------------------------------------------------------------
 po/it.po           | 450 +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++-----------------------------------------------------------------------------------------------
 po/pl.po           | 450 +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++-----------------------------------------------------------------------------------------------
 po/zh_CN.po        | 449 ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++-----------------------------------------------------------------------------------------------
 8 files changed, 1731 insertions(+), 1409 deletions(-)

commit 3e05d2df8de5ded545393994aff29ef9a8f7a0c5
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Mon Jan 24 10:23:36 2011 +0000

    Release Clutter 1.5.14 (1.6.0rc1)

 NEWS         | 42 ++++++++++++++++++++++++++++++++++--------
 configure.ac |  2 +-
 2 files changed, 35 insertions(+), 9 deletions(-)

commit 79b936aa4a829ffd5b5677da228425c4e0c46623
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Fri Jan 21 20:46:09 2011 +0000

    Update the NEWS file

 NEWS | 21 +++++++++++++++++++++
 1 file changed, 21 insertions(+)

commit 6bffd407fd4f4d4d5b5c5f5ef6d9b43c44b7fe03
Author: Bastian Winkler <buz@netbuz.org>
Date:   Fri Jan 21 14:50:44 2011 +0100

    model: Add support to define rows in ClutterScript
    
    This adds a custom "rows" property, that allows to define the rows of a
    ClutterModel. A single row can either an array of all columns or an
    object with column-name : column-value pairs.
    
    http://bugzilla.clutter-project.org/show_bug.cgi?id=2528

 clutter/clutter-model.c           | 210 ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++---------------------------------
 tests/conform/test-model.c        |  35 +++++++++++++++++++++++++++++++++
 tests/data/test-script-model.json |   8 ++++++++
 3 files changed, 218 insertions(+), 35 deletions(-)

commit 95b3a718ef5c08f058e2bf0e3e56df390408821f
Author: Bastian Winkler <buz@netbuz.org>
Date:   Wed Jan 12 13:09:52 2011 +0100

    script-parser: Allow initialized GValue arg in clutter_script_parse_node
    
    Allow to 'abuse' the clutter_script_parse_node function by calling it
    with an initialized GValue instead of a valid GParamSpec argument to
    obtain the correct typed value from the json node.
    
    http://bugzilla.clutter-project.org/show_bug.cgi?id=2528

 clutter/clutter-script-parser.c | 23 +++++++++++++++--------
 1 file changed, 15 insertions(+), 8 deletions(-)

commit 8e1c1909f80b4513154a3dfd8980160f94ec036f
Author: Bastian Winkler <buz@netbuz.org>
Date:   Wed Jan 12 12:54:43 2011 +0100

    model: Change the column argument type to gint for clutter_model_set_sort
    
    Like in clutter_model_set_sorting_column this function should take a
    gint column, otherwise GObject-Introspection won't allow to pass a NULL
    sorting function.
    
    http://bugzilla.clutter-project.org/show_bug.cgi?id=2527

 clutter/clutter-model.c | 2 +-
 clutter/clutter-model.h | 2 +-
 2 files changed, 2 insertions(+), 2 deletions(-)

commit 8a6986089b79f9d6cbb7012d12087d2d2e42526c
Author: Bastian Winkler <buz@netbuz.org>
Date:   Sat Jan 22 12:51:31 2011 +0100

    model: Fix some GObject-Introspection annotations
    
    http://bugzilla.clutter-project.org/show_bug.cgi?id=2526

 clutter/clutter-model.c | 6 +++---
 1 file changed, 3 insertions(+), 3 deletions(-)

commit 86c786aaad28e439146af4a93f787163e96bab6d
Merge: 8a5867799 b7d26b2d0
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Fri Jan 21 20:22:32 2011 +0000

    Merge branch 'xi2'
    
    * xi2: (41 commits)
      test-devices: Actually print the axis data
      device-manager/xi2: Sync the stage of source devices
      event: Clean up clutter_event_copy()
      device: unset the axes array pointer when resetting
      device-manager/xi2: Fix device hotplugging
      glx: Clean up GLX implementation
      device/x11: Store min/max keycode in the XI device class
      x11: Hide all private symbols
      docs: More documentation fixes for InputDevice
      */event: Never manipulate the event queue directly
      win32: Update DeviceManager device creation
      device: Allow enabling/disabling non-master devices
      backend/eglx: Add newly created stages to the translators
      device: Add more doc annotations
      device: Use a double for translate_axis() argument
      test-devices: Clean up and show axes data
      event: Fix up clutter_event_copy()
      device/xi2: Translate the axis data after setting devices
      device: Add more accessors for properties
      docs: Update API reference
      ...

commit 8a5867799c5809854dfac9c2b7e704bcc6e9455b
Author: Robert Bragg <robert@linux.intel.com>
Date:   Fri Jan 21 18:43:35 2011 +0000

    cogl: call _cogl_texture_init for x11 tfp
    
    When we added the texture->framebuffers member a _cogl_texture_init
    funciton was added to initialize the list of framebuffers associated
    with a texture to NULL. All the backends were updated except the
    x11 tfp backend. This was causing crashes in test-pixmap.

 clutter/cogl/cogl/winsys/cogl-texture-pixmap-x11.c | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 1973168bbaa133215df73eaeeef25c6dcc0d6a07
Author: Robert Bragg <robert@linux.intel.com>
Date:   Fri Jan 21 17:38:14 2011 +0000

    journal: start uprof flush timer after flushing fb deps
    
    This avoids us recursively starting the _cogl_journal_flush uprof timer
    by only starting it after flushing the journals of dependency
    framebuffers.

 clutter/cogl/cogl/cogl-journal.c | 6 ++++--
 1 file changed, 4 insertions(+), 2 deletions(-)

commit f9d4846d6acc493b9fd52d627a82a0302d507a17
Author: Robert Bragg <robert@linux.intel.com>
Date:   Fri Jan 21 17:28:34 2011 +0000

    cogl: make sure to init ctx->framebuffers
    
    This makes sure to initialize ctx->framebuffers to NULL otherwise we can
    get apps crashing when they create their first framebuffer.

 clutter/cogl/cogl/cogl-context.c | 2 ++
 1 file changed, 2 insertions(+)

commit 326c51630492ab13a2e584f9efb0dc5673966c0e
Author: Robert Bragg <robert@linux.intel.com>
Date:   Thu Jan 20 19:31:53 2011 +0000

    cogl: rename CoglVertexAttribute CoglAttribute
    
    This is part of a broader cleanup of some of the experimental Cogl API.
    One of the reasons for this particular rename is to reduce the verbosity
    of using the API. Another reason is that CoglVertexArray is going to be
    renamed CoglAttributeBuffer and we want to help emphasize the
    relationship between CoglAttributes and CoglAttributeBuffers.

 clutter/cogl/cogl/Makefile.am                                                   |   6 +--
 clutter/cogl/cogl/{cogl-vertex-attribute-private.h => cogl-attribute-private.h} |  56 ++++++++++++++--------------
 clutter/cogl/cogl/{cogl-vertex-attribute.c => cogl-attribute.c}                 | 272 ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++-------------------------------------------------------------------
 clutter/cogl/cogl/{cogl-vertex-attribute.h => cogl-attribute.h}                 |  97 ++++++++++++++++++------------------------------
 clutter/cogl/cogl/cogl-context.c                                                |   2 +-
 clutter/cogl/cogl/cogl-index-array.c                                            |   4 +-
 clutter/cogl/cogl/cogl-journal.c                                                | 117 ++++++++++++++++++++++++++++-----------------------------
 clutter/cogl/cogl/cogl-path-private.h                                           |   4 +-
 clutter/cogl/cogl/cogl-pipeline-progend-glsl-private.h                          |   2 +-
 clutter/cogl/cogl/cogl-primitive.c                                              | 309 +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++--------------------------------------------------------------------------------
 clutter/cogl/cogl/cogl-primitive.h                                              |  26 ++++++-------
 clutter/cogl/cogl/cogl-primitives.c                                             |  84 ++++++++++++++++++++---------------------
 clutter/cogl/cogl/cogl-types.h                                                  |  22 +++++++++++
 clutter/cogl/cogl/cogl-vertex-buffer-private.h                                  |   4 +-
 clutter/cogl/cogl/cogl-vertex-buffer.c                                          |  18 ++++-----
 clutter/cogl/cogl/cogl-vertex-buffer.h                                          |  22 -----------
 clutter/cogl/cogl/cogl.c                                                        |   4 +-
 clutter/cogl/cogl/cogl.h                                                        |   2 +-
 clutter/cogl/cogl/cogl2-path.c                                                  |  28 +++++++-------
 doc/reference/cogl-2.0/cogl-docs.xml.in                                         |   2 +-
 20 files changed, 517 insertions(+), 564 deletions(-)

commit c4bafb48b6e4a3b35a13252e5ade500c01c4a392
Author: Robert Bragg <robert@linux.intel.com>
Date:   Thu Jan 20 18:51:24 2011 +0000

    docs: Adds bitmap section to cogl reference manual
    
    This adds an include for the cogl-bitmap section to cogl-docs.xml.in

 doc/reference/cogl/cogl-docs.xml.in | 1 +
 1 file changed, 1 insertion(+)

commit b3775a75640ae2be0cef489c69d7e4213f170cb9
Author: Robert Bragg <robert@linux.intel.com>
Date:   Thu Jan 20 12:29:49 2011 +0000

    cogl: s/Cogl*Vertex/CoglVertex*/
    
    We have a bunch of experimental convenience functions like
    cogl_primitive_p2/p2t2 that have corresponding vertex structures but it
    seemed a bit odd to have the vertex annotation e.g. "P2T2" be an infix
    of the type like CoglP2T2Vertex instead of be a postfix like
    CoglVertexP2T2. This switches them all to follow the postfix naming
    style.

 clutter/cogl/cogl/cogl-primitive.c        | 96 ++++++++++++++++++++++++++++++++++++++++++++++++------------------------------------------------
 clutter/cogl/cogl/cogl-primitive.h        | 80 ++++++++++++++++++++++++++++++++++++++++----------------------------------------
 clutter/cogl/cogl/cogl-vertex-attribute.c | 20 ++++++++++----------
 tests/conform/test-cogl-primitive.c       | 16 ++++++++--------
 4 files changed, 106 insertions(+), 106 deletions(-)

commit 3f9e8591671d0c81d5d4034f0895bca3f98cb4c0
Author: Robert Bragg <robert@linux.intel.com>
Date:   Thu Jan 20 18:30:55 2011 +0000

    test-picking: Don't manually paint the stage
    
    Instead of using an idle handler that synchonously paints the stage
    by manually calling clutter_actor_paint (stage) the test now uses an
    idle handler that repeatedly queues a redraw on the stage.
    
    do_events is now called from a "paint" signal handler for the stage, and
    instead of manually determining the fps the test now uses
    CLUTTER_SHOW_FPS=1 instead.

 tests/micro-bench/test-picking.c | 38 +++++++++++++++-----------------------
 1 file changed, 15 insertions(+), 23 deletions(-)

commit 9a663d8e4106e43f8f214b7fdded555ee408cf28
Author: Robert Bragg <robert@linux.intel.com>
Date:   Thu Jan 20 14:41:51 2011 +0000

    debug: Adds a COGL_DEBUG=disable-fast-read-pixel option
    
    COGL_DEBUG=disable-fast-read-pixel can be used to disable the
    optimization for reading a single pixel colour back by looking at the
    geometry in the journal and not involving the GPU. With this disabled we
    will always flush the journal, rendering to the framebuffer and then use
    glReadPixels to get the result.

 clutter/cogl/cogl/cogl-debug-options.h |  7 ++++++-
 clutter/cogl/cogl/cogl-debug.c         |  3 ++-
 clutter/cogl/cogl/cogl-debug.h         | 61 +++++++++++++++++++++++++++++++------------------------------
 clutter/cogl/cogl/cogl-framebuffer.c   |  3 +++
 clutter/cogl/cogl/cogl-journal.c       |  3 +++
 5 files changed, 45 insertions(+), 32 deletions(-)

commit 1bdb0e6e98db719c8652c85fc234c21437ad071a
Author: Robert Bragg <robert@linux.intel.com>
Date:   Wed Jan 12 22:12:41 2011 +0000

    cogl: Implements a software only read-pixel fast-path
    
    This adds a transparent optimization to cogl_read_pixels for when a
    single pixel is being read back and it happens that all the geometry of
    the current frame is still available in the framebuffer's associated
    journal.
    
    The intention is to indirectly optimize Clutter's render based picking
    mechanism in such a way that the 99% of cases where scenes are comprised
    of trivial quad primitives that can easily be intersected we can avoid
    the latency of kicking a GPU render and blocking for the result when we
    know we can calculate the result manually on the CPU probably faster
    than we could even kick a render.
    
    A nice property of this solution is that it maintains all the
    flexibility of the render based picking provided by Clutter and it can
    gracefully fall back to GPU rendering if actors are drawn using anything
    more complex than a quad for their geometry.
    
    It seems worth noting that there is a limitation to the extensibility of
    this approach in that it can only optimize picking a against geometry
    that passes through Cogl's journal which isn't something Clutter
    directly controls.  For now though this really doesn't matter since
    basically all apps should end up hitting this fast-path. The current
    idea to address this longer term would be a pick2 vfunc for ClutterActor
    that can support geometry and render based input regions of actors and
    move this optimization up into Clutter instead.
    
    Note: currently we don't have a primitive count threshold to consider
    that there could be scenes with enough geometry for us to compensate for
    the cost of kicking a render and determine a result more efficiently by
    utilizing the GPU. We don't currently expect this to be common though.
    
    Note: in the future it could still be interesting to revive something
    like the wip/async-pbo-picking branch to provide an asynchronous
    read-pixels based optimization for Clutter picking in cases where more
    complex input regions that necessitate rendering are in use or if we do
    add a threshold for rendering as mentioned above.

 clutter/clutter-main.c                       |   3 -
 clutter/cogl/cogl/cogl-framebuffer-private.h |  27 ++++++++
 clutter/cogl/cogl/cogl-framebuffer.c         | 196 +++++++++++++++++++++++++++++++++++++++++++++++++++-
 clutter/cogl/cogl/cogl-journal-private.h     |  20 ++++++
 clutter/cogl/cogl/cogl-journal.c             | 710 ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++----------------------------------------------
 clutter/cogl/cogl/cogl-vertex-attribute.c    |   7 ++
 clutter/cogl/cogl/cogl.c                     |  20 +++++-
 7 files changed, 800 insertions(+), 183 deletions(-)

commit e289e85397cb52f421e64e253e1af2628909f424
Author: Robert Bragg <robert@linux.intel.com>
Date:   Tue Jan 18 16:37:01 2011 +0000

    matrix: fix transform/project_points() APIs
    
    Both cogl_matrix_transform_points and _project_points take points_in and
    points_out arguments and explicitly allow pointing to the same array
    (i.e. to transform in-place) The implementation of the various internal
    transform functions though were not handling this possability and so it
    was possible the reference partially transformed vertex values as if
    they were original input values leading to incorrect results. This patch
    ensures we take a temporary copy of the current input point when
    transforming.

 clutter/cogl/cogl/cogl-matrix.c | 136 ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++--------------------------------------------------------------------
 1 file changed, 68 insertions(+), 68 deletions(-)

commit 23ed01d4e933da803bb7bbe4d0439de0824532c1
Author: Robert Bragg <robert@linux.intel.com>
Date:   Thu Jan 13 14:29:46 2011 +0000

    cogl: Adds _cogl_util_point_in_polygon API
    
    This adds a utility function that can determine if a given point
    intersects an arbitrary polygon, by counting how many edges a
    "semi-infinite" horizontal ray crosses from that point. The plan is to
    use this for a software based read-pixel fast path that avoids using the
    GPU to rasterize journaled primitives and can instead intersect a point
    being read with quads in the journal to determine the correct color.

 clutter/cogl/cogl/Makefile.am                  |  2 ++
 clutter/cogl/cogl/cogl-point-in-poly-private.h | 40 ++++++++++++++++++++++++++++++++++++++++
 clutter/cogl/cogl/cogl-point-in-poly.c         | 69 +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
 3 files changed, 111 insertions(+)

commit 142b229c5c2684f94af32358d1401b61aa3019aa
Author: Robert Bragg <robert@linux.intel.com>
Date:   Wed Jan 12 22:06:58 2011 +0000

    cogl: Adds _cogl_swap_buffers_notify for clutter backends
    
    This adds a stop-gap mechanism for Cogl to know when the window system
    is requested to present the current backbuffer to the frontbuffer by
    adding a _cogl_swap_buffers_notify function that backends are now
    expected to call right after issuing the equivalent request to OpenGL
    vie the platforms OpenGL binding layer. This (blindly) updates all the
    backends to call this new function.
    
    For now Cogl doesn't do anything with the notification but the intention
    is to use it as part of a planned read-pixel optimization which will
    need to reset some state at the start of each new frame.

 clutter/cogl/cogl/cogl-framebuffer-private.h |  3 +++
 clutter/cogl/cogl/cogl-framebuffer.c         |  5 +++++
 clutter/cogl/cogl/cogl.c                     | 10 ++++++++++
 clutter/cogl/cogl/cogl.h                     |  3 +++
 clutter/egl/clutter-stage-egl.c              |  1 +
 clutter/fruity/clutter-backend-fruity.c      |  1 +
 clutter/glx/clutter-stage-glx.c              |  1 +
 clutter/osx/clutter-stage-osx.c              |  1 +
 clutter/wayland/clutter-stage-wayland.c      |  2 ++
 clutter/win32/clutter-backend-win32.c        |  5 ++++-
 10 files changed, 31 insertions(+), 1 deletion(-)

commit e150f474b3e9e58565dc894b4ae9234406d90675
Author: Robert Bragg <robert@linux.intel.com>
Date:   Wed Jan 12 19:30:30 2011 +0000

    clip: rename get_clip_stack + add framebuffer_get_stack
    
    Instead of having _cogl_get/set_clip stack which reference the global
    CoglContext this instead makes those into CoglClipState method functions
    named _cogl_clip_state_get/set_stack that take an explicit pointer to a
    CoglClipState.
    
    This also adds _cogl_framebuffer_get/set_clip_stack convenience
    functions that avoid having to first get the ClipState from a
    framebuffer then the stack from that - so we can maintain the
    convenience of _cogl_get_clip_stack.

 clutter/cogl/cogl/cogl-clip-state.c          | 21 +++------------------
 clutter/cogl/cogl/cogl-clip-state.h          | 21 +++------------------
 clutter/cogl/cogl/cogl-framebuffer-private.h | 26 ++++++++++++++++++++++++++
 clutter/cogl/cogl/cogl-framebuffer.c         | 17 +++++++++++++++++
 clutter/cogl/cogl/cogl-journal.c             |  5 ++++-
 5 files changed, 53 insertions(+), 37 deletions(-)

commit 179dc9b7d1d9d14227c7f4eef241faf2d1affda0
Author: Robert Bragg <robert@linux.intel.com>
Date:   Wed Jan 12 19:13:45 2011 +0000

    clip-stack: Adds _cogl_clip_stack_get_bounds API
    
    This adds an internal function to be able to query the screen space
    bounding box of the current clip entries contained in a given
    CoglClipStack.
    
    This bounding box which is cheap to determine can be useful to know the
    largest extents that might be updated while drawing with this clip
    stack.
    
    For example the plan is to use this as part of an optimized read-pixel
    path handled on the CPU which will need to track the currently valid
    extents of the last call to cogl_clear()

 clutter/cogl/cogl/cogl-clip-stack.c | 45 ++++++++++++++++++++++++++++++++-------------
 clutter/cogl/cogl/cogl-clip-stack.h |  7 +++++++
 2 files changed, 39 insertions(+), 13 deletions(-)

commit f834596fd42b26d471a80cfec08c0d6e8c53f39a
Author: Robert Bragg <robert@linux.intel.com>
Date:   Thu Jan 6 13:25:45 2011 +0000

    journal: Support per-framebuffer journals
    
    Instead of having a single journal per context, we now have a
    CoglJournal object for each CoglFramebuffer. This means we now don't
    have to flush the journal when switching/pushing/popping between
    different framebuffers so for example a Clutter scene that involves some
    ClutterEffect actors that transiently redirect to an FBO can still be
    batched.
    
    This also allows us to track state in the journal that relates to the
    current frame of its associated framebuffer which we'll need for our
    optimization for using the CPU to handle reading a single pixel back
    from a framebuffer when we know the whole scene is currently comprised
    of simple rectangles in a journal.

 clutter/cogl/cogl/cogl-atlas-texture.c       |  22 ++++++++++++----------
 clutter/cogl/cogl/cogl-clip-state.c          |   5 +++--
 clutter/cogl/cogl/cogl-context.c             |   6 ------
 clutter/cogl/cogl/cogl-context.h             |  12 +++++-------
 clutter/cogl/cogl/cogl-framebuffer-private.h |  23 +++++++++++++++++++++++
 clutter/cogl/cogl/cogl-framebuffer.c         | 111 +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++--------------
 clutter/cogl/cogl/cogl-journal-private.h     |  19 +++++++++++++++++--
 clutter/cogl/cogl/cogl-journal.c             | 140 +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++---------------------------------------------
 clutter/cogl/cogl/cogl-pipeline-private.h    |   3 +++
 clutter/cogl/cogl/cogl-pipeline.c            |   7 ++++++-
 clutter/cogl/cogl/cogl-primitives.c          |   9 +++++++--
 clutter/cogl/cogl/cogl-sub-texture.c         |   3 ++-
 clutter/cogl/cogl/cogl-texture-2d-sliced.c   |   2 +-
 clutter/cogl/cogl/cogl-texture-2d.c          |   2 +-
 clutter/cogl/cogl/cogl-texture-3d.c          |   2 +-
 clutter/cogl/cogl/cogl-texture-private.h     |  15 +++++++++++++++
 clutter/cogl/cogl/cogl-texture-rectangle.c   |   2 +-
 clutter/cogl/cogl/cogl-texture.c             |  58 ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
 clutter/cogl/cogl/cogl-vertex-attribute.c    |   7 ++++++-
 clutter/cogl/cogl/cogl.c                     |  20 ++++++++++++++++----
 clutter/cogl/cogl/cogl2-path.c               |   8 ++++++--
 21 files changed, 375 insertions(+), 101 deletions(-)

commit 385e0f84c6179a30f9031aba974131e1cf3e6a4e
Author: Robert Bragg <robert@linux.intel.com>
Date:   Wed Jan 12 20:37:53 2011 +0000

    cogl-object: Adds an internal _cogl_object_set_user_data
    
    This adds an internal alternative to cogl_object_set_user_data that also
    passes an instance pointer to destroy notify callbacks.
    
    When setting private data on a CoglObject it's often desirable to know
    the instance being destroyed when we are being notified to free the
    private data due to the object being freed. The typical solution to this
    is to track a pointer to the instance in the private data itself so it
    can be identified but that usually requires an extra micro allocation
    for the private data that could have been avoided if only the callback
    were given an instance pointer.
    
    The new internal _cogl_object_set_user_data passes the instance pointer
    as a second argument which means it is ABI compatible for us to layer
    the public version on top of this internal function.

 clutter/cogl/cogl/cogl-object-private.h | 21 ++++++++++++++++++++-
 clutter/cogl/cogl/cogl-object.c         | 24 +++++++++++++++++-------
 2 files changed, 37 insertions(+), 8 deletions(-)

commit 131578c13aeeb53d99d7c63a0b2ddaded23524fc
Author: Robert Bragg <robert@linux.intel.com>
Date:   Wed Jan 5 15:30:04 2011 +0000

    framebuffer: Move clear code to cogl-framebuffer.c
    
    This moves the implementation of cogl_clear into cogl-framebuffer.c as
    two new internal functions _cogl_framebuffer_clear and
    _cogl_framebuffer_clear4f. It's not clear if this is what the API will
    look like as we make more of the CoglFramebuffer API public due to the
    limitations of using flags to identify buffers when framebuffers may
    contain any number of ancillary buffers but conceptually it makes some
    sense to tie the operation of clearing a color buffer to a framebuffer.
    
    The short term intention is to enable tracking the current clear color
    as a property of the framebuffer as part of an optimization for reading
    back single pixels when the geometry is simple enough that we can
    compute the result quickly on the CPU. (If the point doesn't intersect
    any geometry we'll need to return the last clear color.)

 clutter/cogl/cogl/cogl-framebuffer-private.h |  20 ++++++++++++++++++++
 clutter/cogl/cogl/cogl-framebuffer.c         | 103 +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
 clutter/cogl/cogl/cogl.c                     |  66 ++++--------------------------------------------------------------
 clutter/cogl/cogl/cogl2-path.c               |   4 ++--
 4 files changed, 129 insertions(+), 64 deletions(-)

commit b7d26b2d02729b2d5eeb1650ca4e89a723afc1c7
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Fri Jan 21 15:27:56 2011 +0000

    test-devices: Actually print the axis data
    
    Returning in an if() block whose condition we assume to be true doesn't
    play nicely with having statements after the block. Let's fix that.

 tests/interactive/test-devices.c | 31 ++++++++++++++++---------------
 1 file changed, 16 insertions(+), 15 deletions(-)

commit e46571d63911df23cb25fb0b3fcfe5e86f50d81b
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Fri Jan 21 15:26:52 2011 +0000

    device-manager/xi2: Sync the stage of source devices
    
    Keep the slave devices in sync with their master, so that we don't
    ignore their events because they lack the stage pointer.

 clutter/x11/clutter-device-manager-xi2.c | 51 ++++++++++++++++++++++++++++++++++-----------------
 1 file changed, 34 insertions(+), 17 deletions(-)

commit 516366d7691128e9f2138781bcc144cd628b110f
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Fri Jan 21 15:14:11 2011 +0000

    event: Clean up clutter_event_copy()
    
    Try to avoid duplication of variables and blocks.

 clutter/clutter-event.c | 46 +++++++++++++++++++++-------------------------
 1 file changed, 21 insertions(+), 25 deletions(-)

commit 7a339d1663b94e4cbc07ffa8a8c3bf0a47d84cae
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Fri Jan 21 14:12:19 2011 +0000

    device: unset the axes array pointer when resetting
    
    Otherwise we'll get a nice realloc() error from glibc.

 clutter/clutter-input-device.c | 2 ++
 1 file changed, 2 insertions(+)

commit 4ab8a3f0c16b82d4f223de869e1b87279dcff272
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Fri Jan 21 11:43:00 2011 +0000

    stage: Do not create the default stage on stage.is_default()
    
    Use the stage manager to see if a default stage was effectively set,
    otherwise we end up creating a default stage when destroying a
    non-default one.

 clutter/clutter-stage.c | 12 +++++++-----
 1 file changed, 7 insertions(+), 5 deletions(-)

commit 0e993469155516dde673292bafe72d1c8308e27f
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Fri Jan 21 11:41:36 2011 +0000

    device-manager/xi2: Fix device hotplugging
    
    Hierarchy and Device changed events come through with the X window set
    to be the root window, not the stage window. We need to whitelist them
    so that we can actually support hotplugging and device changes.

 clutter/x11/clutter-device-manager-xi2.c | 32 +++++++++++++++++++++-----------
 tests/interactive/test-devices.c         | 83 ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++---------
 2 files changed, 95 insertions(+), 20 deletions(-)

commit 7514f5fe92844a57d33a4811fd20687bbb391c8b
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Fri Jan 21 10:49:12 2011 +0000

    glx: Clean up GLX implementation
    
    Like commit a277b4091a3fa09a39cf001809c3048eb27f3952, but targeted at
    the GLX backend.

 clutter/glx/clutter-backend-glx.c | 22 +++++++++++-----------
 clutter/glx/clutter-stage-glx.c   | 57 ++++++++++++++++++++++++++-------------------------------
 clutter/glx/clutter-stage-glx.h   |  2 +-
 3 files changed, 38 insertions(+), 43 deletions(-)

commit 6da51f6ed379f531bee72b688366dc734082a573
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Fri Jan 21 10:24:34 2011 +0000

    device/x11: Store min/max keycode in the XI device class
    
    The generic device class shouldn't have the minimum and maximum keycode,
    since no other input backend provides those.

 clutter/clutter-device-manager-private.h      |  8 ++------
 clutter/clutter-input-device.c                | 18 +++---------------
 clutter/x11/clutter-device-manager-core-x11.c | 10 +++++++---
 clutter/x11/clutter-device-manager-xi2.c      |  6 ++----
 clutter/x11/clutter-input-device-core-x11.c   |  9 ++++++---
 5 files changed, 20 insertions(+), 31 deletions(-)

commit a277b4091a3fa09a39cf001809c3048eb27f3952
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Thu Jan 20 15:39:28 2011 +0000

    x11: Hide all private symbols
    
    The x11 backend exposes a lot of symbols that are meant to only be used
    when implementing a subclassed backend, like the glx and eglx ones.
    
    The uninstalled headers are also filled with cruft declarations of
    functions long since removed.
    
    Let's try to clean up this mess.

 clutter/egl/clutter-backend-egl.c | 13 +++++++++----
 clutter/glx/clutter-backend-glx.c | 19 ++++++++++++++-----
 clutter/x11/clutter-backend-x11.c | 28 ++++++++++------------------
 clutter/x11/clutter-backend-x11.h | 31 +++----------------------------
 clutter/x11/clutter-keymap-x11.c  |  4 ++--
 clutter/x11/clutter-keymap-x11.h  |  4 ++--
 clutter/x11/clutter-stage-x11.c   | 12 +++++++-----
 clutter/x11/clutter-stage-x11.h   | 13 ++-----------
 8 files changed, 49 insertions(+), 75 deletions(-)

commit 89467abae591fb07afed507323f086264d73e68d
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Wed Jan 19 17:03:27 2011 +0000

    docs: More documentation fixes for InputDevice

 clutter/clutter-input-device.c             | 107 ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++-------------------
 doc/reference/clutter/clutter-sections.txt |  10 +++++++---
 2 files changed, 95 insertions(+), 22 deletions(-)

commit 0f56abf569d524bd42d4a3cdc6a5321a3de2b7f9
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Wed Jan 19 16:34:49 2011 +0000

    */event: Never manipulate the event queue directly
    
    Always use _clutter_event_push() instead.

 clutter/egl/clutter-event-tslib.c              |  2 +-
 clutter/evdev/clutter-device-manager-evdev.c   |  5 +----
 clutter/wayland/clutter-input-device-wayland.c | 26 +++++++-------------------
 clutter/win32/clutter-event-win32.c            |  6 +-----
 4 files changed, 10 insertions(+), 29 deletions(-)

commit 400ecdfc81d19ab27cbc7a4f416b6fc109556ebf
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Wed Jan 19 16:34:37 2011 +0000

    win32: Update DeviceManager device creation

 clutter/win32/clutter-device-manager-win32.c | 13 +++++++++++++
 1 file changed, 13 insertions(+)

commit 73cf6bd52c282acc1cdb67724d2b55d3f822f7ef
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Wed Jan 19 16:23:45 2011 +0000

    device: Allow enabling/disabling non-master devices
    
    Slave and floating devices should always be disabled, and not deliver
    events to the scene. It is up to the user to enable non-master devices
    and handle events coming from them.
    
    ClutterInputDevice gets a new :enabled property, defaulting to FALSE;
    when a device manager creates a new device it has to set it to TRUE if
    the :device-mode property is set to CLUTTER_INPUT_MODE_MASTER.
    
    The main event queue entry point, _clutter_event_push(), will
    automatically discard events coming from disabled devices.

 clutter/clutter-device-manager-private.h      |  3 ++-
 clutter/clutter-event.c                       |  9 +++++++++
 clutter/clutter-input-device.c                | 66 ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
 clutter/clutter-input-device.h                |  3 +++
 clutter/x11/clutter-device-manager-core-x11.c |  3 +++
 clutter/x11/clutter-device-manager-xi2.c      | 10 +++++++++-
 tests/interactive/test-devices.c              | 10 ++++++++--
 7 files changed, 100 insertions(+), 4 deletions(-)

commit 137f7d42a8db40a85ae95b10d9ed0fa895f48b0a
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Wed Jan 19 15:17:34 2011 +0000

    backend/eglx: Add newly created stages to the translators
    
    The events directed to the stage should be translated by the stage.

 clutter/egl/clutter-backend-egl.c | 4 ++++
 1 file changed, 4 insertions(+)

commit d3ed3d3a7b3950160a3351d54e766628fd916ad8
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Wed Jan 19 13:54:27 2011 +0000

    device: Add more doc annotations
    
    Even for internal API.

 clutter/clutter-input-device.c | 32 ++++++++++++++++++++++++++++++++
 1 file changed, 32 insertions(+)

commit 50e52f550a14e86a689673ce898970337cc46e8b
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Wed Jan 19 13:53:20 2011 +0000

    device: Use a double for translate_axis() argument
    
    While XI1 has axis data in events exposed as integers, XI2 uses double
    precision floating point values.

 clutter/clutter-device-manager-private.h |  2 +-
 clutter/clutter-input-device.c           | 17 ++++++++++++++++-
 2 files changed, 17 insertions(+), 2 deletions(-)

commit f54044f7e45fe37538187ca06f7d378ae8d64800
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Wed Jan 19 13:52:33 2011 +0000

    test-devices: Clean up and show axes data

 tests/interactive/test-devices.c | 106 ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++--------------
 1 file changed, 92 insertions(+), 14 deletions(-)

commit d078fe09301db384b7a465b86ad83dab860576b4
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Tue Jan 18 22:31:14 2011 +0000

    event: Fix up clutter_event_copy()
    
    We need to copy the scroll axis data, and we need to copy the private
    Event data from the source event to the target event structure.

 clutter/clutter-event.c | 25 +++++++++++++++++++++++++
 1 file changed, 25 insertions(+)

commit 405e611279321ebe293e02b4507899355f49cc64
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Tue Jan 18 22:30:21 2011 +0000

    device/xi2: Translate the axis data after setting devices
    
    We need the devices (source and virtual) to be set before translating
    the axis data from XI2 to the Clutter event.

 clutter/x11/clutter-device-manager-xi2.c | 30 +++++++++++++++++++-----------
 1 file changed, 19 insertions(+), 11 deletions(-)

commit dd5f6ca7e1b5042beca6363109424565a7d8223b
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Tue Jan 18 17:33:22 2011 +0000

    device: Add more accessors for properties
    
    Allow using real accessor methods for getting the ClutterInputDevice
    properties set on construction.

 clutter/clutter-input-device.c             | 38 ++++++++++++++++++++++++++++++++++++++
 clutter/clutter-input-device.h             |  2 ++
 doc/reference/clutter/clutter-sections.txt |  2 ++
 3 files changed, 42 insertions(+)

commit ad06f1b20fcac9167f456ba21674d8f7a2c0cd3b
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Tue Jan 18 16:57:14 2011 +0000

    docs: Update API reference

 doc/reference/clutter/clutter-sections.txt | 2 ++
 1 file changed, 2 insertions(+)

commit 333ca35ceca739388be36cf48514fcb68f3b7aef
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Tue Jan 18 16:55:14 2011 +0000

    device: Add get_axis_value()
    
    We need a convenience function for extracting the value of a specific
    axis type out of the array of axis values attached to events.

 clutter/clutter-input-device.c | 47 +++++++++++++++++++++++++++++++++++++++++++++++
 clutter/clutter-input-device.h |  4 ++++
 2 files changed, 51 insertions(+)

commit d805237c313f5e2ce85b93fd167569c25b702163
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Tue Jan 18 16:54:12 2011 +0000

    event: Add accessor for the axes field
    
    CLUTTER_BUTTON_* and CLUTTER_MOTION event types have axes data attached
    to them, so we want to expose a common ClutterEvent method for
    extracting that data.

 clutter/clutter-event.c | 57 +++++++++++++++++++++++++++++++++++++++++++++++++++++++++
 clutter/clutter-event.h |  2 ++
 2 files changed, 59 insertions(+)

commit 431200f40dad93bcaeff76ad34f3fdd431d5a8f2
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Tue Jan 18 16:13:26 2011 +0000

    device: Add keys and axes accessors
    
    Allow retrieving the number of keys and axes, since we provide the API
    to iterate over them both.

 clutter/clutter-device-manager-private.h    |  2 --
 clutter/clutter-input-device.c              | 30 ++++++++++++++++++++++++------
 clutter/clutter-input-device.h              |  3 +++
 clutter/x11/clutter-device-manager-xi2.c    |  2 +-
 clutter/x11/clutter-input-device-core-x11.c |  3 +--
 doc/reference/clutter/clutter-sections.txt  | 10 ++++++++--
 6 files changed, 37 insertions(+), 13 deletions(-)

commit b662a070f2c5ebe2af479fd0290745ad923b3c42
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Tue Jan 18 15:42:02 2011 +0000

    docs: Update dependencies in README

 README | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 0a869e0718331737a1126da861222f7b0162fcce
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Tue Jan 18 14:16:11 2011 +0000

    egl/x11: Defer X11-specific code to the X11 backend
    
    The ClutterStageX11 implementation does most of the heavy lifting, so
    subclasses like ClutterStageGLX and ClutterStageEGL do not need to
    handle things like creating the stage Window and selecting events; just
    chaining up and using the internal API will suffice.

 clutter/egl/clutter-stage-egl.c | 108 ++++++++----------------------------------------------------------------------------------------------------
 1 file changed, 8 insertions(+), 100 deletions(-)

commit a3102a777ead15f7ba4b671bd25fd642762fec57
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Tue Jan 18 14:09:04 2011 +0000

    docs: Fill out documentation for new symbols

 clutter/clutter-event.c                    | 82 ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
 clutter/clutter-event.h                    |  1 +
 clutter/clutter-input-device.c             | 37 +++++++++++++++++++++++++++++++++++++
 clutter/clutter-input-device.h             | 29 +++++++++++++++++++++++++++++
 clutter/clutter-private.h                  |  4 ++++
 clutter/x11/clutter-device-manager-xi2.c   | 39 +++++++++++++++++++++++++++++----------
 doc/reference/clutter/Makefile.am          |  1 +
 doc/reference/clutter/clutter-sections.txt | 12 +++++++++++-
 8 files changed, 194 insertions(+), 11 deletions(-)

commit fa3c5a28a7b82d817ae7b83a058158a101e1e4b0
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Tue Jan 18 13:15:20 2011 +0000

    backend/x11: Allow querying xinput support
    
    Undeprecate the XInput-related X11 API: since we don't enable XI support
    by default we still need to ask for it, and see if we have it after the
    backend initialization sequence.

 clutter/x11/clutter-backend-x11.c | 14 ++++++++------
 clutter/x11/clutter-backend-x11.h |  5 +----
 2 files changed, 9 insertions(+), 10 deletions(-)

commit c8cc03f8a7b13db01a71c4a597c05a7b94ba664c
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Tue Jan 18 13:08:09 2011 +0000

    event/x11: Epic clean up
    
    Event translation is now done where it belongs: we don't need a massive
    switch in a file with direct access to private structure members.
    
    So long, event_translate(); and thanks for all the fish.

 clutter/x11/clutter-event-x11.c | 869 -------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
 1 file changed, 869 deletions(-)

commit c044e44dc798a4afede519abe430ff6a20bd745d
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Tue Jan 18 13:07:36 2011 +0000

    device/x11: Use similar core for axis translation as XI2

 clutter/x11/clutter-input-device-core-x11.c | 39 +++++++++++++++++++--------------------
 1 file changed, 19 insertions(+), 20 deletions(-)

commit c9c6236d3786ed3f69f170b02523e08a91b7f644
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Tue Jan 18 13:05:46 2011 +0000

    stage/x11: Do not check a boolean for equality
    
    Booleans should only be used like direct conditions, never as
    comparisons with TRUE or FALSE.

 clutter/x11/clutter-stage-x11.c | 4 +---
 1 file changed, 1 insertion(+), 3 deletions(-)

commit ee15d0d2d01a02e426cbb8c340738e4f8411fc4f
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Tue Jan 18 13:05:17 2011 +0000

    Add copyright and licensing blurbs

 clutter/x11/clutter-input-device-core-x11.h | 23 +++++++++++++++++++++++
 clutter/x11/clutter-input-device-xi2.c      | 23 +++++++++++++++++++++++
 clutter/x11/clutter-input-device-xi2.h      | 23 +++++++++++++++++++++++
 3 files changed, 69 insertions(+)

commit 2cb0077f7d7260109f0974d260cb4ed63ade6e9e
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Tue Jan 18 13:03:07 2011 +0000

    device/xi2: Implement get_core_device()
    
    We ask XI2 to get the client pointer for CLUTTER_POINTER_DEVICE, and
    we use the attached keyboard device for CLUTTER_KEYBOARD_DEVICE. For
    everything else, we return NULL.

 clutter/x11/clutter-device-manager-xi2.c | 25 +++++++++++++++++++++++++
 1 file changed, 25 insertions(+)

commit 9c48486d7ac73aa55b69a70cf1ef7009a0af2a09
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Tue Jan 18 13:02:15 2011 +0000

    device/xi2: Remove the ::remove implementation
    
    Removing a device is only internal API, and we already have a function
    for that: we don't need to implement the DeviceManager virtual as well.

 clutter/x11/clutter-device-manager-xi2.c | 18 ++----------------
 1 file changed, 2 insertions(+), 16 deletions(-)

commit 0075c45ca49569988fb6b8f1b4a60cd4e77be287
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Tue Jan 18 13:01:27 2011 +0000

    device/xi2: Blow the cached devices list
    
    Every time we add or remove a device we should clear the cached list
    that we return in get_devices(), so that it gets repopulated.

 clutter/x11/clutter-device-manager-xi2.c | 8 ++++++++
 1 file changed, 8 insertions(+)

commit de93f721c1314321bf78acec2f50d5a481210ec9
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Tue Jan 18 12:59:49 2011 +0000

    Clean up the copyright and licensing blurbs

 clutter/glx/clutter-stage-glx.c               |  9 +++++----
 clutter/x11/clutter-device-manager-core-x11.c |  2 +-
 clutter/x11/clutter-device-manager-core-x11.h |  2 +-
 clutter/x11/clutter-device-manager-xi2.c      |  2 +-
 clutter/x11/clutter-device-manager-xi2.h      |  2 +-
 clutter/x11/clutter-input-device-core-x11.c   | 23 +++++++++++++++++++++++
 6 files changed, 32 insertions(+), 8 deletions(-)

commit 7c25b063aafc21527413106dca6db3fcb50bd5ad
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Tue Jan 18 12:57:50 2011 +0000

    x11: Use XI2 API only if we support it
    
    XIQueryVersion() is XI2 API.

 clutter/x11/clutter-backend-x11.c | 43 ++++++++++++++++++++++++++++++++-----------
 1 file changed, 32 insertions(+), 11 deletions(-)

commit caf359d8c9a110797e9ad64a7cb3600b7b964275
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Tue Jan 18 12:57:12 2011 +0000

    input-device: Add documentation

 clutter/clutter-input-device.c | 48 +++++++++++++++++++++++++++++++++++++++++++++++-
 clutter/clutter-input-device.h |  2 +-
 2 files changed, 48 insertions(+), 2 deletions(-)

commit 342cdd25756b37745bfd1725d78f6f670f77bee0
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Mon Jan 17 17:01:58 2011 +0000

    input-device: Move select_stage_events() to a vfunc
    
    Don't use a signal, use a virtual function.

 clutter/clutter-device-manager-private.h    |  4 ++++
 clutter/clutter-input-device.c              | 28 +++++-----------------------
 clutter/x11/clutter-input-device-core-x11.c |  5 ++---
 clutter/x11/clutter-input-device-xi2.c      |  5 ++---
 4 files changed, 13 insertions(+), 29 deletions(-)

commit 2777c52f2759513c8e4b66e474ed2da587bd5de5
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Mon Jan 17 16:56:07 2011 +0000

    input-device: Make ClutterInputDeviceClass private
    
    We keep the symbol in the public header, but the definition is now
    private. You could not sub-class InputDevice anyway, without the
    instance structure, and the lack of padding in the class made actually
    implementing devices in backends really hard.

 clutter/clutter-device-manager-private.h |  5 +++++
 clutter/clutter-input-device.h           | 14 --------------
 2 files changed, 5 insertions(+), 14 deletions(-)

commit 001f84875aa5a0f0871b0f86a73d4c1972c12430
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Mon Jan 17 16:42:18 2011 +0000

    Enable XInput support by default
    
    Since we have a decent XI1 and XI2 implementation, now, we should turn
    the support for XInput on by default.
    
    The actual implementation to be used at run-time is still left to be
    decided by the user.

 configure.ac | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 1b1e77b46989ba97bfff8abdfa61df0f514a7eae
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Tue Jan 4 12:32:04 2011 +0000

    event/x11: Rework the way we translate X11 events
    
    This is a lump commit that is fairly difficult to break down without
    either breaking bisecting or breaking the test cases.
    
    The new design for handling X11 event translation works this way:
    
      - ClutterBackend::translate_event() has been added as the central
        point used by a ClutterBackend implementation to translate a
        native event into a ClutterEvent;
    
      - ClutterEventTranslator is a private interface that should be
        implemented by backend-specific objects, like stage
        implementations and ClutterDeviceManager sub-classes, and
        allows dealing with class-specific event translation;
    
      - ClutterStageX11 implements EventTranslator, and deals with the
        stage-relative X11 events coming from the X11 event source;
    
      - ClutterStageGLX overrides EventTranslator, in order to
        deal with the INTEL_GLX_swap_event extension, and it chains up
        to the X11 default implementation;
    
      - ClutterDeviceManagerX11 has been split into two separate classes,
        one that deals with core and (optionally) XI1 events, and the
        other that deals with XI2 events; the selection is done at run-time,
        since the core+XI1 and XI2 mechanisms are mutually exclusive.
    
    All the other backends we officially support still use their own
    custom event source and translation function, but the end goal is to
    migrate them to the translate_event() virtual function, and have the
    event source be a shared part of Clutter core.

 clutter/Makefile.am                                                             |   24 +++-
 clutter/clutter-backend-private.h                                               |    8 ++
 clutter/clutter-backend.c                                                       |   12 ++
 clutter/clutter-device-manager-private.h                                        |  105 ++++++++++++---
 clutter/clutter-device-manager.c                                                |   29 +++++
 clutter/clutter-device-manager.h                                                |    1 +
 clutter/clutter-event-translator.c                                              |   38 ++++++
 clutter/clutter-event-translator.h                                              |   40 ++++++
 clutter/clutter-event.c                                                         |   77 +++++++++--
 clutter/clutter-event.h                                                         |   51 --------
 clutter/clutter-input-device.c                                                  |  476 ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++------
 clutter/clutter-input-device.h                                                  |   57 +++++++--
 clutter/clutter-marshal.list                                                    |    1 +
 clutter/clutter-private.h                                                       |    3 +
 clutter/clutter-types.h                                                         |   51 ++++++++
 clutter/glx/clutter-backend-glx.c                                               |   11 +-
 clutter/glx/clutter-event-glx.c                                                 |  105 ---------------
 clutter/glx/clutter-event-glx.h                                                 |   38 ------
 clutter/glx/clutter-stage-glx.c                                                 |  186 ++++++++++-----------------
 clutter/x11/clutter-backend-x11.c                                               |  358 +++++++++++++++++++++++++++++++++++++++++----------
 clutter/x11/clutter-backend-x11.h                                               |   55 ++++++--
 clutter/x11/clutter-device-manager-core-x11.c                                   |  745 +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
 clutter/x11/{clutter-device-manager-x11.h => clutter-device-manager-core-x11.h} |    4 +-
 clutter/x11/clutter-device-manager-x11.c                                        |  354 --------------------------------------------------
 clutter/x11/clutter-device-manager-xi2.c                                        | 1058 ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
 clutter/x11/clutter-device-manager-xi2.h                                        |   66 ++++++++++
 clutter/x11/clutter-event-x11.c                                                 |  116 ++++-------------
 clutter/x11/clutter-input-device-core-x11.c                                     |  414 +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
 clutter/x11/clutter-input-device-core-x11.h                                     |   26 ++++
 clutter/x11/clutter-input-device-x11.c                                          |  228 ---------------------------------
 clutter/x11/clutter-input-device-x11.h                                          |   25 ----
 clutter/x11/clutter-input-device-xi2.c                                          |  161 +++++++++++++++++++++++
 clutter/x11/clutter-input-device-xi2.h                                          |   22 ++++
 clutter/x11/clutter-stage-x11.c                                                 |  552 +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++-
 clutter/x11/clutter-stage-x11.h                                                 |    9 ++
 configure.ac                                                                    |   50 +++++---
 tests/interactive/test-devices.c                                                |   13 ++
 37 files changed, 4369 insertions(+), 1200 deletions(-)

commit ca092477c2d3fcc74384c3f46216802db32ba0d9
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Thu Jan 20 16:18:16 2011 +0000

    Appease the gods in introspection
    
    Reduce the amount of bogus warnings g-ir-scanner prints out.

 clutter/clutter-align-constraint.c         |  2 --
 clutter/clutter-align-constraint.h         |  3 ++-
 clutter/clutter-backend-private.h          |  1 -
 clutter/clutter-backend.h                  |  9 +++++++++
 clutter/clutter-bind-constraint.c          |  2 --
 clutter/clutter-bind-constraint.h          |  3 ++-
 clutter/clutter-binding-pool.c             |  1 -
 clutter/clutter-binding-pool.h             |  1 +
 clutter/clutter-blur-effect.c              |  2 --
 clutter/clutter-blur-effect.h              |  1 +
 clutter/clutter-colorize-effect.c          |  2 --
 clutter/clutter-colorize-effect.h          |  3 ++-
 clutter/clutter-desaturate-effect.c        |  2 --
 clutter/clutter-desaturate-effect.h        |  1 +
 clutter/clutter-page-turn-effect.c         |  2 --
 clutter/clutter-page-turn-effect.h         |  1 +
 clutter/clutter-path-constraint.c          |  2 --
 clutter/clutter-path-constraint.h          |  3 ++-
 clutter/clutter-settings.c                 |  2 --
 clutter/clutter-settings.h                 |  1 +
 clutter/clutter-snap-constraint.c          |  2 --
 clutter/clutter-snap-constraint.h          |  3 ++-
 doc/reference/clutter/clutter-sections.txt | 17 ++++++++++++++---
 23 files changed, 38 insertions(+), 28 deletions(-)

commit 439553a1b7e7d6a1731df7124b74545881ce4fbf
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Thu Jan 20 13:44:16 2011 +0000

    Update the NEWS file

 NEWS | 12 +++++++++++-
 1 file changed, 11 insertions(+), 1 deletion(-)

commit ef7810422764f7297f295a7c8189204de1eb4c3f
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Thu Jan 20 13:29:37 2011 +0000

    Expose deprecated symbols whilst building Clutter
    
    Don't use ugly "#undef CLUTTER_DISABLE_DEPRECATED" inside source code
    using deprecated symbols; we have the handy CLUTTER_COMPILATION define
    that we can use as part of the "disable deprecated" conditional.

 clutter/clutter-actor.c             | 4 +---
 clutter/clutter-behaviour-depth.c   | 1 -
 clutter/clutter-behaviour-depth.h   | 2 +-
 clutter/clutter-behaviour-ellipse.c | 1 -
 clutter/clutter-behaviour-ellipse.h | 2 +-
 clutter/clutter-behaviour-opacity.c | 1 -
 clutter/clutter-behaviour-opacity.h | 2 +-
 clutter/clutter-behaviour-path.c    | 1 -
 clutter/clutter-behaviour-path.h    | 2 +-
 clutter/clutter-behaviour-rotate.c  | 1 -
 clutter/clutter-behaviour-rotate.h  | 2 +-
 clutter/clutter-behaviour-scale.c   | 1 -
 clutter/clutter-behaviour-scale.h   | 2 +-
 clutter/clutter-behaviour.c         | 1 -
 clutter/clutter-behaviour.h         | 4 ++--
 clutter/clutter-frame-source.h      | 2 +-
 clutter/clutter-timeout-pool.c      | 1 -
 clutter/clutter-timeout-pool.h      | 2 +-
 18 files changed, 11 insertions(+), 21 deletions(-)

commit cd96e631f15ee623116cf3d330cc046e7855ee56
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Thu Jan 20 13:19:03 2011 +0000

    glx: Deprecate ClutterGLXTexturePixmap
    
    Since 1.4 the ClutterGLXTexturePixmap is just a wrapper around
    ClutterX11TexturePixmap, so we can safely deprecate it. All the
    functionality it provided is now effectively available from the
    superclass or directly from Cogl.

 clutter/glx/clutter-glx-texture-pixmap.c | 23 +++++++++++++++--------
 clutter/glx/clutter-glx-texture-pixmap.h | 12 ++++++++----
 2 files changed, 23 insertions(+), 12 deletions(-)

commit 770bcd5b4042818008e3fbbfab8e11722681a5fa
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Thu Jan 20 12:59:56 2011 +0000

    test-pixmap: Remove the GLX code
    
    The ClutterGLXTexturePixmap actor is just a wrapper around
    ClutterX11TexturePixmap, since the relevant texture-from-pixmap code has
    been moved down to Cogl.

 tests/interactive/test-pixmap.c | 41 -----------------------------------------
 1 file changed, 41 deletions(-)

commit a2d6edd4223fc18a9b3902e388ddd105db468f32
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Wed Jan 19 18:51:01 2011 +0000

    test-pixmap: Fix up compilation on EGLX
    
    We need to check for the GLX windowing system if we are to include
    clutter-glx.h.

 tests/interactive/test-pixmap.c | 2 ++
 1 file changed, 2 insertions(+)

commit 62a0584f115f4a1cc6138c2915d90e24c69c4002
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Wed Jan 19 17:54:28 2011 +0000

    docs: Ignore clutter-config.h when scanning headers

 doc/reference/clutter/Makefile.am | 1 +
 1 file changed, 1 insertion(+)

commit a43c5f10bb5f3273378fedecd618260b96499cff
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Wed Jan 19 14:36:30 2011 +0000

    tests: Try to drop including config.h
    
    The config.h header should be considered a Clutter internal header, and
    the test cases (especially the interactive test cases) should strive to
    never rely on internal headers.

 tests/interactive/test-cogl-offscreen.c     |  1 -
 tests/interactive/test-cogl-primitives.c    |  6 +++---
 tests/interactive/test-cogl-tex-convert.c   |  1 -
 tests/interactive/test-cogl-tex-foreign.c   |  1 -
 tests/interactive/test-cogl-tex-getset.c    |  1 -
 tests/interactive/test-cogl-tex-polygon.c   |  1 -
 tests/interactive/test-cogl-tex-tile.c      |  1 -
 tests/interactive/test-cogl-vertex-buffer.c |  1 -
 tests/interactive/test-paint-wrapper.c      |  8 ++------
 tests/interactive/test-pixmap.c             | 34 +++++++++++++++++++++-------------
 tests/interactive/test-textures.c           |  4 ----
 11 files changed, 26 insertions(+), 33 deletions(-)

commit 94b905b9e110c671698a0cd59fa827f6ddb0a84d
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Wed Jan 19 14:33:27 2011 +0000

    build: Generate an instealled config header
    
    Clutter has some platform-specific API that is accessible only if the
    right backend has been compiled in. Third party applications that wish
    to be portable across backends might want to use defines and other
    pre-processor tricks to determine header inclusion and API usage.
    
    While Clutter has an internal set of symbols it can use, third party
    applications don't have the luxury of being able to access the config.h
    generated by Clutter's configure script.
    
    For this reason, Clutter should install a configuration header with a
    series of namespaced defines that can be picked up by applications and
    other third party code.

 .gitignore                  |  1 +
 clutter/Makefile.am         |  5 +++++
 clutter/clutter-config.h.in | 16 ++++++++++++++++
 clutter/clutter.h           |  2 ++
 configure.ac                | 30 ++++++++++++++++++++++++++++++
 5 files changed, 54 insertions(+)

commit 90a01b479c432310f9fcfb5fcd04e23d8fc1a92a
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Tue Jan 18 15:14:58 2011 +0000

    Update the NEWS file

 NEWS | 18 ++++++++++++++++++
 1 file changed, 18 insertions(+)

commit bb41cb54cbdbb21f3be26ac14c07fd1c804b4d31
Author: Chris Lord <chris@linux.intel.com>
Date:   Tue Jan 18 15:48:29 2011 +0000

    timeline: Check if the timeline is playing in do_tick
    
    Check that the timeline is still playing before executing in
    _clutter_timeline_do_tick. This fixes the possibility of receiving a
    new-frame signal when stopping a timeline in response to a different
    timeline's signal emission.

 clutter/clutter-timeline.c | 8 ++++++++
 1 file changed, 8 insertions(+)

commit c61e22d06787effcd4c260a817ba4845d5eedfdb
Author: Lucas Rocha <lucasr@litl.com>
Date:   Mon Jan 17 18:28:49 2011 +0000

    drag-action: fix case where motion events are indefinitely disabled
    
    When drag threshold is not reached, emit_drag_begin() is not called
    causing default value of priv->motion_events_enabled (false) to used to
    restore motion events enabled state in Clutter. This causes drag action
    to indefinitely disable motion events. The current value of motion
    events enabled state is now queried on button press which guarantees
    that the state will be restored with the correct value in
    emit_drag_end()
    
    http://bugzilla.clutter-project.org/show_bug.cgi?id=2522

 clutter/clutter-drag-action.c | 3 ++-
 1 file changed, 2 insertions(+), 1 deletion(-)

commit cecc7a4bfbae6dc4891f3cd1888e85fc1148dc1a
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Tue Jan 18 14:46:02 2011 +0000

    stage: Fix gtk-doc annotation for set_accept_focus()

 clutter/clutter-stage.c | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 5d8b6aa6fa2c51b72079d52766e5013ff612af19
Author: Bastian Winkler <buz@netbuz.org>
Date:   Fri Jan 14 14:53:05 2011 +0100

    introspection: Add missing (out) annotations for get_color()
    
    Some actors are missing the (out) annotations for the get_color()
    methods.
    
    http://bugzilla.clutter-project.org/show_bug.cgi?id=2518

 clutter/clutter-rectangle.c | 4 ++--
 clutter/clutter-stage.c     | 2 +-
 clutter/clutter-text.c      | 2 +-
 3 files changed, 4 insertions(+), 4 deletions(-)

commit 54d00ebaf0a0084c7b0580a7b234e214ce95dd16
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Mon Jan 17 17:30:47 2011 +0000

    docs: Add ClutterClickAction.get_state()

 doc/reference/clutter/clutter-sections.txt | 3 +++
 1 file changed, 3 insertions(+)

commit 6af7b76cb5959616ea828678e1fb0258a7a04d2d
Author: Lucas Rocha <lucasr@gnome.org>
Date:   Mon Jan 17 00:38:04 2011 +0000

    click-action: add API to get modifier type
    
    This is to allow implementing modified click such as ctrl+click,
    shift+click, and so on.
    
    http://bugzilla.clutter-project.org/show_bug.cgi?id=2520

 clutter/clutter-click-action.c | 37 +++++++++++++++++++++++++++++++++++++
 clutter/clutter-click-action.h |  6 ++++--
 2 files changed, 41 insertions(+), 2 deletions(-)

commit 6100aee5bd8d1c11fcaf6f7b3ac9a9317fbe39af
Author: Damien Lespiau <damien.lespiau@intel.com>
Date:   Mon Jan 17 15:22:48 2011 +0000

    color: Mark the new static color API as being new from 1.6
    
    The patch was written a while ago but only merged in the 1.5.x cycle.

 clutter/clutter-color.c | 2 +-
 clutter/clutter-color.h | 2 +-
 2 files changed, 2 insertions(+), 2 deletions(-)

commit ae9781e5266464314fda19ab8495e9824edbcdfb
Author: Neil Roberts <neil@linux.intel.com>
Date:   Mon Jan 17 12:21:33 2011 +0000

    cogl-program: Don't use separate definitions on GLES 1.1
    
    Previously most of the code for cogl-program and cogl-shader was
    ifdef'd out for GLES 1.1 and alternate stub definitions were
    defined. This patch removes those and instead puts #ifdef's directly
    in the functions that need it. This should make it a little bit easier
    to maintain.
    
    http://bugzilla.clutter-project.org/show_bug.cgi?id=2516

 clutter/cogl/cogl/cogl-program.c | 105 +++++++++++++--------------------------------------------------------------------------------------------
 clutter/cogl/cogl/cogl-shader.c  |  91 +++++++++++++++++++++++++++++++------------------------------------------------------------
 2 files changed, 44 insertions(+), 152 deletions(-)

commit b7677d047df6b8c96605454717873bbcb1722763
Author: Neil Roberts <neil@linux.intel.com>
Date:   Mon Jan 17 12:20:06 2011 +0000

    cogl-pipeline-opengl: #ifdef out set_glsl_program for GLES 1.1
    
    glUseProgram is not available under GLES 1.1 so it was breaking the
    build.
    
    http://bugzilla.clutter-project.org/show_bug.cgi?id=2516

 clutter/cogl/cogl/cogl-pipeline-opengl.c | 9 +++++++++
 1 file changed, 9 insertions(+)

commit 568d32acf3604a9c68556224844a839f0e014bcf
Author: Neil Roberts <neil@linux.intel.com>
Date:   Mon Jan 17 12:06:13 2011 +0000

    cogl-pipeline: Fix the enum names for the constant combine source
    
    When determining whether to hash the combine constant Cogl checks the
    arguments to the combine funcs to determine whether the combine
    constant is used. However is was using the GLenums GL_CONSTANT_COLOR
    and GL_CONSTANT_ALPHA but these are not valid values for the
    CoglPipelineCombineSource enum so presumably the constant would never
    get hashed. This patch makes it use Cogl's enum of
    COGL_PIPELINE_COMBINE_SOURCE_CONSTANT instead.
    
    http://bugzilla.clutter-project.org/show_bug.cgi?id=2516

 clutter/cogl/cogl/cogl-pipeline.c | 12 ++++++------
 1 file changed, 6 insertions(+), 6 deletions(-)

commit 0c070cdf91c2956ba057364eb63cc422a79b6c88
Author: Adel Gadllah <adel.gadllah@gmail.com>
Date:   Sun Jan 16 23:19:28 2011 +0100

    ClutterX11TexturePixmap: Fix doc comment
    
    The wrong signal name was used probably a copy & paste
    mistake, fix that.

 clutter/x11/clutter-x11-texture-pixmap.c | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 88fe56d1752ad64f404da2baa1bc74f2ebbae64c
Author: Neil Roberts <neil@linux.intel.com>
Date:   Thu Jan 13 15:54:50 2011 +0000

    cogl-buffer: Support mapping buffers for write on GLES
    
    GLES has an extension called GL_OES_mapbuffer to support mapping
    buffer objects but only for writing. Cogl now has two new feature
    flags to advertise whether mapping for reading and writing is
    supported. Under OpenGL, these features are always set if the VBO
    extension is advertised and under GLES only the write flag is set if
    the GL_OES_mapbuffer extension is advertised.

 clutter/cogl/cogl/cogl-buffer.c                             | 44 ++++++++++++++++++++------------------------
 clutter/cogl/cogl/cogl-types.h                              |  8 +++++++-
 clutter/cogl/cogl/driver/gl/cogl-feature-functions-gl.h     |  4 +++-
 clutter/cogl/cogl/driver/gles/cogl-feature-functions-gles.h | 12 ++++++++++++
 4 files changed, 42 insertions(+), 26 deletions(-)

commit 7e73f0d4232338741e2dc811cdb2039287f384bb
Author: Neil Roberts <neil@linux.intel.com>
Date:   Thu Jan 13 15:36:08 2011 +0000

    cogl: Enable the VBOs feature for GLES2
    
    The GLES2 wrapper code has been removed so there are no longer any
    problems with enabling VBOs.

 clutter/cogl/cogl/driver/gles/cogl-gles.c | 5 -----
 1 file changed, 5 deletions(-)

commit 9bb74988d5b7c7df3678185ed4488c9957f00a9d
Author: Neil Roberts <neil@linux.intel.com>
Date:   Thu Jan 13 15:35:30 2011 +0000

    cogl: Fallback to set_data when mapping a buffer to fill it
    
    In the journal code and when generating the stroke path the vertices
    are generated on the fly and stored in a CoglBuffer using
    cogl_buffer_map. However cogl_buffer_map is allowed to fail but it
    wasn't checking for a NULL return value. In particular on GLES it will
    always fail because glMapBuffer is only provided by an extension. This
    adds a new pair of internal functions called
    _cogl_buffer_{un,}map_for_fill_or_fallback which wrap
    cogl_buffer_map. If the map fails then it will instead return a
    pointer into a GByteArray attached to the context. When the buffer is
    unmapped the array is copied into the buffer using
    cogl_buffer_set_data.

 clutter/cogl/cogl/cogl-buffer-private.h | 19 ++++++++++++++++---
 clutter/cogl/cogl/cogl-buffer.c         | 51 +++++++++++++++++++++++++++++++++++++++++++++++++++
 clutter/cogl/cogl/cogl-context.c        |  5 +++++
 clutter/cogl/cogl/cogl-context.h        |  6 ++++++
 clutter/cogl/cogl/cogl-journal.c        |  5 ++---
 clutter/cogl/cogl/cogl2-path.c          |  7 +++----
 6 files changed, 83 insertions(+), 10 deletions(-)

commit 77a486caf2c130341624ab56e588ab116c7e8e26
Author: Neil Roberts <neil@linux.intel.com>
Date:   Thu Jan 13 14:12:10 2011 +0000

    cogl-context: Don't enable point sprites on GLES2
    
    On GLES2 there's no builtin mechanism to replace texture coordinates
    with point sprite coordinates so calling glEnable(GL_POINT_SPRITE)
    isn't valid. Instead the point sprite coords are implemented by using
    a special builtin varying variable in GLSL.

 clutter/cogl/cogl/cogl-context.c | 5 ++++-
 1 file changed, 4 insertions(+), 1 deletion(-)

commit 88a085fdd86e3f1f285833f2f4df19af339c339c
Author: Robert Bragg <robert@linux.intel.com>
Date:   Tue Jan 11 16:02:06 2011 +0000

    pipeline: differentiate texture target and data state
    
    There are several places where we need to compare the texture state of a
    pipeline and sometimes we need to take into consideration if the
    underlying texture has changed but other times we may only care to know
    if the texture target has changed.
    
    For example the fragends typically generate programs that they want to
    share with all pipelines with equivalent fragment processing state, and
    in this case when comparing pipelines we only care about the texture
    targets since changes to the underlying texture won't affect the
    programs generated.
    
    Prior to this we had tried to handle this by passing around some special
    flags to various functions that evaluate pipeline state to say when we
    do/don't care about the texture data, but this wasn't working in all
    cases and was more awkward to manage than the new approach.
    
    Now we simply have two state bits:
    COGL_PIPELINE_LAYER_STATE_TEXTURE_TARGET and
    COGL_PIPELINE_LAYER_STATE_TEXTURE_DATA and CoglPipelineLayer has an
    additional target member. Since all the appropriate code takes masks of
    these state bits to determine what to evaluate we don't need any extra
    magic flags.

 clutter/cogl/cogl/cogl-pipeline-fragend-arbfp.c |   9 +++----
 clutter/cogl/cogl/cogl-pipeline-fragend-fixed.c |  25 ++++++++---------
 clutter/cogl/cogl/cogl-pipeline-fragend-glsl.c  |   3 +--
 clutter/cogl/cogl/cogl-pipeline-opengl.c        |   9 ++++---
 clutter/cogl/cogl/cogl-pipeline-private.h       |  28 ++++++++-----------
 clutter/cogl/cogl/cogl-pipeline-progend-glsl.c  |   3 +--
 clutter/cogl/cogl/cogl-pipeline-vertend-glsl.c  |   3 +--
 clutter/cogl/cogl/cogl-pipeline.c               | 273 +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++--------------------------------------------------------
 8 files changed, 223 insertions(+), 130 deletions(-)

commit 8ab68d26a5c2e026bc422da13ab290ba3d432aa4
Author: Robert Bragg <robert@linux.intel.com>
Date:   Wed Jan 12 17:11:48 2011 +0000

    pipeline: optimize state init if changing property
    
    When notifying that a pipeline property is going to change, then at
    times a pipeline will take over being the authority of the corresponding
    state group. Some state groups can contain multiple properties and so to
    maintain the integrity of all of the properties we have to initialize
    all the property values in the new authority. For state groups with only
    one property we don't have to initialize anything during the
    pre_change_notify() because we can assume the value will be initialized
    as part of the change being notified.
    
    This patch optimizes how we handle this initialization of state groups
    in a couple of ways; firstly we no longer do anything to initialize
    state-groups with only one property, secondly we no longer use
    _cogl_pipeline_copy_differences - (we have a new
    _cogl_pipeline_init_multi_property_sparse_state() func) so we can avoid
    lots calls to handle_automatic_blend_enable() which is sometimes seen
    high in sysprof profiles.

 clutter/cogl/cogl/cogl-pipeline-private.h | 161 ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++-------------------------------------------
 clutter/cogl/cogl/cogl-pipeline.c         | 255 +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++--------------------------------------------------------------------
 2 files changed, 266 insertions(+), 150 deletions(-)

commit 5fc3122dadf948c5594478a3eae7deef391c62fe
Author: Neil Roberts <neil@linux.intel.com>
Date:   Wed Jan 12 16:59:37 2011 +0000

    test-cogl-shader-glsl: Disable the atlas for the hand texture
    
    Atlasing needs to be disabled for the hand texture so that it can work
    out the step value needed to fetch a neighbouring pixel in the blur
    shader. If the texture ends up in the atlas then the test can't know
    the actual size of the texture so it looks wrong.

 tests/interactive/test-cogl-shader-glsl.c | 4 +++-
 1 file changed, 3 insertions(+), 1 deletion(-)

commit 3c9f72abbfcc7967aa399506adba0bfee4952bbc
Author: Neil Roberts <neil@linux.intel.com>
Date:   Wed Jan 12 16:56:52 2011 +0000

    cogl-atlas-texture: Don't disable atlas if can't read texture data
    
    Previously atlasing would be disabled if the GL driver does not
    support reading back texture data. This meant that atlasing would not
    happen on GLES. However we also require that the driver support FBOs
    and the texture data is only read back as a fallback if the FBO
    fails. Therefore the atlas should be ok on GLES 2 which has FBO
    support in core.

 clutter/cogl/cogl/cogl-atlas-texture.c | 8 +++-----
 1 file changed, 3 insertions(+), 5 deletions(-)

commit 12ceae548d441f0611542645a62f6c0cbf7a0c5f
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Tue Jan 11 21:34:37 2011 +0000

    Post-release version bump to 1.5.13

 configure.ac       |   2 +-
 po/clutter-1.0.pot | 200 ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++------------------------------------------------------------------------------------------------
 po/de.po           | 198 +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++-----------------------------------------------------------------------------------------------
 po/fr.po           | 199 ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++-----------------------------------------------------------------------------------------------
 po/id.po           | 199 ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++-----------------------------------------------------------------------------------------------
 po/it.po           | 200 +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++-----------------------------------------------------------------------------------------------
 po/pl.po           | 200 +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++-----------------------------------------------------------------------------------------------
 po/zh_CN.po        | 199 ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++-----------------------------------------------------------------------------------------------
 8 files changed, 730 insertions(+), 667 deletions(-)

commit 09d5c309ca95f68425919fdd1a41a14f41e4053b
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Tue Jan 11 20:29:30 2011 +0000

    Release 1.5.12

 configure.ac | 23 ++++++++++++-----------
 1 file changed, 12 insertions(+), 11 deletions(-)

commit 676df42c6fefd28a6da2c1cefd885d6fa4d59da1
Author: Robert Bragg <robert@linux.intel.com>
Date:   Tue Jan 11 14:10:11 2011 +0000

    pipeline: don't skip flush if skip_gl_color flag differs
    
    We try and bail out of flushing pipeline state asap if we can see the
    pipeline has already been flushed and hasn't changed but we weren't
    checking to see if the skip_gl_color flag is the same as when it was
    last flush too and so we'd sometimes bail out without updating the
    glColor correctly.

 clutter/cogl/cogl/cogl-pipeline-opengl.c | 3 ++-
 1 file changed, 2 insertions(+), 1 deletion(-)

commit b922ac605962df6b1cf86a0e710294be114f62c4
Author: Damien Lespiau <damien.lespiau@intel.com>
Date:   Tue Jan 11 14:15:46 2011 +0000

    test-shader: Fix the edge-detect shader
    
    cogl_text_coord_in in a array to access the texture units. In this case
    we want to sample texture unit 0, where the texture is.

 tests/interactive/test-shader.c | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 38e527a3cf2527a46461eb76c6598071daf95053
Author: Neil Roberts <neil@linux.intel.com>
Date:   Mon Jan 10 20:13:41 2011 +0000

    cogl-vertex-attribute: Optionally avoid applying the legacy state
    
    When an item is added to the journal the current pipeline immediately
    gets the legacy state applied to it and the modified pipeline is
    logged instead of the original. However the actual drawing from the
    journal is done using the vertex attribute API which was also applying
    the legacy state. This meant that the legacy state used would be a
    combination of the state set when the journal entry was added as well
    as the state set when the journal is flushed. To fix this there is now
    an extra CoglDrawFlag to avoid applying the legacy state when setting
    up the GL state for the vertex attributes. The journal uses this flag
    when flushing.

 clutter/cogl/cogl/cogl-journal.c                  | 3 ++-
 clutter/cogl/cogl/cogl-vertex-attribute-private.h | 6 +++++-
 clutter/cogl/cogl/cogl-vertex-attribute.c         | 6 ++++--
 3 files changed, 11 insertions(+), 4 deletions(-)

commit cb49197d0101aa32fa3bb0f8948c1952f5ccae33
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Tue Jan 11 12:38:52 2011 +0000

    Update the NEWS file

 NEWS | 4 +++-
 1 file changed, 3 insertions(+), 1 deletion(-)

commit f4fc7284ebeaedfb60d9903b41177f59a4907b85
Author: Bastian Winkler <buz@netbuz.org>
Date:   Mon Jan 3 16:15:17 2011 +0100

    script-parser: Also honor properties of type GType
    
    The script parser should also handle GType properties.
    
    http://bugzilla.clutter-project.org/show_bug.cgi?id=2513

 clutter/clutter-script-parser.c | 9 +++++++++
 1 file changed, 9 insertions(+)

commit 8e3d9c21c643091bd537a2674eeaa86255167cc9
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Tue Jan 11 11:49:11 2011 +0000

    Update NEWS file

 NEWS | 46 ++++++++++++++++++++++++++++++++++++++++++++++
 1 file changed, 46 insertions(+)

commit f2080f099e2a05b05cd0adb2f204c1917adae0f2
Author: Damien Lespiau <damien.lespiau@intel.com>
Date:   Tue Jan 11 10:23:59 2011 +0000

    shader: Don't notify properties when finalizing shaders
    
    clutter_shader_finalize() was calling clutter_shader_release() which in
    turn notifies "compiled". GObject was complaining that we were trying to
    _ref() an object that was in _finalize().
    
     #0  g_log (log_domain=0x3e15c4 "GLib-GObject", log_level=G_LOG_LEVEL_CRITICAL,
         format=0x76c938 "%s: assertion `%s' failed") at gmessages.h:97
     #1  0x0070777d in g_return_if_fail_warning (
         log_domain=0x3e15c4 "GLib-GObject",
         pretty_function=0x3e37a4 "g_object_ref",
         expression=0x3e2a00 "object->ref_count > 0") at gmessages.c:586
     #2  0x003b862b in g_object_ref (_object=0x8567af0) at gobject.c:2615
     #3  0x003bd238 in g_object_notify_by_pspec (object=0x8567af0, pspec=0x87ea2f0)
         at gobject.c:1075
     #4  0x00b6500b in clutter_shader_release (shader=0x8567af0)
         at ./clutter-shader.c:612
     #5  0x00b659b9 in clutter_shader_finalize (object=0x8567af0)
         at ./clutter-shader.c:107
    
    Then, let's split release in two, with an _internal() version that does
    not notify "compiled" and use it from dispose (as the object is still
    usable after a call to release_internal().
    
    http://bugzilla.clutter-project.org/show_bug.cgi?id=2512

 clutter/clutter-shader.c | 61 +++++++++++++++++++++++++++++++++++++------------------------
 1 file changed, 37 insertions(+), 24 deletions(-)

commit 3625adb9d8188464b27ddf3e1203214ea2952092
Author: Tomeu Vizoso <tomeu.vizoso@collabora.co.uk>
Date:   Mon Jan 10 19:13:03 2011 +0100

    ClutterListModel: Implement get_n_rows for improved performance
    
    The default implementation in ClutterModel iterates through all
    the elements.
    
    http://bugzilla.clutter-project.org/show_bug.cgi?id=2511

 clutter/clutter-list-model.c | 13 +++++++++++++
 clutter/clutter-model.c      | 56 ++++++++++++++++++++++++++++----------------------------
 2 files changed, 41 insertions(+), 28 deletions(-)

commit 850f956d4e2a811eb663575dcd6ae41f09b992de
Author: Adel Gadllah <adel.gadllah@gmail.com>
Date:   Wed Jan 5 10:24:26 2011 +0100

    ClutterAlignConstraint: Keep pixel aligment
    
    We have to round the values here otherwise we might end up with
    misaligned actors.
    
    http://bugzilla.clutter-project.org/show_bug.cgi?id=2508

 clutter/clutter-align-constraint.c | 4 ++++
 1 file changed, 4 insertions(+)

commit d648de7d1492b9ae69aac6702a99fccb8f92b165
Author: Neil Roberts <neil@linux.intel.com>
Date:   Tue Dec 14 14:44:45 2010 +0000

    cogl-journal: Avoid enabling blending if possible
    
    The vertex attribute API assumes that if there is a color array
    enabled then we can't determine if the colors are opaque so we have to
    enable blending. The journal always uses a color array to avoid
    switching color state between rectangles. Since the journal switched
    to using vertex attributes this means we effectively always enable
    blending from the journal. To fix this there is now a new flag for
    _cogl_draw_vertex_attributes to specify that the color array is known
    to only contain opaque colors which causes the draw function not to
    copy the pipeline. If the pipeline has blending disabled then the
    journal passes this flag.
    
    http://bugzilla.clutter-project.org/show_bug.cgi?id=2481

 clutter/cogl/cogl/cogl-journal.c                  |  9 ++++++---
 clutter/cogl/cogl/cogl-vertex-attribute-private.h |  9 ++++++++-
 clutter/cogl/cogl/cogl-vertex-attribute.c         | 10 ++++++----
 3 files changed, 20 insertions(+), 8 deletions(-)

commit 159cd6ddc02b4a9a37fe7e0a61a104d3abab91a6
Author: Neil Roberts <neil@linux.intel.com>
Date:   Tue Dec 14 14:24:17 2010 +0000

    cogl-vertex-attribute: Add flags to _cogl_draw_vertex_attributes_array
    
    There is an internal version of cogl_draw_vertex_attributes_array
    which previously just bypassed the framebuffer flushing, journal
    flushing and pipeline validation so that it could be used to draw the
    journal. This patch generalises the function so that it takes a set of
    flags to specify which parts to flush. The public version of the
    function now just calls the internal version with the flags set to
    0. The '_real' version of the function has now been merged into the
    internal version of the function because it was only called in one
    place. This simplifies the code somewhat. The common code which
    flushed the various state has been moved to a separate function. The
    indexed versions of the functions have had a similar treatment.
    
    http://bugzilla.clutter-project.org/show_bug.cgi?id=2481

 clutter/cogl/cogl/cogl-journal.c                  |  17 +++++++++++++----
 clutter/cogl/cogl/cogl-primitives.c               |   6 +++++-
 clutter/cogl/cogl/cogl-vertex-attribute-private.h |  13 +++++++++++--
 clutter/cogl/cogl/cogl-vertex-attribute.c         | 167 ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++---------------------------------------------------------------------------------------------------------
 clutter/cogl/cogl/cogl2-path.c                    |  14 +++++++++-----
 5 files changed, 100 insertions(+), 117 deletions(-)

commit 0201e5fa97549ffb2d20a1180e63e5a7a73fa7e2
Author: Neil Roberts <neil@linux.intel.com>
Date:   Fri Dec 17 16:30:23 2010 +0000

    cogl: Don't assume that CoglBitmaps are allocated to height*rowstride
    
    Cogl no longer has any code that assumes the buffer in a CoglBitmap is
    allocated to the full size of height*rowstride. We should comment that
    this is the case so that we remember to keep it that way. This is
    important for cogl_texture_new_from_data because the application may
    have created the data from a sub-region of a larger image and in that
    case it's not safe to read the full rowstride of the last row when the
    sub region contains the last row of the larger image.
    
    http://bugzilla.clutter-project.org/show_bug.cgi?id=2491

 clutter/cogl/cogl/cogl-bitmap-pixbuf.c  | 60 +++++++++---------------------------------------------------
 clutter/cogl/cogl/cogl-bitmap-private.h |  8 ++++++++
 2 files changed, 17 insertions(+), 51 deletions(-)

commit e1cbef23f5118c748eb38c16ebb00de3f51686b7
Author: Neil Roberts <neil@linux.intel.com>
Date:   Fri Dec 17 16:09:26 2010 +0000

    cogl-texture-driver-gles: Don't copy the bitmap if alignment matches
    
    When uploading data for GLES we need to deal with cases where the
    rowstride is too large to be described only by GL_UNPACK_ALIGNMENT
    because there is no GL_UNPACK_ROW_LENGTH. Previously for the
    sub-region uploading code it would always copy the bitmap and for the
    code to upload the whole image it would copy the bitmap unless the
    rowstride == bpp*width. Neither paths took into account that we don't
    need to copy if the rowstride is just an alignment of bpp*width. This
    moves the bitmap copying code to a separate function that is used by
    both upload methods. It only copies the bitmap if the rowstride is not
    just an alignment of bpp*width.
    
    http://bugzilla.clutter-project.org/show_bug.cgi?id=2491

 clutter/cogl/cogl/driver/gles/cogl-texture-driver-gles.c | 103 +++++++++++++++++++++++++++++++++++++++++++++++++++++++------------------------------------------------
 1 file changed, 55 insertions(+), 48 deletions(-)

commit b3058c097dfb834018ab3598d002a7be595e78ff
Author: Neil Roberts <neil@linux.intel.com>
Date:   Fri Dec 17 16:06:10 2010 +0000

    cogl-util: Add an internal wrapper for the ffs function
    
    The ffs function is defined in C99 so if we want to use it in Cogl we
    need to provide a fallback for MSVC. This adds a configure check for
    the function and then a fallback using a while loop if it is not
    available.
    
    http://bugzilla.clutter-project.org/show_bug.cgi?id=2491

 clutter/cogl/cogl/cogl-util.c | 21 +++++++++++++++++++++
 clutter/cogl/cogl/cogl-util.h |  8 ++++++++
 configure.ac                  |  4 ++++
 3 files changed, 33 insertions(+)

commit 91c16023066b3d71ed569e0dcb97bdd0fe8b4667
Author: Neil Roberts <neil@linux.intel.com>
Date:   Fri Dec 17 14:52:25 2010 +0000

    cogl-texture: Don't use the source rowstride if we have to copy bitmap
    
    If we have to copy the bitmap to do the premultiplication then we were
    previously using the rowstride of the source image as the rowstride
    for the new image. This is wasteful if the source image is a subregion
    of a larger image which would make it use a large rowstride. If we
    have to copy the data anyway we might as well compact it to the
    smallest rowstride. This also prevents the copy from reading past the
    end of the last row of pixels.
    
    An internal function called _cogl_bitmap_copy has been added to do the
    copy. It creates a new bitmap with the smallest possible rowstride
    rounded up the nearest multiple of 4 bytes. There may be other places
    in Cogl that are currently assuming we can read height*rowstride of
    the source buffer so they may want to take advantage of this function
    too.
    
    http://bugzilla.clutter-project.org/show_bug.cgi?id=2491

 clutter/cogl/cogl/cogl-bitmap-private.h |  4 ++++
 clutter/cogl/cogl/cogl-bitmap.c         | 29 +++++++++++++++++++++++++++++
 clutter/cogl/cogl/cogl-texture.c        | 22 +---------------------
 3 files changed, 34 insertions(+), 21 deletions(-)

commit c6fbc8c567ebe7eb538e53c0a5964db4ff6aebf2
Author: Neil Roberts <neil@linux.intel.com>
Date:   Wed Dec 22 01:45:09 2010 +0000

    cogl-vertex-attribute: Fix the name of the cogl_normal_in attribute
    
    The builtin vertex attribute for the normals was incorrectly checked
    for as 'cogl_normal' however it is defined as cogl_normal_in in the
    shader boilerplate and for the name generated by CoglVertexBuffer.
    
    http://bugzilla.clutter-project.org/show_bug.cgi?id=2499

 clutter/cogl/cogl/cogl-vertex-attribute.c | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 2c36b81996565f6128a55d5c12fee75a53c0a027
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Mon Jan 10 14:03:35 2011 +0000

    container: Do not use Actor as prerequisite
    
    The prerequisite for ClutterContainer in 1.x is GObject, and we cannot
    restrict the prerequisites without an ABI break.

 clutter/clutter-container.c | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 6bb81a542fd2876c472c0287d368b1ba404324bf
Author: nobled <nobled@dreamwidth.org>
Date:   Tue Jan 4 13:56:05 2011 +0000

    egl: Fix build for --with-flavour=opengl-egl-xlib
    
    Make sure the EGL backend doesn't forget to include desktop OpenGL headers.

 clutter/egl/clutter-egl-headers.h | 20 +++++++++++++-------
 1 file changed, 13 insertions(+), 7 deletions(-)

commit 530bc2aa70ca83c56f46342d337ce873614353a4
Author: nobled <nobled@dreamwidth.org>
Date:   Tue Jan 4 13:59:48 2011 +0000

    egl: Don't use obsolete API
    
    Fixes a GCC "implicit declaration of function" warning when compiling.

 clutter/egl/clutter-stage-egl.c | 4 ++--
 1 file changed, 2 insertions(+), 2 deletions(-)

commit 8c23766da809701bc171fcb9b3650475b1d03a73
Author: Kristian Høgsberg <krh@bitplanet.net>
Date:   Thu Jan 6 07:57:26 2011 -0500

    x11: Create the list of all devices correctly
    
    Linked lists are tricky.

 clutter/x11/clutter-device-manager-x11.c | 4 ++--
 1 file changed, 2 insertions(+), 2 deletions(-)

commit bf0dd2cbcc83d91ef46301aa18bd5f0158b88d22
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Thu Dec 30 12:49:41 2010 +0000

    test-text-field: Grab key focus on the first entry
    
    So that you can start typing right away.

 tests/interactive/test-text-field.c | 6 ++++--
 1 file changed, 4 insertions(+), 2 deletions(-)

commit 2fe20ff3c505d3c1249b03ba7eaa1515f13a3c0a
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Tue Dec 28 22:21:09 2010 +0000

    osx: Implement the set_accept_focus() vfunc
    
    Like the x11 and win32 backends, the quartz backend should allow setting
    the key focus when showing the stage window.

 clutter/osx/clutter-stage-osx.c | 29 +++++++++++++++++++++++------
 clutter/osx/clutter-stage-osx.h |  2 ++
 2 files changed, 25 insertions(+), 6 deletions(-)

commit 9d6a33d0c835e8a91e42303886123e34e60576f5
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Tue Dec 28 18:04:00 2010 +0000

    win32: Implement the set_accept_focus() vfunc
    
    Implement the ClutterStageWindow::set_accept_focus() virtual function in
    the win32 backend.
    
    If accept_focus is set to be TRUE then we call SetforegroundWindow()
    after calling ShowWindow(). This is similar to what GDK does when
    dealing with the same situation.
    
    http://bugzilla.clutter-project.org/show_bug.cgi?id=2500

 clutter/win32/clutter-stage-win32.c | 21 +++++++++++++++++++--
 clutter/win32/clutter-stage-win32.h |  8 +++++---
 2 files changed, 24 insertions(+), 5 deletions(-)

commit 497f39e2f40e816c1e7ceaa3bf2fb4e609436b35
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Tue Dec 28 17:38:39 2010 +0000

    x11: Implement the set_accept_focus() vfunc
    
    Actually set the InputHint flag and set the input field of the WM_SPEC
    hints depending on the value of the accept-focus bitfield.
    
    http://bugzilla.clutter-project.org/show_bug.cgi?id=2500

 clutter/x11/clutter-stage-x11.c | 20 ++++++++++++++++----
 clutter/x11/clutter-stage-x11.h |  1 +
 2 files changed, 17 insertions(+), 4 deletions(-)

commit bbede9fef579000a48309bec017303bd8c46ccae
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Tue Dec 28 17:37:18 2010 +0000

    stage: Add :accept-focus property and accessors
    
    Allow the developer to set whether the Stage should receive key focus
    when mapped. The implementation is fully backend-dependent. The default
    value is TRUE because that's what we've been expecting so far.
    
    http://bugzilla.clutter-project.org/show_bug.cgi?id=2500

 clutter/clutter-stage.c                    | 67 ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++-
 clutter/clutter-stage.h                    |  4 ++++
 doc/reference/clutter/clutter-sections.txt |  2 ++
 3 files changed, 72 insertions(+), 1 deletion(-)

commit e1cd6f49b2afcb1738ee2e95f03aa77b8c696e7b
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Tue Dec 28 17:36:27 2010 +0000

    stage-window: Add set_accept_focus() vfunc
    
    Allow Stage implementations to set whether or not they want to accept
    key focus when being shown.
    
    http://bugzilla.clutter-project.org/show_bug.cgi?id=2500

 clutter/clutter-stage-window.c | 12 ++++++++++++
 clutter/clutter-stage-window.h |  6 ++++++
 2 files changed, 18 insertions(+)

commit 601b958ab1b162176c7dde318a96f279be995e64
Author: Johan Bilien <jobi@via.ecp.fr>
Date:   Wed Dec 29 16:49:13 2010 -0500

    Fixed a crash when destroying the actor of a LEAVE event
    
    When processing a LEAVE event, one might destroy the actor, so the weak
    reference device->actor would be NULL.
    
    http://bugzilla.clutter-project.org/show_bug.cgi?id=2502
    
    Signed-off-by: Emmanuele Bassi <ebassi@linux.intel.com>

 clutter/clutter-input-device.c | 14 +++++++++-----
 1 file changed, 9 insertions(+), 5 deletions(-)

commit 2911d3db535db98f7c0352e3ea40f2a7e65d82ea
Author: Nguyễn Thái Ngọc Duy <pclouds@gmail.com>
Date:   Thu Dec 30 08:16:10 2010 +0700

    autogen.sh: make autoreconf use automake-1.11 when available
    
    This patch exports $ACLOCAL and $AUTOMAKE, otherwise autoreconf
    may use an older version instead.
    
    Signed-off-by: Nguyễn Thái Ngọc Duy <pclouds@gmail.com>
    
    http://bugzilla.clutter-project.org/show_bug.cgi?id=2504

 autogen.sh | 1 +
 1 file changed, 1 insertion(+)

commit c95cc8d477ab26fd6231becdd062a81fa7ee6115
Author: Johan Bilien <jobi@via.ecp.fr>
Date:   Wed Dec 29 16:57:02 2010 -0500

    Only reset the relayout_pending flag when actually doing a relayout
    
    If an actor is (unfortunately) queuing a relayout in relayout, you would
    end up with (ClutterActor*)stage->needs_allocation set to TRUE and
    stage->relayout_pending set to TRUE. But if then in the same cycle, an
    actor calls clutter_actor_get_allocation_box, that will trigger another
    (recursive) _clutter_stage_maybe_relayout, which will wrongly reset the
    relayout pending to FALSE, while not actually performing a new relayout
    because of the re-entrancy protection.
    
    http://bugzilla.clutter-project.org/show_bug.cgi?id=2503

 clutter/clutter-stage.c | 3 ++-
 1 file changed, 2 insertions(+), 1 deletion(-)

commit b6558c5a1848b306c26813bc5f5015eb95c541d1
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Wed Dec 22 09:42:41 2010 +0000

    docs: Fixes for the Cogl API reference

 clutter/cogl/cogl/cogl-bitmap.h          |  4 ++--
 clutter/cogl/cogl/cogl-buffer.h          |  8 ++++----
 clutter/cogl/cogl/cogl-index-array.h     |  2 +-
 clutter/cogl/cogl/cogl-material-compat.h | 11 ++++++-----
 clutter/cogl/cogl/cogl-object.h          | 19 ++++++++++---------
 clutter/cogl/cogl/cogl-path.h            |  8 ++++----
 clutter/cogl/cogl/cogl-pipeline.h        |  2 +-
 clutter/cogl/cogl/cogl-types.h           |  4 ++--
 clutter/cogl/cogl/cogl-vertex-array.h    |  2 +-
 clutter/cogl/cogl/cogl-vertex-buffer.h   |  2 +-
 doc/reference/cogl/cogl-sections.txt     | 39 +++++++++++++++++++++++++++++++++++----
 11 files changed, 67 insertions(+), 34 deletions(-)

commit 533880a1a5140d507db0f1a11d211c74ee0260f6
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Tue Dec 21 12:03:38 2010 +0000

    build: Ignore private headers when building the Cogl reference
    
    Otherwise gtk-doc will try to look up private symbols.

 doc/reference/cogl/Makefile.am | 22 +++++++++++++++++-----
 1 file changed, 17 insertions(+), 5 deletions(-)

commit 91cc8edba12c0e43ba69b055e5b46394b9d51917
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Tue Dec 21 10:51:39 2010 +0000

    test-text-field: Do not expand the labels

 tests/interactive/test-text-field.c | 6 ++----
 1 file changed, 2 insertions(+), 4 deletions(-)

commit 605e8d6fb50624b44b45f012b24cea7c302f78ea
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Tue Dec 21 10:50:24 2010 +0000

    text: Only paint cursor if we have key focus
    
    If a Text actor does not have key focus then there's no point in showing
    the cursor at all.

 clutter/clutter-text.c | 26 +++++++++++++++++++++++++-
 1 file changed, 25 insertions(+), 1 deletion(-)

commit ec5e910cd376050bdd184cf970fa565e10764525
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Mon Dec 20 17:59:35 2010 +0000

    test-text-field: Clean up
    
    Use a Table layout manager, and clean up a bit this test case.

 tests/interactive/test-text-field.c | 96 ++++++++++++++++++++++++++++++++++++++++++++++++++++++++----------------------------------------
 1 file changed, 56 insertions(+), 40 deletions(-)

commit 21a12b966dbf72d2e83265399ac8d380b281df7f
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Mon Dec 20 12:41:07 2010 +0000

    interactive: Remove test-bind
    
    The BindConstraint is already exercised in the test-constraints and in
    other interactive tests.

 tests/interactive/Makefile.am |   1 -
 tests/interactive/test-bind.c | 112 ----------------------------------------------------------------------------------------------------------------
 2 files changed, 113 deletions(-)

commit b9f7ef11100f250767fd726b0ae9727a7e9a3f89
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Sat Dec 18 21:33:37 2010 +0000

    build: Remove Cogl2 reference from the build scripts
    
    Keeping the Cogl 2.0 API reference in the build is getting far more
    troublesome than it's worth.
    
    It's breaking distcheck far too often, and it makes it impossible to
    rebuild the build environment from tarballs - which is something that
    some distributions (namely: the Debian-based ones, but not limited to
    them) do in order to change build scripts using their own rules.

 configure.ac              | 16 ----------------
 doc/reference/Makefile.am |  6 ------
 2 files changed, 22 deletions(-)

commit 491bbc226ee52546507406714030a9647dde4280
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Sat Dec 18 13:24:54 2010 +0000

    constraints: Remove signal handlers on dispose
    
    Same as commit 2fa8b3a3abc7bb8e96a85d927edc0594f44f55df but done for
    AlignConstraint and SnapConstraint as well.

 clutter/clutter-align-constraint.c | 24 +++++++++++++++++++++---
 clutter/clutter-bind-constraint.c  |  4 ++--
 clutter/clutter-snap-constraint.c  | 29 +++++++++++++++++++++++------
 3 files changed, 46 insertions(+), 11 deletions(-)

commit 2fa8b3a3abc7bb8e96a85d927edc0594f44f55df
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Sat Dec 18 13:16:23 2010 +0000

    bind-constraint: Remove handlers in dispose
    
    We should remove the signal handlers on the source actor when a
    BindConstraint is disposed, to avoid dangling pointers and wrong
    invocations.
    
    http://bugzilla.clutter-project.org/show_bug.cgi?id=2493

 clutter/clutter-bind-constraint.c | 20 ++++++++++++++++++++
 1 file changed, 20 insertions(+)

commit 45c884307e5946e316c839c03d94c5f5c92147d8
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Fri Dec 17 16:04:25 2010 +0000

    Post-release version bump to 1.5.11

 configure.ac       |   2 +-
 po/clutter-1.0.pot | 104 ++++++++++++++++++++++++++++++++++++++++++++++++++++----------------------------------------------------
 po/de.po           | 102 +++++++++++++++++++++++++++++++++++++++++++++++++++---------------------------------------------------
 po/fr.po           | 102 +++++++++++++++++++++++++++++++++++++++++++++++++++---------------------------------------------------
 po/id.po           | 102 +++++++++++++++++++++++++++++++++++++++++++++++++++---------------------------------------------------
 po/it.po           | 102 +++++++++++++++++++++++++++++++++++++++++++++++++++---------------------------------------------------
 po/pl.po           | 102 +++++++++++++++++++++++++++++++++++++++++++++++++++---------------------------------------------------
 po/zh_CN.po        | 102 +++++++++++++++++++++++++++++++++++++++++++++++++++---------------------------------------------------
 8 files changed, 359 insertions(+), 359 deletions(-)

commit 339a6805521c04fd9e0d43689b6f380a45404078
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Fri Dec 17 14:40:17 2010 +0000

    Release Clutter 1.5.10 (snapshot)

 NEWS         | 11 +++++++++--
 configure.ac |  2 +-
 2 files changed, 10 insertions(+), 3 deletions(-)

commit 987a50be91f67a64cca32e7403b98c69b5aedb4c
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Fri Dec 17 15:43:24 2010 +0000

    build: Fix release-check for cogl2 reference

 configure.ac              | 10 ++++++++--
 doc/reference/Makefile.am |  7 ++-----
 2 files changed, 10 insertions(+), 7 deletions(-)

commit cab4a5b4846d2e6e1800ac545020bce930a9132e
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Fri Dec 17 14:41:33 2010 +0000

    build: Remove stringify.sh from Makefile.am

 build/Makefile.am | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 894c0527dffc4d0c01ef87880d33b02fcfab923e
Author: Elliot Smith <elliot.smith@intel.com>
Date:   Wed Dec 15 13:31:12 2010 +0000

    cookbook: Proofing for "box layout" recipe
    
    General improvements to readability, formatting, fixing
    typos etc.

 doc/cookbook/layouts.xml | 67 ++++++++++++++++++++++++++++++++++++-------------------------------
 1 file changed, 36 insertions(+), 31 deletions(-)

commit accdd92110baffe886ab9bcc9dc263058d159ecc
Author: Elliot Smith <elliot.smith@intel.com>
Date:   Wed Dec 15 13:13:28 2010 +0000

    cookbook: Add examples and more text for "box layout" recipe
    
    Added 3 examples for the box layout recipe:
    1) Simple box layout demonstrating how to set actor properties
    2) Trivial menu implementation using box layout
    3) Demonstration app which enables tweaking and testing
       of layout property interactions
    
    Also inlined example 1 in the solution section and added
    more explanatory text in the discussion.

 doc/cookbook/examples/Makefile.am                    |   6 +++
 doc/cookbook/examples/layouts-box-menu.c             | 151 ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
 doc/cookbook/examples/layouts-box-property-effects.c | 465 ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
 doc/cookbook/examples/layouts-box.c                  |  95 +++++++++++++++++++++++++++++++++++++
 doc/cookbook/images/layouts-box.png                  | Bin 0 -> 1515 bytes
 doc/cookbook/layouts.xml                             | 134 ++++++++++++++++++++++++++++++++++++++++++++++++----
 6 files changed, 841 insertions(+), 10 deletions(-)

commit 77aacd185dcdd1673e1c3fb058d93a5803febe6a
Author: Elliot Smith <elliot.smith@intel.com>
Date:   Tue Dec 14 18:08:28 2010 +0000

    cookbook: Add initial skeleton for box layout recipe
    
    Created recipe and first draft content for recipe
    about ClutterBoxLayout.

 doc/cookbook/layouts.xml | 264 ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
 1 file changed, 264 insertions(+)

commit 6c244c05497237ee2640d3d4cf7cd3d00baf469f
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Fri Dec 17 13:53:28 2010 +0000

    geometry: Avoid sign issues when interpolating
    
    Width and height in ClutterGeometry are unsigned, and this might lead to
    overflow and wrap around issues.

 clutter/clutter-actor.c | 8 ++++++--
 1 file changed, 6 insertions(+), 2 deletions(-)

commit c3313726f0c6911eee8709a15fe51ec0421d7422
Author: Alexandre Quessy <alexandre@quessy.net>
Date:   Tue Dec 14 17:45:45 2010 -0500

    Fixed a typo in a doc string
    
    http://bugzilla.clutter-project.org/show_bug.cgi?id=2485

 clutter/clutter-deform-effect.c | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 140f818fb14181135891b06bde54649564f0bc07
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Fri Dec 17 12:07:06 2010 +0000

    Update NEWS

 NEWS | 5 +++++
 1 file changed, 5 insertions(+)

commit c444447cd3712153127f4fdd2ac03262ec7689d2
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Fri Dec 17 12:04:11 2010 +0000

    timeline: Rename the reverse property to auto-reverse
    
    Other frameworks expose the same functionality as "auto-reverse",
    probably to match the cassette tape player. It actually makes sense
    for Clutter to follow suit.

 clutter/clutter-timeline.c                           | 57 ++++++++++++++++++++++++++++-----------------------------
 clutter/clutter-timeline.h                           |  4 ++--
 doc/cookbook/animations.xml                          |  4 ++--
 doc/cookbook/examples/animations-looping-implicit.c  |  2 +-
 doc/reference/clutter/clutter-sections.txt           |  4 ++--
 doc/reference/clutter/migrating-ClutterBehaviour.xml |  2 +-
 tests/interactive/test-behave.c                      |  2 +-
 tests/interactive/test-layout.c                      |  2 +-
 tests/interactive/test-threads.c                     |  1 +
 9 files changed, 39 insertions(+), 39 deletions(-)

commit 397e0ddb166097ae9a281c70bbff49196e513c5b
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Thu Dec 16 15:30:53 2010 +0000

    interactive: Rename test-rotate
    
    The rotation test is now really testing the shader-based effects we ship
    with Clutter. The name should be changed to reflect that.

 tests/interactive/Makefile.am                              | 2 +-
 tests/interactive/{test-rotate.c => test-shader-effects.c} | 2 +-
 2 files changed, 2 insertions(+), 2 deletions(-)

commit c2365c63cfd2d9e0c6116a39c7a50defc193c482
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Thu Dec 16 15:25:29 2010 +0000

    interactive: Remove test-viewport
    
    The test-viewport interactive test is exercising the clip code - a job
    better done by the conformance test suite and by the test-clip
    interactive test.

 tests/interactive/Makefile.am     |  1 -
 tests/interactive/test-viewport.c | 69 ---------------------------------------------------------------------
 2 files changed, 70 deletions(-)

commit 1515a9f98971c813d50a4c0004eb49c597fc3144
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Thu Dec 16 15:10:27 2010 +0000

    interactive: Remove test-project
    
    The test-project test case was an old test that was barely working after
    landing the size allocation API in Clutter 0.8. It has never been fixed,
    and it's been of relative use ever since.

 tests/interactive/Makefile.am    |   1 -
 tests/interactive/test-project.c | 229 ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
 2 files changed, 230 deletions(-)

commit 8ae47eb79c0c67faaf8c594aa7e8e2560abc358e
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Thu Dec 16 15:08:11 2010 +0000

    interactive: Remove test-offscreen
    
    The test-offscreen interactive test was a dummy test for the
    ClutterStage:offscreen property, which has been deprecated and
    not implemented since Clutter 1.0, and never really worked except
    briefly in Clutter 0.2 or something.

 tests/interactive/Makefile.am      |  1 -
 tests/interactive/test-offscreen.c | 32 --------------------------------
 2 files changed, 33 deletions(-)

commit faaff037306be31b69fa255b8d3dae91b341256b
Author: Neil Roberts <neil@linux.intel.com>
Date:   Mon Dec 13 17:21:58 2010 +0000

    clutter-stage: Don't always set the projection and viewport matrix
    
    The stage has a dirty flag to record whenever the viewport and
    projection matrices need to be flushed. However after flushing these
    the flags were never cleared so it would always redundantly update the
    state.
    
    http://bugzilla.clutter-project.org/show_bug.cgi?id=2480

 clutter/clutter-stage.c | 8 +++++++-
 1 file changed, 7 insertions(+), 1 deletion(-)

commit f5954339427f19e3c7332ec10d8cfd43c073d724
Author: Neil Roberts <neil@linux.intel.com>
Date:   Tue Dec 14 13:02:47 2010 +0000

    cogl-pipeline-fragend-arbfp: Generate ARBfp if user vertex shader
    
    The ARBfp fragend was bypassing generating a shader if the pipeline
    contains a user program. However it shouldn't do this if the pipeline
    only contains a vertex shader. This was breaking
    test-cogl-just-vertex-shader.

 clutter/cogl/cogl/cogl-pipeline-fragend-arbfp.c | 17 +++++++++++++----
 1 file changed, 13 insertions(+), 4 deletions(-)

commit 52442414d953e90930d3928e81216e0f3ac194fe
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Fri Dec 10 17:46:58 2010 +0000

    cally: Allow memory management for actions
    
    Adding an action should allow passing a user data pointer, and have a
    notification action that gets called when removing the action. This
    allows introspection and language bindings to attach custom data to the
    action - for instance, the real callable object that should be invoked.
    
    http://bugzilla.clutter-project.org/show_bug.cgi?id=2479

 clutter/cally/cally-actor.c | 94 +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++-------------------------------
 clutter/cally/cally-actor.h | 47 ++++++++++++++++++++++++++++++++++-------------
 2 files changed, 97 insertions(+), 44 deletions(-)

commit def14e80cbb898c6c198a5caf3a2a3ad15d5e8e1
Author: Mike Owens <mike@filespanker.com>
Date:   Thu Dec 9 09:39:23 2010 -0500

    ClutterText: Only grab keyboard focus if keyboard-interactive.
    
    Previously, ClutterText took keyboard focus on mouse-down, regardless
    if it were editable or selectable.  Now it checks these properties,
    and behaves like other actors if it can't do anything useful with
    the focus.
    
    http://bugzilla.clutter-project.org/show_bug.cgi?id=2462

 clutter/clutter-text.c | 5 +++--
 1 file changed, 3 insertions(+), 2 deletions(-)

commit 7b985f034fae95862f0c080a6311ccf0ac4f3966
Author: Neil Roberts <neil@linux.intel.com>
Date:   Sat Nov 27 13:15:02 2010 +0000

    Allow multiple CoglAtlases for textures
    
    Previously Cogl would only ever use one atlas for textures and if it
    reached the maximum texture size then all other new textures would get
    their own GL texture. This patch makes it so that we create as many
    atlases as needed. This should avoid breaking up some batches and it
    will be particularly good if we switch to always using multi-texturing
    with a default shader that selects between multiple atlases using a
    vertex attribute.
    
    Whenever a new atlas is created it is stored in a GSList on the
    context. A weak weference is taken on the atlas using
    cogl_object_set_user_data so that it can be removed from the list when
    the atlas is destroyed. The atlas textures themselves take a reference
    to the atlas and this is the only thing that keeps the atlas
    alive. This means that once the atlas becomes empty it will
    automatically be destroyed.
    
    All of the COGL_NOTEs pertaining to atlases are now prefixed with the
    atlas pointer to make it clearer which atlas is changing.

 clutter/cogl/cogl/cogl-atlas-texture-private.h |  10 ++++------
 clutter/cogl/cogl/cogl-atlas-texture.c         | 105 +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++--------------------------------
 clutter/cogl/cogl/cogl-atlas.c                 |  19 ++++++++++++-------
 clutter/cogl/cogl/cogl-atlas.h                 |   3 ---
 clutter/cogl/cogl/cogl-context.c               |   5 ++---
 clutter/cogl/cogl/cogl-context.h               |   2 +-
 clutter/cogl/pango/cogl-pango-glyph-cache.c    |   1 +
 7 files changed, 93 insertions(+), 52 deletions(-)

commit d01a70762395d7ff353df1fb77397b4dfab284cf
Author: Neil Roberts <neil@linux.intel.com>
Date:   Sat Nov 27 13:06:38 2010 +0000

    cogl-atlas: Convert to be a CoglObject subclass
    
    To implement multiple atlases it will be useful to have ref-counting
    on the CoglAtlas so it makes sense to convert it to be a CoglObject.

 clutter/cogl/cogl/cogl-atlas.c              | 10 ++++++++--
 clutter/cogl/cogl/cogl-atlas.h              |  8 +++++---
 clutter/cogl/cogl/cogl-context.c            |  2 +-
 clutter/cogl/pango/cogl-pango-glyph-cache.c |  4 ++--
 4 files changed, 16 insertions(+), 8 deletions(-)

commit d03c3a646ae4d26358ad5a48fe320845f7f099ed
Author: Neil Roberts <neil@linux.intel.com>
Date:   Tue Dec 7 13:58:46 2010 +0000

    test-cogl-just-vertex-shader: Update to use the portable cogl_* names
    
    The vertex shader in this test now uses the cogl_* names for the GL
    builtin so that it will work on GLES2 as well.

 tests/conform/test-cogl-just-vertex-shader.c | 6 ++++--
 1 file changed, 4 insertions(+), 2 deletions(-)

commit d1ddca4eeecf26df9c5a707ef5f88175d90feb34
Author: Neil Roberts <neil@linux.intel.com>
Date:   Tue Dec 7 13:44:45 2010 +0000

    cogl-shader-boilerplate: Add the 3D texture extension on GLES2
    
    To use the 3D texture extension on GLES2 it has to be enabled with the
    following line in GLSL:
    
    #extension GL_OES_texture_3D : enable

 clutter/cogl/cogl/cogl-shader.c | 14 ++++++++++++--
 1 file changed, 12 insertions(+), 2 deletions(-)

commit e0a02b2b5bc4ef88e8829d271380148a966e8494
Author: Neil Roberts <neil@linux.intel.com>
Date:   Tue Dec 7 12:49:00 2010 +0000

    test-cogl-multitexture: Don't test the alpha component
    
    On EGL we don't request a context with any alpha bits so testing alpha
    component of cogl_read_pixels isn't reliable.

 tests/conform/test-cogl-multitexture.c | 3 +--
 1 file changed, 1 insertion(+), 2 deletions(-)

commit afe39296180e3839c42c5327f55ff8a773ba7000
Author: Neil Roberts <neil@linux.intel.com>
Date:   Tue Dec 7 11:39:37 2010 +0000

    test-cogl-materials: Use GL_MAX_VERTEX_ATTRIBS on GLES2
    
    When determining the maximum number of layers we also need to take
    into account GL_MAX_VERTEX_ATTRIBS on GLES2. Cogl needs one vertex
    attrib for each texture unit plus two for the position and color.

 tests/conform/test-cogl-materials.c | 22 +++++++++++++++-------
 1 file changed, 15 insertions(+), 7 deletions(-)

commit bdeb555ae1e440de0453cd8fd4a024ba8381016f
Author: Neil Roberts <neil@linux.intel.com>
Date:   Tue Dec 7 10:38:51 2010 +0000

    cogl2-path: Don't flush the enable flags
    
    All of the drawing needed in _cogl_add_path_to_stencil_buffer is done
    with the vertex attribute API so there should be no need to flush the
    enable flags to enable the vertex array. This was causing problems on
    GLES2 where the vertex array isn't available.

 clutter/cogl/cogl/cogl2-path.c | 5 -----
 1 file changed, 5 deletions(-)

commit 7dc4b3c8947de12ca111edba52a9387287f97a82
Author: Neil Roberts <neil@linux.intel.com>
Date:   Sun Dec 5 18:02:05 2010 +0000

    Remove the GLES2 wrapper
    
    The GLES2 wrapper is no longer needed because the shader generation is
    done within the GLSL fragend and vertend and any functions that are
    different for GLES2 are now guarded by #ifdefs.

 build/stringify.sh                                          |  94 -----------------
 clutter/cogl/cogl/Makefile.am                               |  20 ----
 clutter/cogl/cogl/cogl-atlas.c                              |   6 +-
 clutter/cogl/cogl/cogl-buffer.c                             |   4 -
 clutter/cogl/cogl/cogl-clip-stack.c                         |  13 ++-
 clutter/cogl/cogl/cogl-context.c                            |   6 +-
 clutter/cogl/cogl/cogl-framebuffer.c                        |   6 +-
 clutter/cogl/cogl/cogl-pipeline-fragend-arbfp.c             |   4 -
 clutter/cogl/cogl/cogl-pipeline-fragend-glsl.c              |   4 -
 clutter/cogl/cogl/cogl-pipeline-opengl.c                    |  16 ++-
 clutter/cogl/cogl/cogl-pipeline-progend-glsl.c              |  34 +-----
 clutter/cogl/cogl/cogl-pipeline-vertend-glsl.c              |  24 +++++
 clutter/cogl/cogl/cogl-pixel-array.c                        |   4 -
 clutter/cogl/cogl/cogl-texture-2d.c                         |   2 +
 clutter/cogl/cogl/cogl-texture-3d.c                         |   2 +
 clutter/cogl/cogl/cogl-vertex-attribute.c                   |   1 -
 clutter/cogl/cogl/cogl.c                                    |  16 ++-
 clutter/cogl/cogl/driver/gles/cogl-context-driver-gles.c    |   6 --
 clutter/cogl/cogl/driver/gles/cogl-context-driver-gles.h    |   4 -
 clutter/cogl/cogl/driver/gles/cogl-fixed-vertex-shader.glsl |  73 -------------
 clutter/cogl/cogl/driver/gles/cogl-gles.c                   |   4 +
 clutter/cogl/cogl/driver/gles/cogl-gles2-wrapper.c          | 993 ---------------------------------------------------------------------------------------------------------------------------------------------------------------------------
 clutter/cogl/cogl/driver/gles/cogl-gles2-wrapper.h          | 388 -------------------------------------------------------------------
 clutter/cogl/cogl/driver/gles/cogl-texture-driver-gles.c    |   6 +-
 24 files changed, 81 insertions(+), 1649 deletions(-)

commit 1999bee5d2d5d14a97eacb84edb6ce364202b082
Author: Neil Roberts <neil@linux.intel.com>
Date:   Mon Dec 6 21:29:56 2010 +0000

    cogl-pipeline: Use enums for the layer combine values
    
    Once the GLES2 wrapper is removed then we won't have the GLenums
    needed for setting up the layer combine state. This adds Cogl enums
    instead which have the same values as the corresponding GLenums. The
    enums are:
    
    CoglPipelineCombineFunc
    CoglPipelineCombineSource
     and
    CoglPipelineCombineOp

 clutter/cogl/cogl/cogl-pipeline-fragend-arbfp.c |  41 +++++++++++++++++++++--------------------
 clutter/cogl/cogl/cogl-pipeline-fragend-glsl.c  |  48 ++++++++++++++++++++++++++----------------------
 clutter/cogl/cogl/cogl-pipeline-private.h       |  46 +++++++++++++++++++++++++++++++++++++++-------
 clutter/cogl/cogl/cogl-pipeline.c               | 107 ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++---------------------------------------------
 4 files changed, 148 insertions(+), 94 deletions(-)

commit 271acaaae5d9e698ed1eefb201b2fa49b7bb3d2d
Author: Neil Roberts <neil@linux.intel.com>
Date:   Mon Dec 6 12:31:51 2010 +0000

    cogl: upload matrices with uniforms on GLES2
    
    Once the GLES2 wrapper is removed we won't be able to upload the
    matrices with the fixed function API any more. The fixed function API
    gives a global state for setting the matrix but if a custom shader
    uniform is used for the matrices then the state is per
    program. _cogl_matrix_stack_flush_to_gl is called in a few places and
    it is assumed the current pipeline doesn't need to be flushed before
    it is called. To allow these semantics to continue to work, on GLES2
    the matrix flush now just stores a reference to the matrix stack in
    the CoglContext. A pre_paint virtual is added to the progend which is
    called whenever a pipeline is flushed, even if the same pipeline was
    flushed already. This gives the GLSL progend a chance to upload the
    matrices to the uniforms. The combined modelview/projection matrix is
    only calculated if it is used. The generated programs end up never
    using the modelview or projection matrix so it usually only has to
    upload the combined matrix. When a matrix stack is flushed a reference
    is taked to it by the pipeline progend and the age is stored so that
    if the same state is used with the same program again then we don't
    need to reupload the uniform.

 clutter/cogl/cogl/cogl-context.c                   |  12 +++++++++
 clutter/cogl/cogl/cogl-context.h                   |  10 ++++++++
 clutter/cogl/cogl/cogl-matrix-stack.c              | 127 ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++---------------------
 clutter/cogl/cogl/cogl-matrix-stack.h              |  10 ++++++++
 clutter/cogl/cogl/cogl-pipeline-opengl.c           |   7 ++++++
 clutter/cogl/cogl/cogl-pipeline-private.h          |   4 +++
 clutter/cogl/cogl/cogl-pipeline-progend-glsl.c     | 250 +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++-
 clutter/cogl/cogl/cogl-pipeline-vertend-glsl.c     |   4 +++
 clutter/cogl/cogl/driver/gles/cogl-gles2-wrapper.c |   2 ++
 9 files changed, 396 insertions(+), 30 deletions(-)

commit 67847260bca8ef313650497050e284a1971918aa
Author: Neil Roberts <neil@linux.intel.com>
Date:   Fri Dec 10 17:42:39 2010 +0000

    cogl-matrix-stack: Add _cogl_matrix_stack_has_identity_flag
    
    This adds an internal function to quickly determine whether the top of
    the matrix stack is known to be the identity matrix.

 clutter/cogl/cogl/cogl-matrix-stack.c | 6 ++++++
 clutter/cogl/cogl/cogl-matrix-stack.h | 7 +++++++
 2 files changed, 13 insertions(+)

commit 016005591dfa765255b05d96f701497ed7a59d23
Author: Neil Roberts <neil@linux.intel.com>
Date:   Fri Dec 10 16:06:16 2010 +0000

    cogl-matrix-stack: Convert to be a CoglObject
    
    We will want to use ref-counting on the CoglMatrixStack so it might as
    well be a CoglObject.

 clutter/cogl/cogl/cogl-framebuffer.c     |  4 ++--
 clutter/cogl/cogl/cogl-matrix-stack.c    | 13 ++++++++++---
 clutter/cogl/cogl/cogl-matrix-stack.h    |  3 ---
 clutter/cogl/cogl/cogl-pipeline-opengl.c |  2 +-
 4 files changed, 13 insertions(+), 9 deletions(-)

commit 58a22613877fc041549eddeafbc364d369c5e445
Author: Robert Bragg <robert@linux.intel.com>
Date:   Fri Dec 10 11:34:02 2010 +0000

    matrix-stack: Make header style consistent
    
    Cogl doesn't follow the Clutter/GTK+ columnized function prototype style
    so this updates cogl-matrix-stack.h to match the other Cogl headers.

 clutter/cogl/cogl/cogl-matrix-stack.c |   2 +-
 clutter/cogl/cogl/cogl-matrix-stack.h | 126 +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++---------------------------------------------------
 2 files changed, 76 insertions(+), 52 deletions(-)

commit 4976d229405c7010a6ef1e621bcfb581b7eff99a
Author: Robert Bragg <robert@linux.intel.com>
Date:   Fri Dec 10 11:13:09 2010 +0000

    matrix-stack: Adds a stack age counter
    
    Sometimes it would be useful if we could efficiently track when a matrix
    stack has been modified. For example on GLES2 we have to upload the
    modelview as a uniform to our glsl programs but because the modelview
    state is part of the framebuffer state it becomes a bit more tricky to
    know when to re-sync the value of the uniform with the framebuffer
    state. This adds an "age" counter to CoglMatrixStack which is
    incremented for any operation that effectively modifies the top of the
    stack so now we can save the age of the stack inside the pipeline
    whenever we update modelview uniform and later compare that with the
    stack to determine if it has changed.

 clutter/cogl/cogl/cogl-matrix-stack.c | 18 ++++++++++++++++++
 clutter/cogl/cogl/cogl-matrix-stack.h |  2 ++
 2 files changed, 20 insertions(+)

commit 856d43a27cd4090467de08cd5738f10ec7e06ebd
Author: Neil Roberts <neil@linux.intel.com>
Date:   Mon Dec 6 12:31:16 2010 +0000

    cogl-pipeline: Add internal API to get the layer matrix
    
    This returns the layer matrix given a pipeline and a layer index. The
    API is kept as internal because it directly returns a pointer into the
    layer private data to avoid a copy into an out-param. We might also
    want to add a public function which does the copy.

 clutter/cogl/cogl/cogl-pipeline-private.h |  4 ++++
 clutter/cogl/cogl/cogl-pipeline.c         | 19 +++++++++++++++++++
 2 files changed, 23 insertions(+)

commit 4514d49dda70b9b5a1833c7809dc4d22b1bcd3cd
Author: Neil Roberts <neil@linux.intel.com>
Date:   Fri Dec 3 17:46:16 2010 +0000

    cogl-vertex-attribute: Use glVertexAttribPointer on GLES2
    
    When the GLES2 wrapper is removed we can't use the fixed function API
    such as glColorPointer to set the builtin attributes. Instead the GLSL
    progend now maintains a cache of attribute locations that are queried
    with glGetAttribLocation. The code that previously maintained a cache
    of the enabled texture coord arrays has been modified to also cache
    the enabled vertex attributes under GLES2. The vertex attribute API is
    now the only place that is using this cache so it has been moved into
    cogl-vertex-attribute.c

 clutter/cogl/cogl/cogl-bitmask.c                       |  16 +++++-----
 clutter/cogl/cogl/cogl-bitmask.h                       |  10 +++---
 clutter/cogl/cogl/cogl-context.c                       |   8 ++---
 clutter/cogl/cogl/cogl-context.h                       |   8 +++--
 clutter/cogl/cogl/cogl-internal.h                      |   6 ----
 clutter/cogl/cogl/cogl-pipeline-opengl.c               |  30 ++++++++++++++++-
 clutter/cogl/cogl/cogl-pipeline-progend-glsl-private.h |  18 +++++++++++
 clutter/cogl/cogl/cogl-pipeline-progend-glsl.c         | 139 +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
 clutter/cogl/cogl/cogl-vertex-attribute-private.h      |   3 ++
 clutter/cogl/cogl/cogl-vertex-attribute.c              | 311 ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++------------------------------------------
 clutter/cogl/cogl/cogl.c                               |  36 ++-------------------
 11 files changed, 451 insertions(+), 134 deletions(-)

commit 1515a8d73a0ea3ad6f6f8719e833bc17bb7c0001
Author: Neil Roberts <neil@linux.intel.com>
Date:   Fri Dec 3 11:31:09 2010 +0000

    cogl-path: Stroke using the vertex attribute API
    
    Previously when stroking a path it was flushing a pipeline and then
    directly calling glDrawArrays to draw the line strip from the path
    nodes array. This patch changes it to build a CoglVertexArray and a
    series of attributes to paint with instead. The vertex array and
    attributes are attached to the CoglPath so it can be reused later. The
    old vertex array for filling has been renamed to fill_vbo.

 clutter/cogl/cogl/cogl-path-private.h |  12 ++++++++----
 clutter/cogl/cogl/cogl2-path.c        | 201 +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++----------------------------------------------------------------
 2 files changed, 143 insertions(+), 70 deletions(-)

commit 3c5fa0cf9042827d205f90ac98c2eac9494707e9
Author: Neil Roberts <neil@linux.intel.com>
Date:   Thu Dec 2 22:19:44 2010 +0000

    cogl: Move COGL_DEBUG=show-source into cogl-shader.c
    
    The code to display the source when the show-source debug option is
    given has been moved to _cogl_shader_set_source_with_boilerplate so
    that it will show both user shaders and generated shaders. It also
    shows the code with the full boilerplate. To make it the same for
    ARBfp, cogl_shader_compile_real now also dumps user ARBfp shaders.

 clutter/cogl/cogl/cogl-pipeline-fragend-glsl.c |  5 -----
 clutter/cogl/cogl/cogl-pipeline-vertend-glsl.c |  5 -----
 clutter/cogl/cogl/cogl-shader.c                | 23 +++++++++++++++++++++++
 3 files changed, 23 insertions(+), 10 deletions(-)

commit 8764a0d4874949c12d6c0e6af863d81a39bc4991
Author: Neil Roberts <neil@linux.intel.com>
Date:   Thu Dec 2 20:48:45 2010 +0000

    cogl: Add a vertend to generate GLSL
    
    The GLSL vertend is mostly only useful for GLES2. The fixed function
    vertend is kept at higher priority than the GLSL vertend so it is
    unlikely to be used in any other circumstances.

 clutter/cogl/cogl/Makefile.am                          |   2 +
 clutter/cogl/cogl/cogl-context.c                       |   3 +-
 clutter/cogl/cogl/cogl-context.h                       |   3 +-
 clutter/cogl/cogl/cogl-pipeline-fragend-arbfp.c        |   3 +-
 clutter/cogl/cogl/cogl-pipeline-fragend-fixed.c        |  10 ++++-
 clutter/cogl/cogl/cogl-pipeline-fragend-glsl.c         |  13 +++---
 clutter/cogl/cogl/cogl-pipeline-opengl.c               | 130 ++++++++++++++++++++++++++++++++++++++++++----------------
 clutter/cogl/cogl/cogl-pipeline-private.h              |  30 +++++++++++++-
 clutter/cogl/cogl/cogl-pipeline-progend-glsl.c         |  83 ++++++++++++++++++++++++-------------
 clutter/cogl/cogl/cogl-pipeline-vertend-fixed.c        |  28 +++++++++++++
 clutter/cogl/cogl/cogl-pipeline-vertend-glsl-private.h |  39 ++++++++++++++++++
 clutter/cogl/cogl/cogl-pipeline-vertend-glsl.c         | 396 ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
 clutter/cogl/cogl/cogl-pipeline.c                      |   7 ++++
 clutter/cogl/cogl/driver/gles/cogl-gles2-wrapper.c     |  19 ++++-----
 14 files changed, 679 insertions(+), 87 deletions(-)

commit 6c34fb7232f3d82a6f5720fc9e07a41d997e643b
Author: Neil Roberts <neil@linux.intel.com>
Date:   Tue Dec 7 12:33:39 2010 +0000

    cogl-shader-boilerplate: Don't put the color attrib in location 0
    
    Due to Mesa bug 28585 calling glVertexAttrib with attrib location 0
    doesn't appear to work. This patch just reorders the vertex and color
    attributes in the shader in the hope that Mesa will assign the color
    attribute to a different location.

 clutter/cogl/cogl/cogl-shader-boilerplate.h | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit cf0ded1361bd639f7143aef02f37f17f01bdcf04
Author: Neil Roberts <neil@linux.intel.com>
Date:   Thu Dec 2 22:08:51 2010 +0000

    cogl-shader-boilerplate: Add more builtins for GLES2
    
    Some builtin attributes such as the matrix uniforms and some varyings
    were missing from the boilerplate for GLES2. This also moves the
    texture matrix and texture coord attribute declarations to
    cogl-shader.c so that they can be dynamically defined depending on the
    number of texture coord arrays enabled.

 clutter/cogl/cogl/cogl-shader-boilerplate.h | 23 ++++++++++++++++++++---
 clutter/cogl/cogl/cogl-shader.c             | 30 ++++++++++++++++++++++++------
 2 files changed, 44 insertions(+), 9 deletions(-)

commit 17d689f79480f9d08c1ef8e62b990db0cdb6a36d
Author: Neil Roberts <neil@linux.intel.com>
Date:   Thu Dec 2 18:05:22 2010 +0000

    cogl-pipeline: Rename the fragment_{source,header}_buffer to codegen
    
    We want to reuse the same buffers for vertends so calling them
    fragment_* doesn't make sense.

 clutter/cogl/cogl/cogl-context.c                |  4 ++--
 clutter/cogl/cogl/cogl-context.h                |  4 ++--
 clutter/cogl/cogl/cogl-pipeline-fragend-arbfp.c |  4 ++--
 clutter/cogl/cogl/cogl-pipeline-fragend-glsl.c  |  8 ++++----
 clutter/cogl/cogl/cogl-pipeline-progend-glsl.c  | 12 ++++++------
 5 files changed, 16 insertions(+), 16 deletions(-)

commit a3e53dd029632166a51333249baa49b5e97644c9
Author: Neil Roberts <neil@linux.intel.com>
Date:   Mon Nov 29 18:32:21 2010 +0000

    cogl: Add a fixed function vertend
    
    The vertends are intended to flush state that would be represented in
    a vertex program. Code to handle the layer matrix, lighting and
    point size has now been moved from the common cogl-pipeline-opengl
    backend to the fixed vertend.

 clutter/cogl/cogl/Makefile.am                           |   2 ++
 clutter/cogl/cogl/cogl-pipeline-opengl.c                | 109 ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++---------------------------
 clutter/cogl/cogl/cogl-pipeline-private.h               |  34 +++++++++++++++++++++++++++++++++-
 clutter/cogl/cogl/cogl-pipeline-vertend-fixed-private.h |  36 ++++++++++++++++++++++++++++++++++++
 clutter/cogl/cogl/cogl-pipeline-vertend-fixed.c         | 114 ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
 clutter/cogl/cogl/cogl-pipeline.c                       |  80 +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++-----
 6 files changed, 342 insertions(+), 33 deletions(-)

commit 313adc7bdf9c8a0d61cedf7e34d1cd3e961a7ea2
Author: Neil Roberts <neil@linux.intel.com>
Date:   Thu Dec 2 14:00:46 2010 +0000

    cogl: Add a GLSL 'progend'
    
    'progend' is short for 'program backend'. The progend is intended to
    operate on combined state from a fragment backend and a vertex
    backend. The progend has an 'end' function which is run whenever the
    pipeline is flushed and the two pipeline change notification
    functions. All of the progends are run whenever the pipeline is
    flushed instead of selecting a single one because it is possible that
    multiple progends may be in use for example if the vertends and
    fragends are different. The GLSL progend will take the shaders
    generated by the fragend and vertend and link them into a single
    program. The fragend code has been changed to only generate the shader
    and not the program. The idea is that pipelines can share fragment
    shader objects even if their vertex state is different. The authority
    for the progend needs to be the combined authority on the vertend and
    fragend state.

 clutter/cogl/cogl/Makefile.am                          |   2 +
 clutter/cogl/cogl/cogl-pipeline-fragend-glsl-private.h |   3 +
 clutter/cogl/cogl/cogl-pipeline-fragend-glsl.c         | 725 +++++++++++++++++++++++++++++++++++++++++++++-----------------------------------------------------------------------------------------------------------------------------------
 clutter/cogl/cogl/cogl-pipeline-opengl.c               |   5 ++
 clutter/cogl/cogl/cogl-pipeline-private.h              |  29 ++++++++
 clutter/cogl/cogl/cogl-pipeline-progend-glsl-private.h |  36 +++++++++
 clutter/cogl/cogl/cogl-pipeline-progend-glsl.c         | 542 +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
 clutter/cogl/cogl/cogl-pipeline.c                      |  39 +++++++++-
 8 files changed, 839 insertions(+), 542 deletions(-)

commit 1e3cdb60d6a6ad67c4e693687c5c9c64a25d7cec
Author: Neil Roberts <neil@linux.intel.com>
Date:   Thu Dec 2 13:54:15 2010 +0000

    cogl-program: Add private functions to check if have each shader type
    
    This adds two internal functions:
    
    gboolean
    _cogl_program_has_fragment_shader (CoglHandle handle);
    
    gboolean
    _cogl_program_has_vertex_shader (CoglHandle handle);
    
    They just check whether any of the contained shaders are of that type.

 clutter/cogl/cogl/cogl-program-private.h |  6 ++++++
 clutter/cogl/cogl/cogl-program.c         | 29 +++++++++++++++++++++++++++++
 2 files changed, 35 insertions(+)

commit 31f0eb4f715a3622260965b0b0a3be132cde8d23
Author: Neil Roberts <neil@linux.intel.com>
Date:   Wed Dec 1 17:06:18 2010 +0000

    cogl-pipeline: Make find codegen authority more general
    
    The pipeline function _cogl_pipeline_find_codegen_authority has been
    renamed to _cogl_pipeline_find_equivalent_parent and it now takes a
    set of flags for the pipeline and layer state that affects the
    authority. This is needed so that we can reuse the same code in the
    vertend and progends.

 clutter/cogl/cogl/cogl-pipeline-fragend-arbfp.c |  47 +++++++++++++----------------------------------
 clutter/cogl/cogl/cogl-pipeline-fragend-glsl.c  |   9 +++++++--
 clutter/cogl/cogl/cogl-pipeline-private.h       |  39 ++++++++++++++++++++++++++++++++++-----
 clutter/cogl/cogl/cogl-pipeline.c               | 137 ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++---------------------------------------------------------------------------
 4 files changed, 116 insertions(+), 116 deletions(-)

commit a1996706a293458221bce7a4126f82f64e4ca3c3
Author: Neil Roberts <neil@linux.intel.com>
Date:   Tue Nov 30 12:48:27 2010 +0000

    cogl-pipeline: Move texture enabling/disabling to fixed fragend
    
    Previously enabling and disabling textures was done whatever the
    backend in cogl-pipeline-opengl. However enabling and disabling
    texture targets only has any meaning if no fragment shaders are being
    used so this patch moves the code to cogl-pipeline-fragend-fixed.
    
    The GLES2 wrapper has also been changed to ignore enabledness when
    deciding whether to update texture coordinate attribute pointers.

 clutter/cogl/cogl/cogl-pipeline-fragend-arbfp.c    |   7 -------
 clutter/cogl/cogl/cogl-pipeline-fragend-fixed.c    | 107 +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++--
 clutter/cogl/cogl/cogl-pipeline-fragend-glsl.c     |   7 -------
 clutter/cogl/cogl/cogl-pipeline-opengl-private.h   |  16 +++++++---------
 clutter/cogl/cogl/cogl-pipeline-opengl.c           |  95 +++++++++++++++--------------------------------------------------------------------------------
 clutter/cogl/cogl/cogl-pipeline-private.h          |   2 --
 clutter/cogl/cogl/driver/gles/cogl-gles2-wrapper.c |  67 ++++++++++++++++++++++++++++++-------------------------------------
 7 files changed, 157 insertions(+), 144 deletions(-)

commit 952878aab1d0610b09d048495295fd84499b70e9
Author: Neil Roberts <neil@linux.intel.com>
Date:   Mon Nov 29 16:56:41 2010 +0000

    Rename CoglPipelineBackend to CoglPipelineFragend
    
    The current Cogl pipeline backends are entirely concerned with the
    fragment processing state. We also want to eventually have separate
    backends to generate shaders for the vertex processing state so we
    need to rename the fragment backends. 'Fragend' is a somewhat weird
    name but we wanted to avoid ending up with illegible symbols like
    CoglPipelineFragmentBackendGlslPrivate.

 clutter/cogl/cogl/Makefile.am                                                              |  12 +++++------
 clutter/cogl/cogl/cogl-context.c                                                           |   6 +++---
 clutter/cogl/cogl/{cogl-pipeline-arbfp-private.h => cogl-pipeline-fragend-arbfp-private.h} |  11 +++++-----
 clutter/cogl/cogl/{cogl-pipeline-arbfp.c => cogl-pipeline-fragend-arbfp.c}                 | 166 ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++----------------------------------------------------------------------
 clutter/cogl/cogl/{cogl-pipeline-fixed-private.h => cogl-pipeline-fragend-fixed-private.h} |   8 +++----
 clutter/cogl/cogl/{cogl-pipeline-fixed.c => cogl-pipeline-fragend-fixed.c}                 |  24 ++++++++++-----------
 clutter/cogl/cogl/{cogl-pipeline-glsl-private.h => cogl-pipeline-fragend-glsl-private.h}   |   8 +++----
 clutter/cogl/cogl/{cogl-pipeline-glsl.c => cogl-pipeline-fragend-glsl.c}                   |  80 +++++++++++++++++++++++++++++++++----------------------------------
 clutter/cogl/cogl/cogl-pipeline-opengl.c                                                   |  66 ++++++++++++++++++++++++++++----------------------------
 clutter/cogl/cogl/cogl-pipeline-private.h                                                  |  48 ++++++++++++++++++++---------------------
 clutter/cogl/cogl/cogl-pipeline.c                                                          | 100 ++++++++++++++++++++++++++++++++++++++++++------------------------------------------
 11 files changed, 265 insertions(+), 264 deletions(-)

commit dc61d58c0df9dde51472bae17b1997c82cfcddb1
Author: Neil Roberts <neil@linux.intel.com>
Date:   Thu Dec 2 15:37:53 2010 +0000

    cogl-pipeline-opengl: Remove the includes for the various backends
    
    Nothing in cogl-pipeline-opengl needs to know about the actual backend
    implementations, instead it just accesses then through the vtables.

 clutter/cogl/cogl/cogl-pipeline-opengl.c | 10 ----------
 1 file changed, 10 deletions(-)

commit 54db48dfd1e1b151a3b92e160181f44305e21089
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Sat Dec 11 17:40:52 2010 +0000

    animation: Allow transforming values in bind()
    
    While we do check for compatibility and transformability of a GValue
    with the GParamSpec value type, we are actually failing really badly
    at it.
    
    First of all, we bail out on the wrong conditions.
    
    Then we use the type of the value passed instead of using the type
    of the property itself.
    
    This makes it impossible to actually use transformation functions for
    GValue types - even those that have been registered by GLib itself -
    when using the Animation API directly, instead of going through the
    clutter_actor_animate() wrappers.

 clutter/clutter-animation.c | 28 +++++++++++++++++++++++-----
 1 file changed, 23 insertions(+), 5 deletions(-)

commit ae4e06d8c4ca2bd93a12e4ace38c0c888edcddf1
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Fri Dec 10 17:15:39 2010 +0000

    introspection: Skip some C-only structures
    
    The ParamSpec sub-classes we define are meant to be used only from the C
    API, as high-level languages completely ignore them.
    
    The ClutterStageWindow interface is an internal type that escaped into
    the public headers; all its methods are private, but we cannot remove
    the type until we break for 2.0.

 clutter/clutter-color.h        | 16 ++++++++--------
 clutter/clutter-fixed.h        |  2 +-
 clutter/clutter-stage-window.h |  4 ++--
 clutter/clutter-units.h        |  2 +-
 4 files changed, 12 insertions(+), 12 deletions(-)

commit d5a418304712e38c7055114fa5b13a904fae9883
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Fri Dec 10 17:15:23 2010 +0000

    introspection: Add cairo-1.0 to the dependencies

 clutter/Makefile.am | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 49a43a0772d749d280a7fc6ceb561c6452dc859f
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Fri Dec 10 16:03:10 2010 +0000

    Remove unnecessary duplicate name for private enumerations

 clutter/clutter-actor-private.h | 6 ++----
 1 file changed, 2 insertions(+), 4 deletions(-)

commit b91c1ec21c80e99949a19865be2c44c53063d09e
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Thu Dec 9 16:05:55 2010 +0000

    docs: Update NEWS

 NEWS | 27 +++++++++++++++++++++++++++
 1 file changed, 27 insertions(+)

commit bc58de4658a206f07d51ddbb9b8c06f37c4cf841
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Thu Dec 9 15:52:04 2010 +0000

    docs: Add 1.6 index to the API references

 doc/reference/cally/cally-docs.xml.in     | 5 +++++
 doc/reference/clutter/clutter-docs.xml.in | 5 +++++
 doc/reference/cogl/cogl-docs.xml.in       | 5 +++++
 3 files changed, 15 insertions(+)

commit 36c3fc82c5c3eee50878f964f09939b9b169fd82
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Thu Dec 9 15:42:19 2010 +0000

    Use G_STRFUNC correctly
    
    It cannot be chained up via the pre-processor.

 clutter/egl/clutter-backend-egl.c       | 2 +-
 clutter/fruity/clutter-backend-fruity.c | 2 +-
 2 files changed, 2 insertions(+), 2 deletions(-)

commit 24133ddadcd71af74f52b009b178e0ffa9e51374
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Thu Dec 9 15:11:37 2010 +0000

    Rename the EGLDisplay accessors
    
    The accessor for the EGL display should be namespaced for the correct
    backend-specific API.

 clutter/egl/clutter-backend-egl.c          | 19 ++++++++++++++-----
 clutter/egl/clutter-egl.h                  | 28 +++++++++++++++++++++-------
 clutter/fruity/clutter-backend-fruity.c    | 32 ++++++++++++++++++++++++++++++++
 clutter/fruity/clutter-fruity.h            |  9 +++++++--
 clutter/fruity/clutter-stage-fruity.c      |  3 ++-
 clutter/wayland/clutter-backend-wayland.c  | 24 +++++++++++-------------
 clutter/wayland/clutter-stage-wayland.c    |  4 ++--
 clutter/wayland/clutter-wayland.h          |  7 ++++---
 doc/reference/clutter/clutter-sections.txt |  3 ++-
 9 files changed, 95 insertions(+), 34 deletions(-)

commit f5b51a2428cb3575ca4cfba98926f4906e6aba8e
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Thu Dec 9 15:06:12 2010 +0000

    docs: Documentation fixes

 clutter/clutter-actor-private.h   | 30 ++++++++++++++++--------------
 doc/reference/clutter/Makefile.am |  1 +
 2 files changed, 17 insertions(+), 14 deletions(-)

commit ab0eb0a12b9cc05c417b49832b50b88a7cdb0958
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Thu Dec 9 13:59:08 2010 +0000

    docs: Documentation fixes

 clutter/cally/cally-group.c                          | 2 +-
 clutter/clutter-main.c                               | 2 +-
 clutter/clutter-units.c                              | 4 ++--
 doc/reference/clutter/clutter-animation-tutorial.xml | 2 +-
 4 files changed, 5 insertions(+), 5 deletions(-)

commit 8c7298b0c11df3690a8eb5afdd9226af87b4d76f
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Thu Dec 9 13:49:01 2010 +0000

    build: Check NEWS file during release, not distcheck
    
    The check-news option in configure.ac conflicts with the idea of using a
    buildbot to do a distcheck.
    
    Since we're doing some validation on the state of the build during the
    release-check phase we should add the NEWS file check there.
    
    http://bugzilla.clutter-project.org/show_bug.cgi?id=2468

 build/autotools/Makefile.am.release | 11 ++++++++++-
 configure.ac                        |  2 +-
 2 files changed, 11 insertions(+), 2 deletions(-)

commit 88f7579a9d4dd7b290216b5943d87c8143cceb04
Author: Elliot Smith <elliot.smith@intel.com>
Date:   Thu Dec 9 11:40:27 2010 +0000

    cookbook: Remove bold on emphasis inside programlisting
    
    If an <emphasis> element is placed inside a <programlisting> in a cookbook
    recipe, the result is bold italic text in the HTML output. This isn't
    particularly readable.
    
    Fix is to style emphasis elements inside programlistings
    so the font weight is not bold but is still italicised.
    
    http://bugzilla.clutter-project.org/show_bug.cgi?id=2475

 doc/common/style.css | 3 +++
 1 file changed, 3 insertions(+)

commit ca42ec1a7a3a7b219477d6c16a0aff30d64efb1a
Author: Jussi Kukkonen <jku@linux.intel.com>
Date:   Thu Dec 2 16:08:10 2010 +0200

    tests: Add test for clutter_model_get_iter_at_row()
    
    http://bugzilla.clutter-project.org/show_bug.cgi?id=2460

 tests/conform/test-model.c | 17 +++++++++++++++++
 1 file changed, 17 insertions(+)

commit d8515bf4290bfece33fd41d356e86e74c0728067
Author: Jussi Kukkonen <jku@linux.intel.com>
Date:   Thu Dec 2 16:27:36 2010 +0200

    Fix clutter_list_model_get_iter_at_row() when filtered
    
    Currently clutter_list_model_get_iter_at_row() always returns an
    iterator to the last non-filtered row  when asking for row [1-N].
    
    Patch makes the function return an iterator to the Nth non-filtered
    row or NULL.
    
    http://bugzilla.clutter-project.org/show_bug.cgi?id=2460

 clutter/clutter-list-model.c | 58 +++++++++++++++++-----------------------------------------
 1 file changed, 17 insertions(+), 41 deletions(-)

commit e7f62bc936995c5d998f7c8dc4b2b1b7254ea97d
Author: nobled <nobled@dreamwidth.org>
Date:   Tue Dec 7 07:10:59 2010 +0000

    wayland: Update to current api
    
    Adapt to changes from these wayland commits:
    35fd2a8cc68c42d90756330535de04cbbb4d2613
    2bb3ebe1e437acf836449f0a63f3264ad29566f2
    f8fc08f77187f6a5723281dab66841e5f3c24320
    
    http://bugzilla.clutter-project.org/show_bug.cgi?id=2474

 clutter/wayland/clutter-backend-wayland.c | 8 ++++----
 1 file changed, 4 insertions(+), 4 deletions(-)

commit d8a544c0f17f5d6550578a426c1ef1c4060ca411
Author: nobled <nobled@dreamwidth.org>
Date:   Tue Dec 7 07:07:40 2010 +0000

    wayland: fix typo
    
    Fixes the build error:
    
    clutter-input-device-wayland.c:154:69:
    error: too few arguments to function call
    
    http://bugzilla.clutter-project.org/show_bug.cgi?id=2473

 clutter/wayland/clutter-input-device-wayland.c | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 3795c9b975d43305c64ed24306736f764ef165bc
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Thu Dec 9 12:37:41 2010 +0000

    build: Do not hardcode --warn-all for g-ir-scanner
    
    It's possible to use --warn-all through the introspection scanner
    options from outside the build environment.

 clutter/Makefile.am | 3 ---
 1 file changed, 3 deletions(-)

commit d229036441b3f0a4f7ab5205de46b5dbc9d9d7a9
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Thu Dec 9 12:36:50 2010 +0000

    Reduce the amount of g-ir-scanner warnings
    
    As much as we can; the remaining warnings are mostly valid things that
    the introspection scanner still flags as potential issues.

 clutter/clutter-actor.h            | 26 +++++++++++++-------------
 clutter/clutter-container.c        | 16 ++++++++++++----
 clutter/clutter-device-manager.h   | 10 +++++-----
 clutter/clutter-layout-manager.h   |  8 ++++----
 clutter/clutter-offscreen-effect.h |  6 +++---
 clutter/clutter-scriptable.h       |  2 +-
 clutter/x11/clutter-backend-x11.c  | 10 +++++-----
 clutter/x11/clutter-stage-x11.c    |  7 ++++---
 8 files changed, 47 insertions(+), 38 deletions(-)

commit e1f48b15ee92f60f2a84c808ba0d505f38a1bf61
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Thu Dec 9 12:00:29 2010 +0000

    docs: Use :reverse in the Behaviour migration guide
    
    Instead of the ::completed signal flip.

 doc/reference/clutter/migrating-ClutterBehaviour.xml | 8 +++-----
 1 file changed, 3 insertions(+), 5 deletions(-)

commit b16ea099882accbb489d20ef1ea03dc3cb0d2846
Merge: b6318bd82 50849ac1f
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Thu Dec 9 11:58:10 2010 +0000

    Merge remote branch 'elliot/cookbook-animations-looping-new-api'
    
    * elliot/cookbook-animations-looping-new-api:
      cookbook: Use new API to reverse timeline

commit b6318bd8218c021270370d6e8093d38bdabe791d
Author: Tomeu Vizoso <tomeu.vizoso@collabora.co.uk>
Date:   Tue Dec 7 15:29:05 2010 +0100

    Make clutter_shader_effect_set_uniform_value accept G_TYPE_DOUBLE
    
    For users of gobject-introspection that cannot know which
    non-integer type to pass.
    
    http://bugzilla.clutter-project.org/show_bug.cgi?id=2471

 clutter/clutter-shader-effect.c | 12 +++++++++++-
 1 file changed, 11 insertions(+), 1 deletion(-)

commit cf1fced88507e0ccc2fa704d14b3141168a48360
Author: Robert Bragg <robert@linux.intel.com>
Date:   Wed Dec 8 18:57:42 2010 +0000

    pipeline: don't dereference NULL program state
    
    This avoid dereferencing a NULL arbfp program state in
    _cogl_pipeline_backend_arbfp_layer_pre_change_notify for
    _STATE_COMBINE_CONSTANT changes.

 clutter/cogl/cogl/cogl-pipeline-arbfp.c | 12 ++++++++----
 1 file changed, 8 insertions(+), 4 deletions(-)

commit 46295a0dd1c0dcbc130ed9dd3aed900e597c8d42
Author: Robert Bragg <robert@linux.intel.com>
Date:   Wed Dec 8 16:29:37 2010 +0000

    arbfp: Copy pipelines used as cache keys
    
    We are currently using a pipeline as a key into our arbfp program cache
    but because we weren't making a copy of the pipelines used as keys there
    were times when doing a lookup in the cache would end up trying to
    compare a lookup key with an entry key that would point to invalid
    memory.
    
    Note: the current approach isn't ideal from the pov that that key
    pipeline may reference some arbitrarily large user textures will now be
    kept alive indefinitely. The plan to improve on this is that we will
    have a mechanism to create a special "key pipeline" which will derive
    from the default Cogl pipeline (to avoid affecting the lifetime of
    other pipelines) and only copy state from the original pipeline that
    affects the arbfp program and will reference small dummy textures
    instead of potentially large user textures.

 clutter/cogl/cogl/cogl-pipeline-arbfp.c | 34 +++++++++++++++++++++++++++++++++-
 1 file changed, 33 insertions(+), 1 deletion(-)

commit 87b2300f98727525267a6849c36c74849ea993fd
Author: Robert Bragg <robert@linux.intel.com>
Date:   Wed Dec 8 16:27:57 2010 +0000

    arbfp: initialize arbfp_program_state->next_constant_id
    
    When allocating a new ArbfpProgramState struct when starting code
    generation we weren't initializing arbfp_program_state->next_constant_id
    to 0.

 clutter/cogl/cogl/cogl-pipeline-arbfp.c | 1 +
 1 file changed, 1 insertion(+)

commit bac600b21bcbe13d3259fb7cee9e2b378f807d74
Author: Robert Bragg <robert@linux.intel.com>
Date:   Wed Dec 8 16:23:10 2010 +0000

    pipeline: Clarify stages for finding an arbfp program
    
    In the arbfp backend there is a seqential approach to finding a suitable
    arbfp program to use for a given pipeline; first we see if there's
    already a program associated with the pipeline, 2nd we try and find a
    program associated with the "arbfp-authority" 3rd we try and lookup a
    program in a cache and finally we resort to starting code-generation for
    a new program. This patch slightly reworks the code of these steps to
    hopefully make them a bit clearer.

 clutter/cogl/cogl/cogl-pipeline-arbfp.c | 102 ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++------------------------------------------
 1 file changed, 60 insertions(+), 42 deletions(-)

commit 9606c42c559fefbf397047dad6da3f4f8958b459
Author: Neil Roberts <neil@linux.intel.com>
Date:   Mon Dec 6 21:14:33 2010 +0000

    cogl-pipeline: Fix the layer_has_alpha_cb
    
    _cogl_pipeline_needs_blending_enabled tries to determine whether each
    layer is using the default combine state. However it was using
    argument 0 for both checks so the if-statement would never be true.

 clutter/cogl/cogl/cogl-pipeline.c | 4 ++--
 1 file changed, 2 insertions(+), 2 deletions(-)

commit ab5f394e5aea5a79a0e5d6647e86402ca2ba5e4f
Author: Robert Bragg <robert@linux.intel.com>
Date:   Wed Dec 8 11:38:56 2010 +0000

    pipeline: remove unused HashState member
    
    There was an unused pipeline_differences member as part of the HashState
    struct which this patch remove to avoid confusion.

 clutter/cogl/cogl/cogl-pipeline.c | 1 -
 1 file changed, 1 deletion(-)

commit 5fd8e9c6083ff17202ceb2cfd2d1c56df0d1da14
Author: Robert Bragg <robert@linux.intel.com>
Date:   Wed Dec 8 11:35:16 2010 +0000

    pipeline: initialize HashState flags member
    
    There are a set of "EvalFlags" that get passed to _cogl_pipeline_hash
    that can tweak the semantics of what state is evaluated for hashing but
    these flags weren't getting passed via the HashState state structure
    so it would be undefined if you would get the correct semantics.

 clutter/cogl/cogl/cogl-pipeline.c | 1 +
 1 file changed, 1 insertion(+)

commit ea66156c83dded1536009bbdd02032e5e3114c3a
Author: Robert Bragg <robert@linux.intel.com>
Date:   Wed Dec 8 11:30:00 2010 +0000

    pipeline: don't use near/far symbols
    
    According to 9cc90333473e3 the windows headers #define near as nothing,
    and presumable the same is true for 'far' too. Apparently this define is
    to improve compatibility with code written for Windows 3.1, so it's good
    that people will be able to incorporate such code into their Clutter
    applications.

 clutter/cogl/cogl/cogl-pipeline.c | 8 ++++----
 1 file changed, 4 insertions(+), 4 deletions(-)

commit acd3d615686f8b10589ac57b7fb16b4f968ae3fb
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Wed Dec 8 14:26:27 2010 +0000

    docs: Fix listitem tag

 clutter/clutter-color.c | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit c454526bbbd91224ab3fa580d80bf937b912d2cc
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Wed Dec 8 13:59:53 2010 +0000

    docs: Clean up clutter_color_from_string()
    
    Add hsl() and hsla() formats, and clean up the wording.

 clutter/clutter-color.c | 54 +++++++++++++++++++++++++++++++++++++-----------------
 1 file changed, 37 insertions(+), 17 deletions(-)

commit ca7dc2f951f1d5cc59c364a186aa065449c2b85f
Author: Neil Roberts <neil@linux.intel.com>
Date:   Tue Dec 7 23:32:47 2010 +0000

    cogl-backend-egl: Chain up to the X11 backend init_events
    
    Since c6493885c3f18 when building the EGL backend for eglx there was
    no fallback in the init_events implementation so the X11 backend init
    function would never get called. This was stopping it from receiving
    any X events so a lot of things broke. It now just chains up.

 clutter/egl/clutter-backend-egl.c | 5 +++++
 1 file changed, 5 insertions(+)

commit b0751d234240aa5e7899dedba22c607e75f5ad81
Author: Damien Lespiau <damien.lespiau@intel.com>
Date:   Tue Dec 7 22:06:07 2010 +0000

    input-device: Downgrade over-zealous warning to note
    
    This warning is really harmless, we just discard the event anyway, let's
    demote it to a CLUTTER_NOTE() so event backend implementers can see it.

 clutter/clutter-input-device.c | 4 ++--
 1 file changed, 2 insertions(+), 2 deletions(-)

commit f8fc194b3b3529bf4f3230cef00d5d0b042673bf
Author: Neil Roberts <neil@linux.intel.com>
Date:   Tue Dec 7 11:02:21 2010 +0000

    clutter-score: Initialize ClutterScoreEntry::complete_id
    
    When clutter_score_append_at_marker is called instead of
    clutter_score_append the complete_id field of ClutterScoreEntry was
    being left uninitialised. When the entry is eventually freed it would
    sometimes try to disconnect an invalid signal id. This was causing
    conformance test failures for me on GLES2.

 clutter/clutter-score.c | 1 +
 1 file changed, 1 insertion(+)

commit 9d836d8ce5d95749e1b3562f1cab77d9ac27cb1e
Author: Robert Bragg <robert@linux.intel.com>
Date:   Tue Dec 7 16:44:36 2010 +0000

    context: only declare arbfp cache for GL
    
    We were trying to declare and initializing an arbfp program cache for
    GLES but since the prototypes for the _hash and _equal functions were
    only available for GL this broke the GLES builds. By #ifdefing the code
    to conditionally declare/initialize for GL only this should hopefully
    fix GLES builds.

 clutter/cogl/cogl/cogl-context.c | 4 ++++
 clutter/cogl/cogl/cogl-context.h | 2 ++
 2 files changed, 6 insertions(+)

commit 67c2a1b29fa679f3a86b8ee4cae682de8391397b
Author: Robert Bragg <robert@linux.intel.com>
Date:   Tue Dec 7 16:36:44 2010 +0000

    pipeline: remove spurious use of True instead of TRUE
    
    The constant 'True' is defined by Xlib which isn't used for all clutter
    builds so this replaces occurrences of True with TRUE which is defined
    by glib. This should hopefully fix the win32 builds.

 clutter/cogl/cogl/cogl-pipeline.c | 4 ++--
 1 file changed, 2 insertions(+), 2 deletions(-)

commit 464ed7e6b7c35248c03fd0a03a8e8087e7b5e274
Author: Robert Bragg <robert@linux.intel.com>
Date:   Fri Dec 3 12:01:18 2010 +0000

    arbfp: Adds an ARBfp program cache
    
    This adds a cache (A GHashTable) of ARBfp programs and before ever
    starting to code-generate a new program we will always first try and
    find an existing program in the cache. This uses _cogl_pipeline_hash and
    _cogl_pipeline_equal to hash and compare the keys for the cache.
    
    There is a new COGL_DEBUG=disable-program-caches option that can disable
    the cache for debugging purposes.

 clutter/cogl/cogl/cogl-context.c                |   6 ++++++
 clutter/cogl/cogl/cogl-context.h                |   2 ++
 clutter/cogl/cogl/cogl-debug-options.h          |   5 +++++
 clutter/cogl/cogl/cogl-debug.c                  |   8 +++++---
 clutter/cogl/cogl/cogl-debug.h                  |   3 ++-
 clutter/cogl/cogl/cogl-pipeline-arbfp-private.h |   6 ++++++
 clutter/cogl/cogl/cogl-pipeline-arbfp.c         | 111 ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++-------------------
 7 files changed, 118 insertions(+), 23 deletions(-)

commit e87c3820ee729930d4a7b84f4737b99eb26ad03d
Author: Robert Bragg <robert@linux.intel.com>
Date:   Thu Nov 4 13:57:36 2010 +0000

    pipeline: Implements _cogl_pipeline_hash function
    
    This allows us to get a hash for a set of state groups for a given
    pipeline. This can be used for example to get a hash of the fragment
    processing state of a pipeline so we can implement a cache for compiled
    arbfp/glsl programs.

 clutter/cogl/cogl/cogl-color-private.h    |   5 ++
 clutter/cogl/cogl/cogl-context.c          |   2 +
 clutter/cogl/cogl/cogl-pipeline-private.h |  18 ++++++-
 clutter/cogl/cogl/cogl-pipeline.c         | 520 +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
 clutter/cogl/cogl/cogl-util.c             |   9 ++++
 clutter/cogl/cogl/cogl-util.h             |  27 ++++++++++
 6 files changed, 580 insertions(+), 1 deletion(-)

commit cc36e49ec5f06f608380fba24682a69e9b0d0a1a
Author: Robert Bragg <robert@linux.intel.com>
Date:   Fri Dec 3 11:36:49 2010 +0000

    pipeline: generalize _cogl_pipeline_equal
    
    _cogl_pipeline_equal now accepts a mask of pipeline differences and layer
    differences to constrain what state will be compared. In addition a set
    of flags are passed that can tweak the comparison semantics for some
    state groups. For example when comparing layer textures we sometimes
    only need to compare the texture target and can ignore the data itself.
    
    In updating the code this patch also changes it so all required pipeline
    authorities are resolved in one step up-front instead of resolving the
    authority for each state group in turn and repeatedly having to traverse
    the pipeline's ancestry. This adds two new functions
    _cogl_pipeline_resolve_authorities and
    _cogl_pipeline_layer_resolve_authorities to handle resolving a set of
    authorities.

 clutter/cogl/cogl/cogl-journal.c          |   9 +++---
 clutter/cogl/cogl/cogl-pipeline-private.h | 155 +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++-----------------------------
 clutter/cogl/cogl/cogl-pipeline.c         | 287 +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++------------------------------------------------------------
 3 files changed, 312 insertions(+), 139 deletions(-)

commit 62b051951c80c31ee6874a1d156ce889350ce8be
Author: Robert Bragg <robert@linux.intel.com>
Date:   Tue Dec 7 12:13:10 2010 +0000

    docs: don't dist cogl-2.0 manual if not built
    
    If not configured with --enable-cogl2-reference then don't try and dist
    the doc/references/cogl-2.0 manual. Although this means a tarball built
    this way will not be able to build the experimental cogl-2.0 manual this
    isn't considered a big problem since anyone interested in this would
    hopefully be tracking git for now or we can simply be careful to
    configure with --enable-cogl2-reference for our tarball releases.

 doc/reference/Makefile.am | 7 ++++++-
 1 file changed, 6 insertions(+), 1 deletion(-)

commit ff646b7fc3e4528836f415e4087ee30c6547ad7d
Author: Robert Bragg <robert@linux.intel.com>
Date:   Wed Dec 1 16:53:08 2010 +0000

    pipeline: remove layer->backend_priv[] array
    
    This removes the unused array of per-packend priv data pointers
    associated with every CoglPipelineLayer. This reduces the size of all
    layer allocations and avoids having to zero an array for each
    _cogl_pipeline_layer_copy.

 clutter/cogl/cogl/cogl-pipeline-arbfp.c   |  1 -
 clutter/cogl/cogl/cogl-pipeline-glsl.c    |  3 +--
 clutter/cogl/cogl/cogl-pipeline-private.h |  9 ---------
 clutter/cogl/cogl/cogl-pipeline.c         | 24 ------------------------
 4 files changed, 1 insertion(+), 36 deletions(-)

commit 1180fd159edea9b3907c186d45013348c041b216
Author: Robert Bragg <robert@linux.intel.com>
Date:   Wed Dec 1 16:37:25 2010 +0000

    cogl-object: remove un-used cogl_object_get_type
    
    A non-static function named cogl_object_get_type was inadvertently added
    during the addition of the CoglObject base type, but there is no public
    prototype in the headers and it's only referenced inside cogl-object.c
    to implement cogl_handle_get_type() for compatibility. This removes the
    function since we don't want to commit to CoglObject always simply being
    a boxed type. In the future we may want to register hierarchical
    GTypeInstance based types.

 clutter/cogl/cogl/cogl-object.c | 8 +-------
 1 file changed, 1 insertion(+), 7 deletions(-)

commit ef02cb7ff203b12932697823fbcc59a7bd04ad4d
Author: Robert Bragg <robert@linux.intel.com>
Date:   Mon Nov 29 21:42:06 2010 +0000

    matrix gtype: registers a boxed type for CoglMatrix
    
    To allow us to have gobject properties that accept a CoglMatrix value we
    need to register a GType. This adds a cogl_gtype_matrix_get_type function
    that will register a static boxed type called "CoglMatrix".
    
    This adds a new section to the reference manual for GType integration
    functions.

 clutter/cogl/cogl/Makefile.am            |  1 +
 clutter/cogl/cogl/cogl-gtype-private.h   | 48 ++++++++++++++++++++++++++++++++++++++++++++++++
 clutter/cogl/cogl/cogl-matrix.c          |  7 +++++++
 clutter/cogl/cogl/cogl-matrix.h          | 16 ++++++++++++++++
 clutter/cogl/cogl/cogl.h                 |  6 ++++++
 doc/reference/cogl-2.0/cogl-docs.xml.in  |  6 ++++++
 doc/reference/cogl-2.0/cogl-sections.txt |  6 +++++-
 doc/reference/cogl/cogl-docs.xml.in      |  1 +
 doc/reference/cogl/cogl-sections.txt     |  6 ++++++
 9 files changed, 96 insertions(+), 1 deletion(-)

commit c29a7526c040209a5ca0bb327f1df6a98c4d88aa
Author: Robert Bragg <robert@linux.intel.com>
Date:   Mon Nov 29 18:47:10 2010 +0000

    matrix: Adds matrix_copy and _free functions
    
    As a pre-requisite for being able to register a boxed GType for
    CoglMatrix (enabling us to define gobject properties that accept a
    CoglMatrix) this adds cogl_matrix_copy and _free functions.

 clutter/cogl/cogl/cogl-matrix.c | 15 +++++++++++++++
 clutter/cogl/cogl/cogl-matrix.h | 27 +++++++++++++++++++++++++++
 2 files changed, 42 insertions(+)

commit 3edd02841b5748bbad0977ba9ccd91d65651f819
Author: Robert Bragg <robert@linux.intel.com>
Date:   Fri Dec 3 16:59:52 2010 +0000

    pipeline simple optimization for _needs_blending_enabled
    
    In _cogl_pipeline_needs_blending_enabled after first checking whether
    the property most recently changed requires blending we would then
    resort to checking all other properties too in case some other state
    also requires blending. We now avoid checking all other properties in
    the case that blending was previously disabled and checking the property
    recently changed doesn't require blending.
    
    Note: the plan is to improve this further by explicitly keeping track
    of the properties that currently cause blending to be enabled so that we
    never have to resort to checking all other properties we can constrain
    the checks to those masked properties.

 clutter/cogl/cogl/cogl-pipeline.c | 17 +++++++++++++----
 1 file changed, 13 insertions(+), 4 deletions(-)

commit 9ff191bd3bfba0000547c3082e7fe6c57152bbe5
Author: Robert Bragg <robert@linux.intel.com>
Date:   Fri Dec 3 16:56:54 2010 +0000

    pipeline: inline _get_parent and _get_authority
    
    This moves _cogl_pipeline_get_parent and _cogl_pipeline_get_authority
    into cogl-pipeline-private.h so they can be inlined since they have been
    seen to get quite high in profiles. Given that they both contain such
    small amounts of code the function call overhead is significant.

 clutter/cogl/cogl/cogl-pipeline-private.h | 17 +++++++++++++++++
 clutter/cogl/cogl/cogl-pipeline.c         | 17 -----------------
 2 files changed, 17 insertions(+), 17 deletions(-)

commit 3fa91efea84c2c442fcc92e8ed0df711d7e67988
Author: Neil Roberts <neil@linux.intel.com>
Date:   Wed Nov 10 14:02:31 2010 +0000

    Add a COGL_DEBUG option to disable software clipping
    
    This adds a debug option called disable-software-clipping which causes
    the journal to always log the clip stack state rather than trying to
    manually clip rectangles.

 clutter/cogl/cogl/cogl-debug-options.h |  5 +++++
 clutter/cogl/cogl/cogl-debug.c         |  3 ++-
 clutter/cogl/cogl/cogl-debug.h         |  3 ++-
 clutter/cogl/cogl/cogl-journal.c       | 23 +++++++++++++----------
 4 files changed, 22 insertions(+), 12 deletions(-)

commit 62c893feee386223aebbab781171028db547d7f9
Author: Neil Roberts <neil@linux.intel.com>
Date:   Tue Nov 9 19:18:37 2010 +0000

    cogl-journal: Attempt to clip manually to avoid breaking up batches
    
    Before flushing the journal there is now a separate iteration that
    will try to determine if the matrix of the clip stack and the matrix
    of the rectangle in each entry are on the same plane. If they are it
    can completely avoid the clip stack and instead manually modify the
    vertex and texture coordinates to implement the clip. The has the
    advantage that it won't break up batching if a single clipped
    rectangle is used in a scene.
    
    The software clip is only used if there is no user program and no
    texture matrices. There is a threshold to the size of the batch where
    it is assumed that it is worth the cost to break up a batch and
    program the GPU to do the clipping. Currently this is set to 8
    although this figure is plucked out of thin air.
    
    To check whether the two matrices are on the same plane it tries to
    determine if one of the matrices is just a simple translation of the
    other. In the process of this it also works out what the translation
    would be. These values can be used to translate the clip rectangle
    into the coordinate space of the rectangle to be logged. Then we can
    do the clip directly in the rectangle's coordinate space.

 clutter/cogl/cogl/cogl-context.c         |   3 ++
 clutter/cogl/cogl/cogl-context.h         |   1 +
 clutter/cogl/cogl/cogl-journal-private.h |   2 ++
 clutter/cogl/cogl/cogl-journal.c         | 363 ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++----
 4 files changed, 363 insertions(+), 6 deletions(-)

commit be63fcee7ff2ef33d25efd873f9a9b79856e1577
Author: Neil Roberts <neil@linux.intel.com>
Date:   Tue Nov 9 19:09:25 2010 +0000

    cogl-clip-stack: Move the struct definitions to the header
    
    It will be useful to be able to directly examine the contents of the
    clip stack within the journal code.

 clutter/cogl/cogl/cogl-clip-stack.c | 112 ----------------------------------------------------------------------------------------------------------------
 clutter/cogl/cogl/cogl-clip-stack.h | 114 ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
 2 files changed, 114 insertions(+), 112 deletions(-)

commit dc0506a1649bcea4997a68013927529451131712
Author: Neil Roberts <neil@linux.intel.com>
Date:   Tue Nov 9 12:01:04 2010 +0000

    cogl-clip-stack: Don't convert rect clips to window clips
    
    Previously in cogl-clip-state.c when it detected that the current
    modelview matrix is screen-aligned it would convert the clip entry to
    a window clip. Instead of doing this cogl-clip-stack.c now contains
    the detection and keeps the entry as a rectangle clip but marks that
    it is entirely described by its scissor rect. When flusing the clip
    stack it doesn't do anything extra for entries that have this mark
    (because the clip will already been setup by the scissor). This is
    needed so that we can still track the original rectangle coordinates
    and modelview matrix to help detect when it would be faster to modify
    the rectangle when adding it to the journal rather than having to
    break up the batch to set the clip state.

 clutter/cogl/cogl/cogl-clip-stack.c | 109 +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++--------------------------
 clutter/cogl/cogl/cogl-clip-state.c |  55 -------------------------------------------------------
 2 files changed, 83 insertions(+), 81 deletions(-)

commit 22be07c3b5ec7d8d5e5e0447599425026cbb7bd8
Author: Neil Roberts <neil@linux.intel.com>
Date:   Thu Nov 25 21:08:45 2010 +0000

    cogl-journal: Defer expanding the vertices until uploading
    
    When logging a quad we now only store the 2 vertices representing the
    top left and bottom right of the quad. The color is only stored once
    per entry. Once we come to upload the data we expand the 2 vertices
    into four and copy the color to each vertex. We do this by mapping the
    buffer and directly expanding into it. We have to copy the data before
    we can render it anyway so it doesn't make much sense to expand the
    vertices before uploading and this way should save some space in the
    size of the journal. It also makes it slightly easier if we later want
    to do pre-processing on the journal entries before uploading such as
    doing software clipping.
    
    The modelview matrix is now always copied to the journal entry whereas
    before it would only be copied if we aren't doing software
    transform. The journal entry struct always has the space for the
    modelview matrix so hopefully it's only a small cost to copy the
    matrix.
    
    The transform for the four entries is now done using
    cogl_matrix_transform_points which may be slightly faster than
    transforming them each individually with a call to
    cogl_matrix_transfom.

 clutter/cogl/cogl/cogl-context.h |   1 +
 clutter/cogl/cogl/cogl-journal.c | 273 +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++-------------------------------------------------------------------------
 2 files changed, 173 insertions(+), 101 deletions(-)

commit a7d88e15270e73025b19f745f21473b832fb1754
Author: Neil Roberts <neil@linux.intel.com>
Date:   Thu Dec 2 21:08:30 2010 +0000

    Revert "cogl: Remove the generated array size for cogl_tex_coord_in"
    
    This reverts commit 4cfe90bde275dbb952645397aa2ba2d6f6e2f3ba.
    
    GLSL 1.00 on GLES doesn't support unsized arrays so the whole idea
    can't work.
    
    Conflicts:
    
            clutter/cogl/cogl/cogl-pipeline-glsl.c

 clutter/cogl/cogl/cogl-context.c                 |   2 +-
 clutter/cogl/cogl/cogl-pipeline-arbfp.c          |   3 ++-
 clutter/cogl/cogl/cogl-pipeline-fixed.c          |   3 ++-
 clutter/cogl/cogl/cogl-pipeline-glsl.c           |  52 +++++++++++++++++++++++++++++++++++++-----
 clutter/cogl/cogl/cogl-pipeline-opengl-private.h |   3 ++-
 clutter/cogl/cogl/cogl-pipeline-opengl.c         |   6 +++--
 clutter/cogl/cogl/cogl-pipeline-private.h        |   3 ++-
 clutter/cogl/cogl/cogl-shader-boilerplate.h      |   1 -
 clutter/cogl/cogl/cogl-shader-private.h          |   6 +++++
 clutter/cogl/cogl/cogl-shader.c                  | 229 ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++----------------------------------------------
 clutter/cogl/cogl/cogl-vertex-attribute.c        |   4 +++-
 clutter/cogl/cogl/cogl.c                         |   9 +++++++-
 clutter/cogl/cogl/cogl2-path.c                   |   4 ++--
 13 files changed, 250 insertions(+), 75 deletions(-)

commit e0ce4cee8c6fb8d40d565cf3890942a0bc898bc0
Author: Damien Lespiau <damien.lespiau@intel.com>
Date:   Thu Dec 2 15:46:40 2010 +0000

    win32: export TARGET and ROOT_DIR in env.sh
    
    So children of the shell sourcing it can use them (eg. buildbot slaves)

 build/mingw/mingw-cross-compile.sh | 4 ++--
 1 file changed, 2 insertions(+), 2 deletions(-)

commit c1878316e02dce0ff10c8e81ee3fa3b6ea9bb9cb
Author: Damien Lespiau <damien.lespiau@intel.com>
Date:   Thu Dec 2 15:41:43 2010 +0000

    win32: Detect the mingw32 cross compiler on Fedora
    
    Fedora mingw32 cross compiler is prefix with i686-pc-mingw32-.

 build/mingw/mingw-cross-compile.sh | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit e73d5b30bbb927eae5ae2cd270df9d79c821c109
Author: Damien Lespiau <damien.lespiau@intel.com>
Date:   Thu Dec 2 14:03:01 2010 +0000

    win32: Update glib and cairo version in mingw-cross-compile.sh
    
    Clutter has moved on and now depends on glib 2.26 and cairo 1.10
    (for cairo-gobject).

 build/mingw/mingw-cross-compile.sh | 4 ++--
 1 file changed, 2 insertions(+), 2 deletions(-)

commit dd5431ef382a59337cfda04bc31cebc28085f17f
Author: Neil Roberts <neil@linux.intel.com>
Date:   Thu Dec 2 16:30:55 2010 +0000

    cogl-pipeline-glsl: Fix reusing shaders for shared ancestors
    
    The check for whether we can reuse a program we've already generated
    was only being done if the pipeline already had a
    glsl_program_state. When there is no glsl_program_state it then looks
    for the nearest ancestor it can share the program with. It then
    wasn't checking whether that ancestor already had a GL program so it
    would start generating the source again. It wouldn't however compile
    that source again because _cogl_pipeline_backend_glsl_end does check
    whether there is already a program. This patch moves the check until
    after it has found the glsl_program_state, whether or not it was found
    from an ancestor or as its own state.

 clutter/cogl/cogl/cogl-pipeline-glsl.c | 32 +++++++++++++++-----------------
 1 file changed, 15 insertions(+), 17 deletions(-)

commit 4cfe90bde275dbb952645397aa2ba2d6f6e2f3ba
Author: Neil Roberts <neil@linux.intel.com>
Date:   Thu Dec 2 12:27:29 2010 +0000

    cogl: Remove the generated array size for cogl_tex_coord_in
    
    Under GLES2 we were defining the cogl_tex_coord_in varying as an array
    with a size determined by the number of texture coordinate arrays
    enabled whenever the program is used. This meant that we may have to
    regenerate the shader with a different size if the shader is used with
    more texture coord arrays later. However in OpenGL the equivalent
    builtin varying gl_TexCoord is simply defined as:
    
    varying vec4 gl_TexCoord[]; /* <-- no size */
    
    GLSL is documented that if you declare an array with no size then you
    can only access it with a constant index and the size of the array
    will be determined by the highest index used. If you want to access it
    with a non-constant expression you need to redeclare the array
    yourself with a size.
    
    We can replicate the same behaviour in our Cogl shaders by instead
    declaring the cogl_tex_coord_in with no size. That way we don't have
    to pass around the number of tex coord attributes enabled when we
    flush a material. It also means that CoglShader can go back to
    directly uploading the source string to GL when cogl_shader_source is
    called so that we don't have to keep a copy of it around.
    
    If the user wants to access cogl_tex_coord_in with a non-constant
    index then they can simply redeclare the array themself. Hopefully
    developers will expect to have to do this if they are accustomed to
    the gl_TexCoord array.

 clutter/cogl/cogl/cogl-context.c                 |   2 +-
 clutter/cogl/cogl/cogl-pipeline-arbfp.c          |   3 +--
 clutter/cogl/cogl/cogl-pipeline-fixed.c          |   3 +--
 clutter/cogl/cogl/cogl-pipeline-glsl.c           |  46 ++++---------------------------------
 clutter/cogl/cogl/cogl-pipeline-opengl-private.h |   3 +--
 clutter/cogl/cogl/cogl-pipeline-opengl.c         |   6 ++---
 clutter/cogl/cogl/cogl-pipeline-private.h        |   3 +--
 clutter/cogl/cogl/cogl-shader-boilerplate.h      |   1 +
 clutter/cogl/cogl/cogl-shader-private.h          |   6 -----
 clutter/cogl/cogl/cogl-shader.c                  | 229 ++++++++++++++++++++++++++++++++++++++++++++++----------------------------------------------------------------------------------------------------------------------------------------
 clutter/cogl/cogl/cogl-vertex-attribute.c        |   4 +---
 clutter/cogl/cogl/cogl.c                         |   9 +-------
 clutter/cogl/cogl/cogl2-path.c                   |   4 ++--
 13 files changed, 73 insertions(+), 246 deletions(-)

commit 50849ac1fdc7840cced9aa1730b5d3f7fd4d5d02
Author: Elliot Smith <elliot.smith@intel.com>
Date:   Tue Nov 30 16:52:01 2010 +0000

    cookbook: Use new API to reverse timeline
    
    clutter_timeline_set_reverse() can be used to
    automatically reverse a timeline's direction each time
    it completes, so use that in looping animation recipe and
    examples.

 doc/cookbook/animations.xml                         | 25 ++++++++++++++++++-------
 doc/cookbook/examples/animations-looping-implicit.c | 24 +-----------------------
 2 files changed, 19 insertions(+), 30 deletions(-)

commit 4f17bf3bcc5c017ef14a876f172ba3b1c3590317
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Tue Nov 30 18:55:38 2010 +0000

    keysyms: Update the list
    
    Add TouchpadOn and TouchpadOff from the X11 key symbols.

 clutter/clutter-keysyms-compat.h | 2 ++
 clutter/clutter-keysyms.h        | 2 ++
 2 files changed, 4 insertions(+)

commit 87a72d188e7d986686106859a4d4f229b20dfe7a
Author: Neil Roberts <neil@linux.intel.com>
Date:   Wed Dec 1 15:48:37 2010 +0000

    cogl-pipeline: Fix comparing layer states for finding codgen authority
    
    When compiling for GLES2, the codegen is affected by state other than
    the layers. That means when we find an authority for the codegen state
    we can't directly look at authority->n_layers to determine the number
    of layers because it isn't necessarily the layer state authority. This
    patch changes it to use cogl_pipeline_get_n_layers instead. Once we
    have two authorities that differ in codegen state we then compare all
    of the layers to decide if they would affect codegen. However it was
    ignoring the fact that the authorities might also differ by the other
    codegen state. This path also adds an extra check for whether
    _cogl_pipeline_compare_differences contains any codegen bits other
    than COGL_PIPELINE_STATE_LAYERS.

 clutter/cogl/cogl/cogl-pipeline.c | 11 +++++++++--
 1 file changed, 9 insertions(+), 2 deletions(-)

commit f620d53054e50e4ddcf656794a38d13c21d0dbf6
Author: Neil Roberts <neil@linux.intel.com>
Date:   Wed Dec 1 14:39:28 2010 +0000

    cogl-pipeline: Fix the codgen authority for texture target changes
    
    When determining if a layer would require a different shader to be
    generated it needs to check a certain set of state changes and it
    needs to check whether the texture target is different. However it was
    checking whether texture texture was different only if the other state
    was also different which doesn't make any sense. It also only checked
    the texture difference if that was the only state change which meant
    that effectively the code was impossible to reach. Now it does the
    texture target check indepent of the other state changes.

 clutter/cogl/cogl/cogl-pipeline.c | 29 ++++++++++++++---------------
 1 file changed, 14 insertions(+), 15 deletions(-)

commit a38fa7a2dfc3a169777ba172d145178b9b068d73
Author: Neil Roberts <neil@linux.intel.com>
Date:   Tue Nov 30 22:28:38 2010 +0000

    cogl-pipeline-fixed: Use the correct state flag for combine constant
    
    The fixed pipeline backend wasn't correctly flushing the combine
    constant because it was using the wrong flag to determine if the
    combine constant has changed since the last flushed material.

 clutter/cogl/cogl/cogl-pipeline-fixed.c | 6 +++---
 1 file changed, 3 insertions(+), 3 deletions(-)

commit 499a370ee326ea24fd0fff55466877a6f286d9fd
Author: Neil Roberts <neil@linux.intel.com>
Date:   Tue Nov 30 22:17:17 2010 +0000

    cogl-pipeline-opengl: Fix enabling previously disabled units
    
    When enabling a unit that was disabled from a previous flush pipeline
    it was forgetting to rebind the right texture unit so it wouldn't
    work. This was causing the redhand to disappear when using the fixed
    function backend in test-cogl-multitexture if anything else is added
    to the scene.

 clutter/cogl/cogl/cogl-pipeline-opengl.c | 1 +
 1 file changed, 1 insertion(+)

commit 17a98875d33c872800c04c26338427970b88b308
Author: Neil Roberts <neil@linux.intel.com>
Date:   Tue Nov 30 22:15:40 2010 +0000

    cogl-pipeline: Add more ignored state changes for program generation
    
    For shader generation backends we don't need to worry about changes to
    the texture object and changing the user matrix. The missing user
    matrix flag was causing test-cogl-multitexture to regenerate the
    shader every frame.

 clutter/cogl/cogl/cogl-pipeline-arbfp.c | 5 ++++-
 clutter/cogl/cogl/cogl-pipeline-glsl.c  | 5 ++++-
 2 files changed, 8 insertions(+), 2 deletions(-)

commit 1564418b3feb9ab010c225129bc1b79b7c882318
Author: Damien Lespiau <damien.lespiau@intel.com>
Date:   Tue Nov 30 16:36:56 2010 +0000

    cogl: Revert "build: Remove unused variable"
    
    Having ctx here produces a warning on GLES. However it's needed for Big
    GL as we have at the top of the file:
    
     #ifdef HAVE_COGL_GL
     #define glClientActiveTexture ctx->drv.pf_glClientActiveTexture
     #endif
    
    This reverts commit 27a3a2056a245aca64b8e3a7d82b7976c13e897a.

 clutter/cogl/cogl/cogl.c | 2 ++
 1 file changed, 2 insertions(+)

commit 8ee91794477c82171e0b165fb9e10655798682a0
Author: Damien Lespiau <damien.lespiau@intel.com>
Date:   Tue Nov 30 16:22:49 2010 +0000

    egl: Fix compilation with EGLX
    
    That what happens when you test things only with 2 configure options
    instead of 3. The 2 tested compile, the third one breaks. Another good
    catch for the eglx bot!

 clutter/egl/clutter-backend-egl.c | 4 ++++
 1 file changed, 4 insertions(+)

commit bbbd91e581ca6d7408c1f6fa2f1b6d50d2c4db2b
Author: Damien Lespiau <damien.lespiau@intel.com>
Date:   Tue Nov 30 16:03:26 2010 +0000

    cogl: Fix unused variable warning with GLES2
    
    This shader variable is only used with big GL.

 clutter/cogl/cogl/cogl-shader.c | 2 ++
 1 file changed, 2 insertions(+)

commit 9ad55edf24f74353c095153e370d6f648f4e5593
Author: Damien Lespiau <damien.lespiau@intel.com>
Date:   Tue Nov 30 10:06:12 2010 -0500

    egl: Don't try to use stage_x11 with non-X winsys
    
    The access to stage_x11 has to be protected by COGL_HAS_X11_SUPPORT.

 clutter/egl/clutter-stage-egl.c | 7 +++++--
 1 file changed, 5 insertions(+), 2 deletions(-)

commit 4ceb95d2ca5f5a52a77bfcada47d5befc6ab1fd1
Author: Damien Lespiau <damien.lespiau@intel.com>
Date:   Tue Nov 30 14:50:13 2010 +0000

    evdev: Add a comment to revisit the GSource management with glib 2.28
    
    With glib 2.28, we'll be able to have one GSource per device manager
    with child sources for earch device. Make a note to update the code
    in a few months.

 clutter/evdev/clutter-device-manager-evdev.c | 7 ++++++-
 1 file changed, 6 insertions(+), 1 deletion(-)

commit 27a3a2056a245aca64b8e3a7d82b7976c13e897a
Author: Damien Lespiau <damien.lespiau@intel.com>
Date:   Fri Nov 19 14:51:39 2010 -0500

    build: Remove unused variable
    
    and be 100% warning free again.

 clutter/cogl/cogl/cogl.c | 2 --
 1 file changed, 2 deletions(-)

commit 9ba5447c9bbbd93808a56d9968b2e60f20bbd328
Author: Damien Lespiau <damien.lespiau@intel.com>
Date:   Fri Nov 19 14:31:51 2010 -0500

    evdev: Enable the compilation of the evdev backend for eglnative
    
    Not tested (but checked that it compiles).
    
    There's no reason to only enable the check for the cex100. Hopefully
    should work.
    
    We make sure not to enable both the evdev and the tslib backend at the
    same time as the DeviceManager is a singleton and we can't have both
    subclasses at the same time for now.

 configure.ac | 17 +++++++++++++++--
 1 file changed, 15 insertions(+), 2 deletions(-)

commit bce4c87232bea82560725fa44e079088d75a367f
Author: Damien Lespiau <damien.lespiau@intel.com>
Date:   Fri Nov 19 14:19:52 2010 -0500

    evdev: Don't oveflow when translating buttons to masks
    
    An array is used to translate the button to its mask. Clutter defines
    the masks for button 1 to 5 but we report BTN_LEFT..BTN_TASK ie
    0x110..0x117. We need to pad the array for the translation not to access
    random data for buttons between 0x115 and 0x117.

 clutter/evdev/clutter-device-manager-evdev.c | 4 ++--
 1 file changed, 2 insertions(+), 2 deletions(-)

commit ac431ac21db043d42fa5b0be604a155503846012
Author: Damien Lespiau <damien.lespiau@intel.com>
Date:   Thu Nov 11 19:11:27 2010 -0500

    input-device: Warn if the device has no associated stage
    
    Discarding the event without any warning when the device has no
    associated stage makes it hard to find the bug for people implementing
    new event backends. We should really warn for that abnormal condition in
    _clutter_input_device_update().

 clutter/clutter-input-device.c | 8 ++++++--
 1 file changed, 6 insertions(+), 2 deletions(-)

commit c20beabf93a97c3e0d58d8512aa5459ca670d3bf
Author: Damien Lespiau <damien.lespiau@intel.com>
Date:   Thu Nov 11 19:07:35 2010 -0500

    evdev: Add mouse support
    
    We know support EV_REL events comming from evdev devices. This addition
    is pretty straigthforward, it adds a x,y per GSource listening to a
    evdev device, updates from EL_REL (relative) events and craft new
    ClutterMotionEvents. As for buttons, BTN_LEFT..BTN_TASK are translated
    to ClutterButtonEvents with 1..8 as button number.

 clutter/evdev/clutter-device-manager-evdev.c | 223 +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++---------------------
 tests/interactive/test-events.c              |   8 +++++--
 2 files changed, 204 insertions(+), 27 deletions(-)

commit 94c2812d720bbdd3db3d779f1f96438b65ae383d
Author: Damien Lespiau <damien.lespiau@intel.com>
Date:   Tue Nov 9 13:14:37 2010 -0500

    evdev: Only create a xkbcommon mapping for keyboard devices

 clutter/evdev/clutter-device-manager-evdev.c | 44 +++++++++++++++++++++++++++-----------------
 1 file changed, 27 insertions(+), 17 deletions(-)

commit 7cd6ba282865491d1e60e830676a363c72f21c25
Author: Damien Lespiau <damien.lespiau@intel.com>
Date:   Tue Nov 9 13:02:53 2010 -0500

    evdev: Close the device gracefully in case of a read() error
    
    Even with udev, the read fails before udev has a chance to signal the
    change. Hence (and to handle errors gracefully anyway), let's remove the
    device from the device manager in case of a read() error.

 clutter/evdev/clutter-device-manager-evdev.c | 20 +++++++++++++++++++-
 1 file changed, 19 insertions(+), 1 deletion(-)

commit afd279dd7684bfd28b07cf668a1aaf213239cfd4
Author: Damien Lespiau <damien.lespiau@intel.com>
Date:   Tue Nov 9 12:50:23 2010 -0500

    evdev: Merge clutter-event-evdev.[ch] into the device manager
    
    The device manager now fully owns the GSources corresponding to the
    devices it manages. This will allow not only to remove the source when
    udev signals a device removal but also handle read() errors gracefully
    by removing the faulty device from the manager.

 clutter/Makefile.am                          |   2 --
 clutter/egl/clutter-backend-egl.c            |   1 -
 clutter/evdev/clutter-device-manager-evdev.c | 320 ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++--
 clutter/evdev/clutter-device-manager-evdev.h |   3 ++
 clutter/evdev/clutter-event-evdev.c          | 367 ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
 clutter/evdev/clutter-event-evdev.h          |  36 -------------------
 6 files changed, 321 insertions(+), 408 deletions(-)

commit afee3b009cff5149a1a97aadb3d8009c7b4a26f8
Author: Damien Lespiau <damien.lespiau@intel.com>
Date:   Tue Nov 9 11:56:26 2010 -0500

    evdev: Support hotplug (addition/removal) of evdev devices
    
    Just connect to the GUdevClient "uevent" signal and deals with
    "add"/"remove" commands. This drives the installation/removal of
    GSource to listen to the device.

 clutter/evdev/clutter-device-manager-evdev.c | 59 +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
 clutter/evdev/clutter-event-evdev.c          | 49 +++++++++++++++++++++++++++++++++++++++++++++++++
 2 files changed, 108 insertions(+)

commit b83a4813a4fbf6818bed9f15d8fcf1d7c3717c9a
Author: Damien Lespiau <damien.lespiau@intel.com>
Date:   Mon Nov 8 11:38:16 2010 -0500

    evdev: Make sure we only add evdev devices
    
    Let's use the sysfs path of the device to make sure we only load evdev
    device, not legacy mousedev ones for instance. We rely on the sysfs
    API/ABI guarantees and look for devices finishing by /input%d/event%d.

 clutter/evdev/clutter-device-manager-evdev.c | 35 ++++++++++++++++++++++++++++-------
 1 file changed, 28 insertions(+), 7 deletions(-)

commit c6493885c3f18042f39273a2efa4fc3616d932b2
Author: Damien Lespiau <damien.lespiau@intel.com>
Date:   Thu Nov 4 10:38:32 2010 -0400

    evdev: First stab at an evdev backend
    
    This backend is a event backend that can be enabled for EGL (for now).
    It uses udev (gudev) to query input devices on a linux system, listens to
    keyboard events from input devices and xkbcommon to translate raw key
    codes into key keysyms.
    
    This commit only supports key events, more to follow.

 clutter/Makefile.am                          |  20 ++++++++++++
 clutter/clutter-device-manager-private.h     |   1 +
 clutter/clutter-input-device.h               |   8 +++++
 clutter/egl/clutter-backend-egl.c            |  49 ++++++++++++++++++++++-------
 clutter/egl/clutter-backend-egl.h            |   6 ++++
 clutter/evdev/clutter-device-manager-evdev.c | 276 +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
 clutter/evdev/clutter-device-manager-evdev.h |  58 ++++++++++++++++++++++++++++++++++
 clutter/evdev/clutter-event-evdev.c          | 318 ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
 clutter/evdev/clutter-event-evdev.h          |  36 +++++++++++++++++++++
 clutter/evdev/clutter-input-device-evdev.c   | 197 +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
 clutter/evdev/clutter-input-device-evdev.h   |  66 +++++++++++++++++++++++++++++++++++++++
 configure.ac                                 |  12 ++++++-
 12 files changed, 1034 insertions(+), 13 deletions(-)

commit 9f5f62b4b53da3354b35789a8c04b83272252b3b
Author: Damien Lespiau <damien.lespiau@intel.com>
Date:   Thu Nov 4 10:09:28 2010 -0400

    evdev: Fix the unicode_value for new ClutterEvents
    
    Looking at what the X11 backend does: the unicode value is being
    translated to the unicode codepoint of the symbol if possible. Let's do
    the same then.
    
    Before that, key events for say KEY_Right (0xff53) had the unicode_value
    set to the keysym, which meant "This key event is actually printable and
    is Unicode codepoint is 0xff53", which lead to interesting results.

 clutter/evdev/clutter-xkb-utils.c | 71 ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++-
 1 file changed, 70 insertions(+), 1 deletion(-)

commit ef5256ec25e6261947e107256ce36ead42fcab88
Author: Damien Lespiau <damien.lespiau@intel.com>
Date:   Thu Nov 4 06:59:22 2010 -0400

    evdev: Factor out the xkbcommon code from the wayland client backend
    
    The wayland client code has support for translating raw linux input
    device key codes coming from the wayland compositor into key symbols
    thanks to libxkbcommon.
    
    A backend directly listening to linux input devices (called evdev, just
    like the Xorg one) could use exactly the same code for the translation,
    so abstract it a bit in a separate file.

 clutter/Makefile.am                            |  11 +++++++----
 clutter/evdev/clutter-xkb-utils.c              | 111 +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
 clutter/evdev/clutter-xkb-utils.h              |  41 +++++++++++++++++++++++++++++++++++++++++
 clutter/wayland/clutter-input-device-wayland.c |  46 ++++++++++------------------------------------
 4 files changed, 169 insertions(+), 40 deletions(-)

commit b5a9de1a23a58c1d52f5a394696a8532dc42befe
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Tue Nov 30 10:35:17 2010 +0000

    moduleset: Add gstreamer and gst-plugins-good

 build/clutter.modules | 26 ++++++++++++++++++++++++++
 1 file changed, 26 insertions(+)

commit 1d153fa860850e4d24df16a64b499a5690fbfeab
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Tue Nov 30 10:34:59 2010 +0000

    moduleset: Disable stand-alone Cally

 build/clutter.modules | 2 ++
 1 file changed, 2 insertions(+)

commit 085962a361d1150f3f59a1e4925e89814a86c931
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Tue Nov 30 10:34:38 2010 +0000

    moduleset: Switch gtk2 to the 2.24 branch

 build/clutter.modules | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 5e085e8d7f26e5191d67657ae4eacf3dab2e9906
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Mon Nov 29 14:21:21 2010 +0000

    Post-release version bump to 1.5.9

 configure.ac       |   2 +-
 po/clutter-1.0.pot | 408 ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++----------------------------------------------------------------------------------------------------------
 po/de.po           | 406 +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++---------------------------------------------------------------------------------------------------------
 po/fr.po           | 406 +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++---------------------------------------------------------------------------------------------------------
 po/id.po           | 406 +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++---------------------------------------------------------------------------------------------------------
 po/it.po           | 406 +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++---------------------------------------------------------------------------------------------------------
 po/pl.po           | 406 +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++---------------------------------------------------------------------------------------------------------
 po/zh_CN.po        | 406 +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++---------------------------------------------------------------------------------------------------------
 8 files changed, 1423 insertions(+), 1423 deletions(-)

commit 8cebec6bdcefe84c2c663fce380c24f5ac88cfa4
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Mon Nov 29 14:09:09 2010 +0000

    Release Clutter 1.5.8 (snapshot)

 configure.ac | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit d046df8e6f1c1dfdf4144b1cbe2494d71ac3adc4
Author: Neil Roberts <neil@linux.intel.com>
Date:   Mon Nov 29 10:55:49 2010 +0000

    cogl-shader.c: Don't add the common boilerplate twice
    
    In 6246c2bd6 I moved the code to add the boilerplate to a shader to a
    separate function and also made it so that the common boilerplate is
    added as a separate string to glShaderSource. However I didn't notice
    that the #define for the vertex and fragment shaders already includes
    the common part so it was being added twice. Mesa seems to accept this
    but it was causing problems on the IMG driver because COGL_VERSION was
    defined twice.

 clutter/cogl/cogl/cogl-shader.c | 8 ++------
 1 file changed, 2 insertions(+), 6 deletions(-)

commit ae300dc8e08d28dad821f7c843fe2b01783efb5a
Author: Neil Roberts <neil@linux.intel.com>
Date:   Mon Nov 29 10:51:40 2010 +0000

    cogl-pipeline-glsl: Use char* instead of GLchar*
    
    It appears that some GLES2 headers don't define GLchar and it works
    just as well to use a regular char.

 clutter/cogl/cogl/cogl-pipeline-glsl.c | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 08308fd3978dff227b8e0c8e1388a590bde29f25
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Mon Nov 29 12:23:14 2010 +0000

    docs: Close a tag

 clutter/clutter-color.c | 2 ++
 1 file changed, 2 insertions(+)

commit 556c938b4d6d3cb4743e00d95c0347e483d847a2
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Mon Nov 29 12:01:20 2010 +0000

    Update NEWS

 NEWS | 4 +++-
 1 file changed, 3 insertions(+), 1 deletion(-)

commit 038fe708f86efda95237915f8bce7fd1afb3a262
Merge: 67143bd84 c9d0f8b26
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Mon Nov 29 11:56:36 2010 +0000

    Merge remote branch 'elliot/cookbook-animations-scaling'
    
    * elliot/cookbook-animations-scaling:
      cookbook: Add recipe for animated scaling of an actor
      cookbook: Add example of scaling a texture
      cookbook: Added "animated scaling" recipe skeleton
      cookbook: Added animated scaling example

commit 67143bd846c2b39ce94779d7ab2b5bd48e58d1cd
Author: Chris Lord <chris@linux.intel.com>
Date:   Thu Nov 25 15:11:42 2010 +0000

    text: Optimise get_preferred_height for single-line-mode
    
    Don't calculate an extra layout in clutter_text_get_preferred_height for
    single-line strings, when it's unnecessary. There's no need to set the
    width of a layout when in single-line mode, as wrapping will not happen.

 clutter/clutter-text.c | 5 ++++-
 1 file changed, 4 insertions(+), 1 deletion(-)

commit e1b58d9407845a249bc59cd270be50d43d34126b
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Mon Nov 29 11:19:16 2010 +0000

    Update NEWS file

 NEWS | 32 ++++++++++++++++++++++++++++++--
 1 file changed, 30 insertions(+), 2 deletions(-)

commit 850a35f069368b645ceb8e027b6b27863dba308b
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Mon Nov 29 10:59:16 2010 +0000

    shader-effect: Remove unused function
    
    The reset_uniforms() internal function is not used any more because the
    CoglProgram cannot be reset post-creation - hence the uniforms cannot
    change.

 clutter/clutter-shader-effect.c | 50 ++++++++++++++++----------------------------------
 1 file changed, 16 insertions(+), 34 deletions(-)

commit 08087c965bf312513f98a53bf3220e92c372d131
Author: Neil Roberts <neil@linux.intel.com>
Date:   Sat Nov 27 16:26:20 2010 +0000

    ClutterShaderEffect: Don't throw away the program for a new actor
    
    Previously when the shader effect is used with a new actor it would
    end up throwing away the old program. I don't think this is neccessary
    and it means if you use an effect to temporarily bind to an actor then
    it will recompile the shader whenever it is applied.
    
    http://bugzilla.clutter-project.org/show_bug.cgi?id=2454

 clutter/clutter-shader-effect.c | 42 +++++++++++++++++++-----------------------
 1 file changed, 19 insertions(+), 23 deletions(-)

commit 2dc9e0dc2941a1f805e71a656585037ced0ed721
Author: Neil Roberts <neil@linux.intel.com>
Date:   Sat Nov 27 16:27:59 2010 +0000

    ClutterOffscreenEffect: Don't throw away the material for a new actor
    
    When a new actor is set for ClutterOffscreenEffect it would throw away
    the old material. I don't think there is anything specifically tied to
    the actor in the material so throwing away just loses Cogl's cached
    state about the material. This ends up relinking the shader every time
    a new actor is set in ClutterShaderEffect.
    
    http://bugzilla.clutter-project.org/show_bug.cgi?id=2454

 clutter/clutter-offscreen-effect.c | 6 ------
 1 file changed, 6 deletions(-)

commit b63e9ee8f8717dbf73e15df1e9a9d115dcb45504
Author: Tomeu Vizoso <tomeu.vizoso@collabora.co.uk>
Date:   Sat Nov 27 16:07:01 2010 +0100

    Don't bail out from creating the FBO if we don't have it yet.
    
    This happens when reattaching an effect to another actor.
    
    http://bugzilla.clutter-project.org/show_bug.cgi?id=2453

 clutter/clutter-offscreen-effect.c | 3 ++-
 1 file changed, 2 insertions(+), 1 deletion(-)

commit 47d63c1c550776de52841f3d5508f20b48f5d722
Author: Tomeu Vizoso <tomeu.vizoso@collabora.co.uk>
Date:   Sat Nov 27 16:04:50 2010 +0100

    Set the signal handler to 0 when disconnecting it.
    
    Otherwise we'll try to disconnect it again later.
    
    http://bugzilla.clutter-project.org/show_bug.cgi?id=2452

 clutter/clutter-actor-meta.c | 5 ++++-
 1 file changed, 4 insertions(+), 1 deletion(-)

commit 215d87abe9ccfe98cbf0e5e73f5c8edf4106a7ce
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Mon Nov 29 08:55:13 2010 +0000

    shader-effect: Zero out ShaderUniform
    
    Do not use the compiler to zero the first field of the GValue member,
    since it's apparently non-portable. As we're allocating memory anyway we
    can let the slice allocator do the zero-ing for us.
    
    Mentioned in: http://bugzilla.clutter-project.org/show_bug.cgi?id=2455

 clutter/clutter-shader-effect.c | 3 +--
 1 file changed, 1 insertion(+), 2 deletions(-)

commit 21e47d4280e27393d7510e232a1b1ee19b426032
Author: Neil Roberts <neil@linux.intel.com>
Date:   Fri Nov 26 15:23:15 2010 +0000

    cogl_pipeline_equal: Fix the comparison for layer texture equality
    
    Before commit 49898d43 CoglPipeline would compare whether a pipeline
    layer's texture is equal by fetching the underlying GL handle. I
    changed that so that it would only compare the CoglHandles because
    that commit removes the GL handle texture overrides and sliced
    textures instead log the underlying primitive texture. However I
    forgot that the primitives don't always use
    _cogl_texture_foreach_sub_texture_in_region when the quad fits within
    the single texture so it won't use a texture override. This meant that
    atlas textures and sub textures get logged with the atlas handle so
    the comparison still needs to be done using the GL handles. It might
    be nice to add a CoglTexture virtual to get the underlying primitive
    texture instead to avoid having the pipeline poke around with GL
    handles.

 clutter/cogl/cogl/cogl-pipeline.c | 9 ++++++++-
 1 file changed, 8 insertions(+), 1 deletion(-)

commit b424bd75124c4dc34510b056376a7f04f4620e53
Author: Robert Bragg <robert@linux.intel.com>
Date:   Mon Nov 1 13:53:16 2010 +0000

    tests: Adds test-cogl-perf micro benchmark
    
    This is mostly a stub, starting point for a one-stop Cogl
    micro-benchmarking tool. The first test it adds is one that tries to
    hammer the Cogl journal, but no doubt there are lots of other things we
    should be regularly testing. Currently the aim is that the tool will be
    able to also generate reports which we can collect to keep track of
    performance changes over time.

 tests/micro-bench/Makefile.am      |   4 +++-
 tests/micro-bench/test-cogl-perf.c | 161 +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
 2 files changed, 164 insertions(+), 1 deletion(-)

commit 58a467c9270ec325431fc963aa8a862ae69fcabf
Author: Robert Bragg <robert@linux.intel.com>
Date:   Thu Nov 25 20:12:36 2010 +0000

    primitives: avoid leaking polygon override materials
    
    If we have to make override changes to the user's source material to
    handle cogl_polygon then we need to make sure we unref the override
    material at the end.

 clutter/cogl/cogl/cogl-primitives.c | 3 +++
 1 file changed, 3 insertions(+)

commit 01b93537ab9743dfd6aa2f0c3d4499420ee860cd
Author: Alexandre Quessy <alexandre@quessy.net>
Date:   Thu Nov 25 13:13:51 2010 -0500

    Fixed "the the" repetitions in some doc strings
    
    http://bugzilla.clutter-project.org/show_bug.cgi?id=2450

 clutter/clutter-actor.c                | 6 +++---
 clutter/clutter-stage.c                | 2 +-
 clutter/clutter-text.c                 | 2 +-
 clutter/cogl/cogl/cogl-fixed.c         | 2 +-
 clutter/cogl/cogl/cogl-vertex-buffer.c | 2 +-
 doc/cookbook/animations.xml            | 2 +-
 doc/cookbook/events.xml                | 2 +-
 7 files changed, 9 insertions(+), 9 deletions(-)

commit 3729e47ef68dd0f4257563985d784b687acce5d2
Author: Robert Bragg <robert@linux.intel.com>
Date:   Thu Nov 25 13:19:59 2010 +0000

    pipeline: Simplify layer change notifications to backend
    
    Previously we used the layers->backend_priv[] members to determine when
    to notify backends about layer changes, but it entirely up to the
    backends if they want to associate private state with layers, even
    though they may still be interested in layer change notifications (they
    may associate layer related state with the owner pipeline).
    
    We now make the observation that in
    _cogl_pipeline_backend_layer_change_notify we should be able to assume
    there can only be one backend currently associated with the layer
    because we wouldn't allow changes to a layer with multiple dependants.
    This means we can determine the backend to notify by looking at the
    owner pipeline instead.

 clutter/cogl/cogl/cogl-pipeline.c | 22 ++++++++++------------
 1 file changed, 10 insertions(+), 12 deletions(-)

commit 6ddb8397110f6e6998e0262e5d3dd604cd93d670
Author: Neil Roberts <neil@linux.intel.com>
Date:   Thu Nov 25 10:56:50 2010 +0000

    clutter-offscreen-effect: Don't recreate the material when FBO changes
    
    Previously whenever the size of the FBO changes it would create a new
    material and attach the texture to it. This is not good for Cogl
    because it throws away any cached state for the material. In
    test-rotate the size of the FBO changes constantly so it effectively
    uses a new material every paint. For shader effects this also ends up
    relinking the shader every paint because the linked programs are part
    of the material state.

 clutter/clutter-offscreen-effect.c | 12 +++++-------
 1 file changed, 5 insertions(+), 7 deletions(-)

commit 1b2a748d6c180454f0501859b4b02dc8c94d75e0
Author: Neil Roberts <neil@linux.intel.com>
Date:   Wed Nov 24 18:37:47 2010 +0000

    cogl-context: Get rid of the features_cached member
    
    The features_cached member of CoglContext is intended to mark when
    we've calculated the features so that we know if they are ready in
    cogl_get_features. However we always intialize the features while
    creating the context so features_cached will never be FALSE so it's
    not useful. We also had the odd behaviour that the COGL_DEBUG feature
    overrides were only applied in the first call to
    cogl_get_features. However there are other functions that use the
    feature flags such as cogl_features_available that don't use this
    function so in some cases the feature flags will be interpreted before
    the overrides are applied. This patch makes it always initialize the
    features and apply the overrides immediately while creating the
    context. This fixes a problem with COGL_DEBUG=disable-arbfp where the
    first material flushed is done before any call to cogl_get_features so
    it may still use ARBfp.

 clutter/cogl/cogl/cogl-context.c          | 24 +++++++++++++++++++++++-
 clutter/cogl/cogl/cogl-context.h          |  1 -
 clutter/cogl/cogl/cogl.c                  | 24 ------------------------
 clutter/cogl/cogl/driver/gl/cogl-gl.c     |  1 -
 clutter/cogl/cogl/driver/gles/cogl-gles.c |  1 -
 5 files changed, 23 insertions(+), 28 deletions(-)

commit b9176e8672fa56cf627b3d47e06598338d32e5ea
Author: Neil Roberts <neil@linux.intel.com>
Date:   Wed Nov 24 17:42:34 2010 +0000

    Lower the priority of the GLSL pipeline backend
    
    Now that the GLSL backend can generate code it can effectively handle
    any pipeline unless there is an ARBfp program. However with current
    open source GL drivers the ARBfp compiler is more stable so it makes
    sense to prefer ARBfp when possible. The GLSL backend is also lower
    than the fixed function backend on the assumption that any driver that
    supports GLSL will also support ARBfp so it's quicker to try the fixed
    function backend next.

 clutter/cogl/cogl/cogl-pipeline-private.h | 12 ++++++------
 1 file changed, 6 insertions(+), 6 deletions(-)

commit d19f6212ce84894a79554f183d001deb25464721
Author: Neil Roberts <neil@linux.intel.com>
Date:   Wed Nov 24 17:29:00 2010 +0000

    Add a COGL_DEBUG option to disable the fixed function pipeline backend
    
    This adds COGL_DEBUG=disable-fixed to disable the fixed function
    pipeline backend. This is needed to test the GLSL shader generation
    because otherwise the fixed function backend would always override it.

 clutter/cogl/cogl/cogl-debug-options.h  |  5 +++++
 clutter/cogl/cogl/cogl-debug.c          |  1 +
 clutter/cogl/cogl/cogl-debug.h          | 15 ++++++++-------
 clutter/cogl/cogl/cogl-pipeline-fixed.c |  3 +++
 4 files changed, 17 insertions(+), 7 deletions(-)

commit 577d65c2c964aba9046aa07ef76aaf1a99c32b70
Author: Neil Roberts <neil@linux.intel.com>
Date:   Wed Nov 24 17:33:07 2010 +0000

    Don't use the fixed function backend if there is a user program
    
    The fixed function pipeline backend can't handle a user program so it
    should bail out if one is given.

 clutter/cogl/cogl/cogl-pipeline-fixed.c | 6 ++++++
 1 file changed, 6 insertions(+)

commit aa498072e075cc1ef4a85a0d14fb7b78ba749e3a
Author: Neil Roberts <neil@linux.intel.com>
Date:   Wed Nov 24 17:37:55 2010 +0000

    Add a warning message when no usable Cogl pipeline backend is found
    
    If none of the pipeline backends can handle the state then it now
    displays a warning so the developer has a chance to work out what's
    going on.

 clutter/cogl/cogl/cogl-pipeline-opengl.c | 3 +++
 1 file changed, 3 insertions(+)

commit 289e880efd4b7e2434619cbbe18ae444d4c52fd8
Author: Neil Roberts <neil@linux.intel.com>
Date:   Wed Nov 24 15:30:56 2010 +0000

    cogl-pipeline-glsl: Don't use gl_PointCoord on OpenGL
    
    We don't want to use gl_PointCoord to implement point sprites on big
    GL because in that case we already use glTexEnv(GL_COORD_REPLACE) to
    replace the texture coords with the point sprite coords. Although GL
    also supports the gl_PointCoord variable, it requires GLSL 1.2 which
    would mean we would have to declare the GLSL version and check for
    it. We continue to use gl_PointCoord for GLES2 because it has no
    glTexEnv function.

 clutter/cogl/cogl/cogl-pipeline-glsl.c | 9 ++++++++-
 1 file changed, 8 insertions(+), 1 deletion(-)

commit 9c32d07453fbc06c44e8c0fca6ef6e85f23ebf0b
Author: Neil Roberts <neil@linux.intel.com>
Date:   Sat Jul 17 14:11:02 2010 +0100

    Add a conformance test that uses a vertex shader with no frag shader
    
    This creates a material which users a layer to override the color of
    the rectangle. A simple vertex shader is then created which just
    emulates the fixed function pipeline. No fragment shader is
    added. This demonstrates a bug where the layer state is getting
    ignored when a vertex shader is in use.
    
    http://bugzilla.clutter-project.org/show_bug.cgi?id=2221

 tests/conform/Makefile.am                    |   1 +
 tests/conform/test-cogl-just-vertex-shader.c | 135 +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
 tests/conform/test-conform-main.c            |   2 ++
 3 files changed, 138 insertions(+)

commit a50010fb408294dce2d1205fe3a70aeead39c192
Author: Neil Roberts <neil@linux.intel.com>
Date:   Tue Nov 23 14:47:17 2010 +0000

    Remove the fragment shader generation from the GLES2 wrapper
    
    The GLES2 wrapper no longer needs to generate any fragment shader
    state because the GLSL pipeline backend will always give the wrapper a
    custom fragment shader. This simplifies a lot of the state comparison
    done by the wrapper. The fog generation is also removed even though
    it's actually part of the vertex shader because only the fixed
    function pipeline backend actually calls the fog functions so it would
    be disabled when using any of the other backends anyway. We can fix
    this when the two shader backends also start generating vertex
    shaders.

 clutter/cogl/cogl/Makefile.am                                 |   5 +-
 clutter/cogl/cogl/cogl-pipeline-opengl.c                      |   8 ++
 clutter/cogl/cogl/driver/gles/cogl-fixed-fragment-shader.glsl |  64 ---------------
 clutter/cogl/cogl/driver/gles/cogl-gles2-wrapper.c            | 737 +++----------------------------------------------------------------------------------------------------------------------------------------------------------------------
 clutter/cogl/cogl/driver/gles/cogl-gles2-wrapper.h            |  69 +---------------
 5 files changed, 22 insertions(+), 861 deletions(-)

commit 987e3c32dc733b5f6942a10651750080730272e6
Author: Neil Roberts <neil@linux.intel.com>
Date:   Tue Nov 23 14:51:49 2010 +0000

    Disable the fixed function backend for GLES2
    
    GLES2 doesn't really support fixed function so if we disable it we can
    remove the fixed function wrappers from the GLES2 Cogl backend.

 clutter/cogl/cogl/cogl-pipeline-fixed.c   | 11 -----------
 clutter/cogl/cogl/cogl-pipeline-private.h |  4 +---
 clutter/cogl/cogl/cogl-pipeline.c         |  2 ++
 3 files changed, 3 insertions(+), 14 deletions(-)

commit 3504491b46246ffe912939defa17d013f9a27b46
Author: Neil Roberts <neil@linux.intel.com>
Date:   Mon Nov 22 18:33:49 2010 +0000

    cogl-pipeline-glsl: Generate the alpha test snippet under GLES2
    
    GLES2 has no glAlphaFunc function so we need to simulate the behaviour
    in the fragment shader. The alpha test function is simulated with an
    if-statement and a discard statement. The reference value is stored as
    a uniform.

 clutter/cogl/cogl/cogl-pipeline-glsl.c | 144 ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++----
 1 file changed, 140 insertions(+), 4 deletions(-)

commit c3582b77dfc553528e49a8f3a1373a787cf64648
Author: Neil Roberts <neil@linux.intel.com>
Date:   Mon Nov 22 18:32:43 2010 +0000

    cogl-pipeline: Add getters for the alpha test state
    
    This adds two public functions:
    
     cogl_pipeline_get_alpha_test_function
       and
     cogl_pipeline_get_alpha_test_reference.

 clutter/cogl/cogl/cogl-pipeline.c | 25 +++++++++++++++++++++++++
 clutter/cogl/cogl/cogl-pipeline.h | 22 ++++++++++++++++++++++
 2 files changed, 47 insertions(+)

commit 959846326fa138d9611212f0e1c6626e187984b8
Author: Neil Roberts <neil@linux.intel.com>
Date:   Mon Nov 22 18:29:50 2010 +0000

    cogl: Separate out state flags for the alpha test func and ref
    
    Previously the flag to mark the differences for the alpha test
    function and reference value were conflated into one. However this is
    awkward when generating shader code to simulate the alpha testing for
    GLES 2 because in that case changing the function would need a
    different program but changing the reference value just requires
    updating a uniform. This patch makes the function and reference have
    their own state flags.

 clutter/cogl/cogl/cogl-pipeline-opengl.c  |   3 ++-
 clutter/cogl/cogl/cogl-pipeline-private.h |  25 ++++++++++++++-----------
 clutter/cogl/cogl/cogl-pipeline.c         | 110 ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++------------------------
 3 files changed, 102 insertions(+), 36 deletions(-)

commit 124441aade679834ce7e34f38f9e10bd829aa76b
Author: Neil Roberts <neil@linux.intel.com>
Date:   Mon Nov 22 16:44:11 2010 +0000

    Remove the disabling of layer constants for GLES2
    
    The GLSL shader generation supports layer combine constants so there's
    no need to disable it for GLES2. It looks like there was also code for
    it in the GLES2 wrapper so I'm not sure why it was disabled in the
    first place.

 clutter/cogl/cogl/cogl-blend-string.c | 10 ----------
 1 file changed, 10 deletions(-)

commit 3fa73735c02e2e6471774f2a4253317e424564ee
Author: Neil Roberts <neil@linux.intel.com>
Date:   Fri Nov 19 10:44:27 2010 +0000

    Generate GLSL in the CoglPipeline GLSL backend
    
    The GLSL pipeline backend can now generate code to represent the
    pipeline state in a similar way to the ARBfp backend. Most of the code
    for this is taken from the GLES 2 wrapper.

 clutter/cogl/cogl/cogl-context.c       |   1 +
 clutter/cogl/cogl/cogl-context.h       |   1 +
 clutter/cogl/cogl/cogl-pipeline-glsl.c | 772 ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++------------------
 3 files changed, 702 insertions(+), 72 deletions(-)

commit 6246c2bd6cc5174529f5a6c5efb7daf44c131b6b
Author: Neil Roberts <neil@linux.intel.com>
Date:   Mon Nov 22 12:15:35 2010 +0000

    Move the cogl shader boilerplate setting code to a separate function
    
    _cogl_shader_compile_real had some code to create a set of strings to
    combine the boilerplate code with a shader before calling
    glShaderSource. This has now been moved to its own internal function
    so that it could be used from the GLSL pipeline backend as well.

 clutter/cogl/cogl/cogl-shader-private.h |  8 ++++++++
 clutter/cogl/cogl/cogl-shader.c         | 96 ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++----------------------
 2 files changed, 82 insertions(+), 22 deletions(-)

commit 339fc68bcbc15dbb212684be5cb4155cdaf4c836
Author: Neil Roberts <neil@linux.intel.com>
Date:   Fri Nov 19 15:42:26 2010 +0000

    Move need_texture_combine_separate to cogl-pipeline
    
    need_texture_combine_separate is moved to cogl-pipeline.c and renamed
    to _cogl_pipeline_need_texture_combine_separate. The function is
    needed by both the ARBfp and GLSL codegen backends so it makes sense to
    share it.

 clutter/cogl/cogl/cogl-pipeline-arbfp.c   | 75 +--------------------------------------------------------------------------
 clutter/cogl/cogl/cogl-pipeline-private.h |  4 ++++
 clutter/cogl/cogl/cogl-pipeline.c         | 74 ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
 3 files changed, 79 insertions(+), 74 deletions(-)

commit 9bbb088a2ad3e7758b65f83c181e0603350acfc1
Author: Neil Roberts <neil@linux.intel.com>
Date:   Fri Nov 19 10:43:52 2010 +0000

    Move find_arbfp_authority to cogl-pipeline.c
    
    The code for finding the arbfp authority for a pipeline should be the
    same as finding the GLSL authority. So that the code can be shared the
    function has been moved to cogl-pipeline.c and renamed to
    _cogl_pipeline_find_codegen_authority.

 clutter/cogl/cogl/cogl-pipeline-arbfp.c   | 145 +------------------------------------------------------------------------------------------------------------------------------------------------
 clutter/cogl/cogl/cogl-pipeline-private.h |   4 ++++
 clutter/cogl/cogl/cogl-pipeline.c         | 142 ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
 3 files changed, 147 insertions(+), 144 deletions(-)

commit e57a132f940d1b0f1c66720096c446e4f04bf4dc
Author: Neil Roberts <neil@linux.intel.com>
Date:   Mon Nov 1 17:25:26 2010 +0000

    cogl: Rename arbfp_source_buffer to fragment_source_buffer
    
    Only one of the material backends can be generating code at the same
    time so it seems to make sense to share the same source buffer between
    arbfp and glsl. The new name is fragment_source_buffer in case we
    later want to create a new buffer for the vertex shader. That probably
    couldn't share the same buffer because it will likely need to be
    generated at the same time.

 clutter/cogl/cogl/cogl-context.c        | 2 +-
 clutter/cogl/cogl/cogl-context.h        | 2 +-
 clutter/cogl/cogl/cogl-pipeline-arbfp.c | 6 +++---
 3 files changed, 5 insertions(+), 5 deletions(-)

commit 9b5c90f441938c8044eecaf9c348c85708d45ce3
Author: Evan Nemerson <evan@coeus-group.com>
Date:   Fri Nov 19 23:27:46 2010 -0800

    cogl: Include exported pacakges information in GIR
    
    http://bugzilla.clutter-project.org/show_bug.cgi?id=2438

 clutter/cogl/cogl/Makefile.am | 1 +
 1 file changed, 1 insertion(+)

commit f687ec6a226fa3914c6cf81fbad6b43786a2e1dc
Author: Chris Lord <chris@linux.intel.com>
Date:   Wed Nov 24 16:34:21 2010 +0000

    docs: Update documentation to reflect automatic map/unmap/etc.
    
    Update the ClutterActor documentation to reflect the new automatic
    map/unmap/realize/unrealize implementations.

 clutter/clutter-actor.h                            |  6 ++++--
 doc/reference/clutter/subclassing-ClutterActor.xml | 10 +---------
 2 files changed, 5 insertions(+), 11 deletions(-)

commit 186d5698ceb32e3b99d52390e29c5609fa3a8ae2
Author: Chris Lord <chris@linux.intel.com>
Date:   Tue Oct 26 17:09:24 2010 +0100

    actor: Use the internal child list for map/unmap
    
    Use the internal child list for the default map/unmap vfuncs. This removes
    the requirement for non-container composite actors to implement their own
    map/unmap functions.

 clutter/clutter-actor.c | 22 ++++++++++++++--------
 1 file changed, 14 insertions(+), 8 deletions(-)

commit 4752cc38b2000ba643fc9451769ebb2da9873280
Author: Robert Bragg <robert@linux.intel.com>
Date:   Wed Oct 20 18:26:01 2010 +0100

    actor: re-work unrealize to work with composite actors
    
    Unrealizing an actor is a recursive process that needs to traverse the
    children of an actor to ensure they are also unrealized. This maintains
    the invariant that if any given actor is marked as unrealized then you
    know that all its children have also been unrealized.
    
    The previous implementation would use the container interface's
    foreach_with_internals vfunc to explicitly traverse the children of
    container actors but this didn't consider composite actors that aren't
    containers.
    
    Since clutter-actor now maintains an explicit list of children we can
    also handle composite actors that aren't containers using
    _clutter_actor_traverse.

 clutter/clutter-actor.c | 57 +++++++++++++++++++++++++++++++++------------------------
 1 file changed, 33 insertions(+), 24 deletions(-)

commit 4bda67473283b9b10a21b72df01d54447c7d557f
Author: Robert Bragg <robert@linux.intel.com>
Date:   Wed Oct 20 15:40:30 2010 +0100

    actor: make _clutter_actor_traverse more flexible
    
    This makes it possible to choose the traversal order; either depth first
    or breadth first and when visiting actors in a depth first order there
    is now a callback called before children are traversed and one called
    after. Some tasks such as unrealizing actors need to explicitly control
    the traversal order to maintain the invariable that all children of an
    actor are unrealized before we actually mark the parent as unrealized.
    
    The callbacks are now passed the relative depth in the graph of the
    actor being visited and instead of only being able to return a boolean
    to bail out of further traversal it can now do one of: continue,
    skip_children or break. To implement something like unrealize it's
    desirable to skip children that you find have already been unrealized.

 clutter/clutter-actor-private.h |  47 ++++++++++++++++++++++++++++++++++++++++++++---
 clutter/clutter-actor.c         | 146 +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++---------------------------
 2 files changed, 163 insertions(+), 30 deletions(-)

commit 9df6f0c52445ef9c3c5343c1f0aee63c67bffe06
Author: Owen W. Taylor <otaylor@fishsoup.net>
Date:   Tue Oct 5 13:05:45 2010 -0400

    ClutterX11TexturePixmap: Optimize ConfigureEvent handling
    
    ClutterX11TexturePixmap watches for configure events to tell when it
    needs to name a new pixmap for the window. However, ConfigureEvents
    occur on moves in addition to resizes, and doing round trips and
    naming new pixmaps every time a window is moved is a real performance
    killer.
    
    Add clutter_x11_texture_pixmap_sync_window_internal() that takes the
    size/position of the window as arguments rather than always calling
    XGetWindowAttributes. This allows us to bypass all work other than
    notifying the window-x/window-y properties when we get a ConfigurEvent
    for a move.
    
    The last received width/height is saved to allow us to also omit
    XGetWindowAttributes on MapNotify events.
    
    The public clutter_x11_texture_pixmap_sync_window() becomes a bit less
    efficient since we no longer combine the roundtrips for
    XGetWindowAttributes() and XCompositeNameWindowPixmap(), but it appears
    to have no callers in current publicly available code.
    
    Several FIXME's are added for areas where there are still weird things
    going on in the code or improvements could be made.
    
    http://bugzilla.clutter-project.org/show_bug.cgi?id=2356

 clutter/x11/clutter-x11-texture-pixmap.c | 189 ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++---------------------------------------------------------
 1 file changed, 132 insertions(+), 57 deletions(-)

commit 1fdd82fcf1234a9b6c6fbcff05a62ce8f1eefcab
Author: Neil Roberts <neil@linux.intel.com>
Date:   Wed Nov 17 17:31:23 2010 +0000

    test-cogl-texture-get-set-data: Test the alpha component
    
    Previously the alpha component of the test texture data was always set
    to 255 and the data was read back as RGB so that the alpha component
    is ignored. Now the alpha component is set to a generated value and
    the data is read back a second time as RGBA to verify that Cogl is not
    doing any premult conversions when the internal texture and target
    data is the same.
    
    http://bugzilla.clutter-project.org/show_bug.cgi?id=2414

 tests/conform/test-cogl-texture-get-set-data.c | 39 ++++++++++++++++++++++++++++++++++++---
 1 file changed, 36 insertions(+), 3 deletions(-)

commit 8b4034cd06035e49bbe709daf2977d828cb0f263
Author: Owen W. Taylor <otaylor@fishsoup.net>
Date:   Fri Nov 12 11:02:13 2010 -0500

    Use FBOs and use cogl_read_pixels() to efficiently read partial textures
    
    * cogl_texture_get_data() is converted to use
       _cogl_texture_foreach_sub_texture_in_region() to iterate
      through the underlying textures.
    
     * When we need to read only a portion of the underlying
       texture, we set up a FBO and use _cogl_read_pixels()
       to read the portion we need. This is enormously more
       efficient for reading a small portion of a large atlas
       texture.
    
     * The CoglAtlasTexture, CoglSubTexture, and CoglTexture2dSliced
       implementation of get_texture() are removed.
    
    http://bugzilla.clutter-project.org/show_bug.cgi?id=2414

 clutter/cogl/cogl/cogl-atlas-texture.c     |  17 +----------------
 clutter/cogl/cogl/cogl-sub-texture.c       |  70 +--------------------------------------------------------------------
 clutter/cogl/cogl/cogl-texture-2d-sliced.c | 149 +-------------------------------------------------------------------------------------------------------------------------------------------------
 clutter/cogl/cogl/cogl-texture.c           | 191 ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++--------
 4 files changed, 186 insertions(+), 241 deletions(-)

commit 519b6fe6f259762f05a638716691f626b3b54f12
Author: Neil Roberts <neil@linux.intel.com>
Date:   Wed Nov 17 17:57:17 2010 +0000

    cogl-framebuffer: Try to track format of the framebuffer
    
    Previously in cogl_read_pixels we assume the format of the framebuffer
    is always premultiplied because that is the most likely format with
    the default Cogl blend mode. However when the framebuffer is bound to
    a texture we should be able to make a better guess at the format
    because we know the texture keeps track of the premult status. This
    patch adds an internal format member to CoglFramebuffer. For onscreen
    framebuffers we still assume it is RGBA_8888_PRE but for offscreen to
    textures we copy the texture format. cogl_read_pixels uses this to
    determine whether the data returned by glReadPixels will be
    premultiplied.
    
    http://bugzilla.clutter-project.org/show_bug.cgi?id=2414

 clutter/cogl/cogl/cogl-framebuffer-private.h |  3 +++
 clutter/cogl/cogl/cogl-framebuffer.c         | 15 +++++++++++++++
 clutter/cogl/cogl/cogl.c                     | 22 ++++++++++------------
 3 files changed, 28 insertions(+), 12 deletions(-)

commit 08e1d7f57438fc563253906de735412329366b45
Author: Neil Roberts <neil@linux.intel.com>
Date:   Wed Nov 17 17:45:27 2010 +0000

    cogl_read_pixels: Fix the format used in GLES2
    
    When converting the data in cogl_read_pixels it was using bmp_format
    instead of the format passed in to the function. bmp_format is the
    same as the passed in format except that it always has the premult bit
    set. Therefore the conversion would not handle premultiply correctly.
    
    http://bugzilla.clutter-project.org/show_bug.cgi?id=2414

 clutter/cogl/cogl/cogl.c | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 2bd054f886a1ecd18837e6be9e48b379b8628754
Author: Neil Roberts <neil@linux.intel.com>
Date:   Wed Nov 17 15:38:20 2010 +0000

    Add an internal _cogl_read_pixels_with_rowstride
    
    This is the same as _cogl_read_pixels except that it takes a rowstride
    parameter for the destination buffer. Under OpenGL setting the
    rowstride this will end up calling GL_ROW_LENGTH so that the buffer
    region can be directly written to. Under GLES GL_ROW_LENGTH is not
    supported so it will use an intermediate buffer as it does if the
    format is not GL_RGBA.
    
    cogl_read_pixels now just calls the full version of the function with
    the rowstride set to width*bpp.
    
    http://bugzilla.clutter-project.org/show_bug.cgi?id=2414

 clutter/cogl/cogl/cogl-private.h | 10 ++++++++++
 clutter/cogl/cogl/cogl.c         | 39 ++++++++++++++++++++++++++++-----------
 2 files changed, 38 insertions(+), 11 deletions(-)

commit b4016f64fa9c82266e4827fb06826319a418d9d9
Author: Neil Roberts <neil@linux.intel.com>
Date:   Thu Nov 11 15:28:44 2010 +0000

    Add an internal _cogl_offscreen_new_to_texture_full function
    
    This function is the same as cogl_offscreen_new_to_texture but it
    takes a level parameter and a set of flags so that FBOs can be used to
    render to higher mipmap levels and to disable the depth and stencil
    buffers. cogl_offscreen_new_to_texture now just calls the new function
    with the level set to zero. This function could be useful in a few
    places in Cogl where we want to use FBOs as an implementation detail
    such as when copying between textures.
    
    http://bugzilla.clutter-project.org/show_bug.cgi?id=2414

 clutter/cogl/cogl/cogl-framebuffer-private.h |  24 ++++++++++++++++++++++++
 clutter/cogl/cogl/cogl-framebuffer.c         | 100 ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++------------------------
 2 files changed, 100 insertions(+), 24 deletions(-)

commit d52bd995a6a5012fc363b607a9ac79b2748087db
Author: Owen W. Taylor <otaylor@fishsoup.net>
Date:   Fri Nov 12 10:58:59 2010 -0500

    Test slicing when getting data in both directions
    
    http://bugzilla.clutter-project.org/show_bug.cgi?id=2414

 tests/conform/test-cogl-texture-get-set-data.c | 2 ++
 1 file changed, 2 insertions(+)

commit a53b9febcdd60c322933e41e4ded6247da1f8bef
Author: Robert Bragg <robert@linux.intel.com>
Date:   Tue Nov 23 16:48:59 2010 +0000

    stage: if backend _ignoring_redraw_clips queue full redraw
    
    In clutter_stage_real_queue_redraw we were checking to see if the
    backend will ignore any subsequent redraw_clip so we can avoid the cost
    of projecting the paint-volume of an actor into stage coordinates, but
    we weren't ensuring that a full redraw would be queued instead we just
    bailed out immediately. This makes sure to call
    _clutter_stage_window_add_redraw_clip (stage_window, NULL) in this case
    to make sure the backend will do an un-clipped redraw.

 clutter/clutter-stage.c | 5 ++++-
 1 file changed, 4 insertions(+), 1 deletion(-)

commit 5f181f7265fe043025583e3a7747e9ce55bd65ba
Author: Robert Bragg <robert@linux.intel.com>
Date:   Tue Nov 23 16:05:44 2010 +0000

    stage-window: tweak has_redraw_clips semantics
    
    This tweaks the semantics of the has_redraw_clips vfunc so we can assume
    that at the start of a new frame there is an implied, initial,
    redraw_clip that clips everything (i.e. nothing would be redrawn) so in
    that case we would expect the has_redraw_clips vfunc to return True at
    the start of a new frame for backends that support clipping.
    
    Previously there was an ambiguity when this function returned False
    since it could either mean a full screen redraw had been queued or it
    could mean that the clip state wasn't yet initialized for that frame.
    This would result in _clutter_stage_has_full_redraw_queued() returning
    True at the start of a new frame even before any actors have been
    updated, which in turn meant we would incorrectly ignore queue_redraw
    requests for actors, believing them to be redundant.

 clutter/clutter-stage-window.c  | 16 ++++++++++++++++
 clutter/egl/clutter-stage-egl.c | 19 +++++++++++++------
 clutter/glx/clutter-stage-glx.c | 21 ++++++++++++++-------
 3 files changed, 43 insertions(+), 13 deletions(-)

commit c9d0f8b26e8ca6e67b52a1cc2a54d247919d09a9
Author: Elliot Smith <elliot.smith@intel.com>
Date:   Wed Nov 24 12:44:35 2010 +0000

    cookbook: Add recipe for animated scaling of an actor
    
    Recipe explains how to animate scaling a single actor.
    
    Also covers scaling vs. resizing, scale center, and
    scaling within layouts and containers.
    
    The first example shows how animations around each scale
    gravity look, as well as tracking the transformed position
    and size of the actor and displaying those.
    
    The second example is a simple image viewer with zoom in/out
    using scaling.

 doc/cookbook/animations.xml | 305 +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++--------------------------------
 1 file changed, 257 insertions(+), 48 deletions(-)

commit ee9a4d02bba8bb0cf6ea73c5cdcce49fb29f786e
Author: Elliot Smith <elliot.smith@intel.com>
Date:   Wed Nov 24 12:22:12 2010 +0000

    cookbook: Add example of scaling a texture
    
    Added a simple application for scaling a
    texture while keeping the mouse pointer over
    the same coordinates on its surface.

 doc/cookbook/examples/Makefile.am               |   2 ++
 doc/cookbook/examples/animations-scaling-zoom.c | 155 +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
 2 files changed, 157 insertions(+)

commit c8f112876e69ca2aeb9eb202c504bcf24ecab921
Author: Elliot Smith <elliot.smith@intel.com>
Date:   Fri Nov 19 14:52:44 2010 +0000

    cookbook: Added "animated scaling" recipe skeleton

 doc/cookbook/animations.xml | 132 ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
 1 file changed, 132 insertions(+)

commit b47b2f474910ead5b72eae88ebc53c2f667b93d7
Author: Elliot Smith <elliot.smith@intel.com>
Date:   Fri Nov 19 14:29:39 2010 +0000

    cookbook: Added animated scaling example
    
    Added an example showing scaling of an actor on
    each of the scaling gravity settings (NORTH_WEST, NORTH etc.),
    with a mark indicating the center being used.
    
    Displays the transformed size and position, updated
    on each paint of the actor.

 doc/cookbook/examples/Makefile.am          |   2 ++
 doc/cookbook/examples/animations-scaling.c | 183 +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
 2 files changed, 185 insertions(+)

commit 446107f19d59ab95c918e566b5d8efdb8c0841c8
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Wed Nov 24 12:02:38 2010 +0000

    x11: Check for initialized context when enabling ARGB visuals
    
    Instead of using the backend singleton. This allows lazy initialization
    of Clutter.
    
    http://bugzilla.clutter-project.org/show_bug.cgi?id=2435

 clutter/x11/clutter-backend-x11.c | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 6a552e27abfa2e0f0705ac935872e5393cdf1fdc
Author: Tomeu Vizoso <tomeu.vizoso@collabora.co.uk>
Date:   Tue Nov 23 17:06:52 2010 +0100

    Fix API docs for ClutterShaderEffects
    
    It can implement now both fragment and vertex shaders.
    
    http://bugzilla.clutter-project.org/show_bug.cgi?id=2442

 clutter/clutter-shader-effect.c | 7 +++----
 1 file changed, 3 insertions(+), 4 deletions(-)

commit 65d0ce607efe6cbc72e3f1f4518c8cf5d038ceee
Author: Robert Bragg <robert@linux.intel.com>
Date:   Tue Nov 23 14:31:45 2010 +0000

    stage: Report an unknown paint volume.
    
    Previously we were leaving it up to the default implementation of
    get_paint_volume in ClutterGroup to handle the stage by determining the
    bounding box of all contained children. This isn't the true bounding box
    of the stage though since the stage is responsible for clearing the
    entire framebuffer at the start of the frame. This adds a
    get_paint_volume implementation for ClutterStage which simply returns
    False which means Clutter has to assume it covers everything.

 clutter/clutter-stage.c | 10 ++++++++++
 1 file changed, 10 insertions(+)

commit 52bf38c38c4b1d0c787cccf5e1ea2518a67ac1bf
Author: Robert Bragg <robert@linux.intel.com>
Date:   Tue Nov 23 14:30:08 2010 +0000

    x11: only queue clipped redraw for Expose
    
    When we handle Expose events we try and queue a clipped redraw of the
    stage, but for some reason we were also redundantly calling
    clutter_actor_queue_redraw for the stage which would negate the request
    to queue a clipped redraw.

 clutter/x11/clutter-event-x11.c | 2 --
 1 file changed, 2 deletions(-)

commit 1b7c895a2d041a36ad9279044e47542be8c0ba95
Author: Neil Roberts <neil@linux.intel.com>
Date:   Tue Nov 23 14:07:16 2010 +0000

    cogl-texture-driver-gles: Fix image height for uploading 3D textures
    
    When uploading a 3D texture with an awkward rowstride, on GLES Cogl
    will copy the images to an intermediate buffer to pass to GL. However
    it was using the wrong height when copying the data so it would end up
    overflowing the buffer and crashing.

 clutter/cogl/cogl/driver/gles/cogl-texture-driver-gles.c | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 01c6ccfa1336216c74829386912806ca02e1ab12
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Tue Nov 23 13:05:47 2010 +0000

    pipeline: Use WrapModeInternal in the Layer struct
    
    Since we're using CoglPipelineWrapModeInternal in the internal API
    anyway, and the compiler complains loudly when comparing two enumeration
    types without casting, the PipelineLayer struct should store the
    wrap modes using the internal enumeration.

 clutter/cogl/cogl/cogl-pipeline-private.h | 44 ++++++++++++++++++++++----------------------
 1 file changed, 22 insertions(+), 22 deletions(-)

commit 8e6fac38fa73ec4c8a67835a1128e6b1a9889302
Author: Owen W. Taylor <otaylor@fishsoup.net>
Date:   Sat Nov 13 11:29:49 2010 -0500

    Don't update or use last_paint_box when painting inside a clone
    
    The last_paint_box for an actor represents its "normal" position - we
    shouldn't update it or use it to cull drawing if we are painting
    a clone of the actor. Tracking whether we are painting a clone is
    done by adding  _clutter_actor_push/pop_clone_paint() and a global
    "clone paint level".
    
    http://bugzilla.clutter-project.org/show_bug.cgi?id=2396

 clutter/clutter-actor-private.h |  3 +++
 clutter/clutter-actor.c         | 42 +++++++++++++++++++++++++++++++++++-------
 clutter/clutter-clone.c         |  2 ++
 3 files changed, 40 insertions(+), 7 deletions(-)

commit c68280556ee762c840bb8c73da16d505b6efe1ac
Author: Robert Bragg <robert@linux.intel.com>
Date:   Mon Nov 22 15:51:15 2010 +0000

    clip-stack: combine modelview-projection in set_clip_planes
    
    When using clip planes and we we have to project some vertices into
    screen coordinates we used to transform those by the modelview and then
    the projection matrix separately. Now we combine the modelview and
    projection matrix and then use that to transform the vertices in one
    step instead.

 clutter/cogl/cogl/cogl-clip-stack.c | 24 ++++++++++++------------
 1 file changed, 12 insertions(+), 12 deletions(-)

commit 99f4832c28512e8b670b3681eeb228b4c8c08d14
Author: Robert Bragg <robert@linux.intel.com>
Date:   Mon Nov 22 12:44:36 2010 +0000

    journal: remove possability of fallback layers
    
    When logging quads in the journal it used to be possible to specify a
    mask of fallback layers (layers where a default white texture should be
    used in-place of the corresponding texture in the current source
    pipeline). Since we now handle fallbacks for cogl_rectangle* primitives
    when validating the pipeline up-front before logging in the journal we
    no longer need the ability for the journal to apply fallbacks too.

 clutter/cogl/cogl/cogl-journal-private.h | 1 -
 clutter/cogl/cogl/cogl-journal.c         | 6 ------
 clutter/cogl/cogl/cogl-primitives.c      | 2 --
 3 files changed, 9 deletions(-)

commit 305bb124b71b8fd531009f050cc83d89af1dfb93
Author: Robert Bragg <robert@linux.intel.com>
Date:   Fri Nov 12 16:08:25 2010 +0000

    use cogl_matrix_transform_points in clutter
    
    When transforming a paint-volume or transforming allocation vertices we
    are transforming more than one point at a time so we can batch those
    together with cogl_matrix_transform_points instead of
    cogl_matrix_transform_point. Also in both of these cases we don't need
    to do a projective transform so using cogl_matrix_transform_points also
    lets us reduce the per-vertex computation.

 clutter/clutter-actor.c        | 23 ++++++++---------------
 clutter/clutter-paint-volume.c | 18 +++++++-----------
 2 files changed, 15 insertions(+), 26 deletions(-)

commit 2dba3e8cbf4d130701510768b5c766bb7ef070e8
Author: Robert Bragg <robert@linux.intel.com>
Date:   Fri Nov 12 13:35:24 2010 +0000

    matrix: Adds experimental cogl_matrix_{transform,project}_points
    
    This add two new function that allows us to transform or project an
    array of points instead of only transforming one point at a time. Recent
    benchmarking has shown cogl_matrix_transform_point to be a bottleneck
    sometimes, so this should allow us to reduce the overhead when
    transforming lots of vertices at the same time, and also reduce the cost
    of 3 component, non-projective transforms.
    
    For now they are marked as experimental (you have to define
    COGL_ENABLE_EXPERIMENTAL_API) because there is some concern that it
    introduces some inconsistent naming. cogl_matrix_transform_point would
    have to be renamed cogl_matrix_project_point to be consistent, but that
    would be an API break.

 clutter/cogl/cogl/cogl-matrix.c      | 346 ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
 clutter/cogl/cogl/cogl-matrix.h      | 123 +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
 doc/reference/cogl/cogl-sections.txt |   2 +-
 3 files changed, 470 insertions(+), 1 deletion(-)

commit 4307e65f937538a6251738a8450babce5ed9e8e6
Author: Robert Bragg <robert@linux.intel.com>
Date:   Thu Nov 11 16:28:45 2010 +0000

    primitives: validate with _cogl_pipeline_foreach_layer
    
    Switch _cogl_rectangles_with_multitexture_coords to using
    _cogl_pipeline_foreach_layer to iterate the layers of a pipeline when
    validating instead of iterating the pipelines internal list, which is
    risky since any modifications to pipelines (even to an override pipeline
    derived from the original), could potentially corrupt the list as it is
    being iterated.

 clutter/cogl/cogl/cogl-pipeline-private.h |   3 +-
 clutter/cogl/cogl/cogl-pipeline.c         |   6 ++--
 clutter/cogl/cogl/cogl-primitives.c       | 324 +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++----------------------------------------------------------------------------------------
 3 files changed, 180 insertions(+), 153 deletions(-)

commit fb564cc2ca9579c3b444f5fd5c59ee4da040b7da
Author: Robert Bragg <robert@linux.intel.com>
Date:   Thu Nov 11 15:08:38 2010 +0000

    cogl: remove WrapModeOverrides from FlushOptions
    
    This removes the possibility to specify wrap mode overrides within a
    CoglPipelineFlushOptions struct since the right way to handle these
    overrides is by copying the user's material and making the changes to
    that copy before flushing. All primitives code has already switched away
    from using these wrap mode overrides so this patch just removes unused
    code and types. It also remove the wrap_mode_overrides argument for
    _cogl_journal_log_quad.

 clutter/cogl/cogl/cogl-journal-private.h  |  2 --
 clutter/cogl/cogl/cogl-journal.c          |  7 -------
 clutter/cogl/cogl/cogl-pipeline-private.h | 32 +-------------------------------
 clutter/cogl/cogl/cogl-pipeline.c         | 55 -------------------------------------------------------
 clutter/cogl/cogl/cogl-primitives.c       |  2 --
 5 files changed, 1 insertion(+), 97 deletions(-)

commit b8c9ee7e88ca6d1c2e9bc6380740dbf19096e71e
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Tue Nov 23 10:26:15 2010 +0000

    x11: Ignore NULL settings
    
    Prevent a segfault when dealing with XSETTINGS_ACTION_DELETE.
    
    http://bugzilla.clutter-project.org/show_bug.cgi?id=2441

 clutter/x11/clutter-backend-x11.c | 3 +++
 1 file changed, 3 insertions(+)

commit 1db8b8a70e9c198a04d7c3e3e6365513f5d6858d
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Mon Nov 22 17:01:17 2010 +0000

    color: Do not shadow a variable
    
    Avoid a warning.

 clutter/clutter-color.c | 2 --
 1 file changed, 2 deletions(-)

commit 88049013702032895a9cb7ed60f661d58443130d
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Mon Nov 22 15:20:55 2010 +0000

    Update NEWS

 NEWS | 13 +++++++++++++
 1 file changed, 13 insertions(+)

commit f4531aef4bea347f84b6ace38f6df7b34cdbe13c
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Mon Nov 22 15:07:01 2010 +0000

    color: And finally, add hsla() support
    
    Missed it when reading the CSS spec.

 clutter/clutter-color.c | 35 ++++++++++++++++++++++++++++++++---
 1 file changed, 32 insertions(+), 3 deletions(-)

commit e86db85cd2f0bbdbb65924a8f9ae2575e1212d14
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Mon Nov 22 15:02:47 2010 +0000

    color: Support the CSS hsl() notation
    
    Since we support the rgb() and rgba() notations we might as well also
    support the hsl() one.

 clutter/clutter-color.c    | 70 ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
 tests/conform/test-color.c | 14 ++++++++++++++
 2 files changed, 84 insertions(+)

commit ab6da347f61c0fb2249bbab9d03545121752d633
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Mon Nov 22 14:22:56 2010 +0000

    color: Support CSS color definitions
    
    The CSS Color Module 3, available at:
    
      http://www.w3.org/TR/css3-color/
    
    allows defining colors as:
    
      rgb ( r, g, b )
      rgba ( r, g, b, a)
    
    along with the usual hexadecimal and named notations.
    
    The r, g, and b channels can be:
    
      • integers between 0 and 255
      • percentages, between 0% and 100%
    
    The alpha channel, if included using the rgba() modifier, can be a
    floating point value between 0.0 and 1.0.
    
    The ClutterColor parser should support this notation.

 clutter/clutter-color.c    | 135 +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++------
 tests/conform/test-color.c |  54 +++++++++++++++++++++++++++++++++++++++++++++++++-----
 2 files changed, 178 insertions(+), 11 deletions(-)

commit ee0b8c439e0211e1af8ad55d17d2695e17879f0a
Author: Emmanuele Bassi <ebassi@linux.intel.com>
Date:   Mon Nov 22 10:16:45 2010 +0000

